// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.2.0.dev0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 },
          { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 },
          { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 },
          { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 },
          { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112319, 0.08417937871268441, -0.11664236870396068, 0.0, -0.14682003422210368, 0.07290148043997567, -0.10101525445522089 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366903, -0.134687005940295, 0.0972019739199675, 0.26057971086461384, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536854, 0.34992710611188205, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647902, 0.235702260395516, -0.2721655269759085, -0.12026755886059137, 0.14682003422210368, -0.22453655975512496, 0.17677669529663714 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.21384434262392843, 0.06013377943029567, 0.03952847075210468, 0.11226827987756251, -0.13889597487592922 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.169533172561123, 0.084179378712684, 0.11664236870396065, 0.0, 0.1468200342221035, 0.07290148043997532, 0.10101525445522094 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.016940773179473345, -0.02478650334959185, 0.03788072042070801 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.0782460796435952, -0.16835875742536854, -0.3499271061118823, 0.0, -0.06776309271789388, -0.14580296087995082, -0.303045763365663 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007366, -0.40406101782088444, -0.622092633087791, 0.12026755886059118, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.16414978848973444 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.31104631654389603, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268413, 0.11664236870396126, 0.16035674514745457, 0.06776309271789377, 0.032076651393589534, -0.0757614408414161 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.15552315827194851, 0.0, 0.18070158058105068, 0.0, 0.10101525445522079 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.32071349029490925, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.14580296087995118, -0.20203050891044183 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756484, -0.21886638465297953, 0.194403947839935, 0.16035674514745496, -0.1581138830084195, 0.17787961227354077, -0.12626906806902657 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.6495721976846471, 0.0, -0.31943828249997086, -0.41239304942116023, 0.5714285714285701 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.15971914124998543, -0.4536323543632767, 0.35714285714285665 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.6776309271789404, 1.8079567149113953, 0.0, 0.0, -0.586845597326966, -1.2626906806902622, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894572, 1.1664236870396083, -0.3367175148507357, 1.0415476122441183, 0.6846531968814582, -0.5808377131175202, 0.21870444131992522 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999996, 0.13041013273932592, -0.841793787126841, 0.9331389496316876, 0.0, 0.11293848786315702, -0.7290148043997552, -2.0203050891044203 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153404, 0.33671751485073803, 1.3608276348795443, -0.20044593143431821, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.41239304942116134, -0.14285714285714277 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578778, 0.0, 0.0, 0.0, 1.17369119465393, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, 0.0, -2.083095224488239, 0.5868455973269636, -0.10101525445522297, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536828, 0.0, 0.0, 0.0, 1.4580296087995097, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.7885163201274017, 0.0, -1.1293848786315657, 0.7290148043997554, -0.2525381361380525 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129194, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607831, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041366, 0.0, 0.0, 12.521980673998847, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137755, 0.0, 7.838367176906182, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064566, 5.184592558726249, -1.4966629547095636, 6.831300510639718, -1.0583005244258323, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.190890230020691, 2.529822128134685, 8.082903768654775, 6.26099033699942, -1.807392228230126, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688754, -5.091168824543124, 3.9191835884531017, 0.0, 9.699484522385706, 4.20000000000001, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.9999999999999996) + dof_values[4] * (K[2] * -2.9999999999999996) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.9999999999999987) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000018) + dof_values[1] * (K[2] * -3.0000000000000044) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0000000000000004 + K[2] * -3.0000000000000036) + dof_values[8] * (K[0] * 3.0000000000000004 + K[2] * 3.0000000000000053);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.999999999999996) + dof_values[2] * (K[0] * -2.9999999999999982) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999973 + K[2] * -3.0) + dof_values[5] * (K[0] * 2.9999999999999964 + K[2] * 3.000000000000001);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.9999999999999996) + dof_values[4] * (K[2 + 1] * -2.9999999999999996) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.9999999999999987) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000018) + dof_values[1] * (K[2 + 1] * -3.0000000000000044) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0000000000000004 + K[2 + 1] * -3.0000000000000036) + dof_values[8] * (K[1] * 3.0000000000000004 + K[2 + 1] * 3.0000000000000053);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.999999999999996) + dof_values[2] * (K[1] * -2.9999999999999982) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999973 + K[2 + 1] * -3.0) + dof_values[5] * (K[1] * 2.9999999999999964 + K[2 + 1] * 3.000000000000001);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 2.633333333333353, -2.016666666666675, -0.03333333333332755, -1.591666666666684, -0.06666666666665899, -1.008333333333334, -1.091666666666672, 2.60000000000001, -1.508333333333339, 1.649915822768663, 10.96965511460295, -6.83333333333335, 5.892556509887892, -16.88749537379672, 10.41666666666666 },
            { -2.016666666666675, 2.533333333333342, 0.8166666666666673, -0.06666666666666574, 1.633333333333339, 1.266666666666668, 0.1833333333333383, -1.200000000000006, 1.016666666666666, 3.771236166328253, -8.948929172439186, 11.1666666666667, -11.78511301977582, 7.794228634060021, -20.83333333333339 },
            { -0.03333333333332755, 0.8166666666666673, 0.6333333333333362, -1.008333333333342, 1.266666666666673, 0.4083333333333331, -0.508333333333332, 0.6000000000000023, -0.09166666666667143, 4.006938426723797, -0.5773502691895601, 4.833333333333341, -5.892556509887916, -3.897114317030013, -10.4166666666667 },
            { -1.591666666666684, -0.06666666666666574, -1.008333333333342, 2.633333333333356, -2.016666666666683, -0.0333333333333343, 1.508333333333333, -2.600000000000005, 1.091666666666674, -7.542472332656582, -5.917840259193782, -3.583333333333351, 5.892556509887946, 16.88749537379669, 10.41666666666675 },
            { -0.06666666666665899, 1.633333333333339, 1.266666666666673, -2.016666666666683, 2.533333333333349, 0.8166666666666684, -1.016666666666664, 1.200000000000001, -0.1833333333333387, 8.013876853447597, -1.154700538379158, 9.6666666666667, -11.78511301977585, -7.794228634060006, -20.83333333333344 },
            { -1.008333333333334, 1.266666666666668, 0.4083333333333331, -0.0333333333333343, 0.8166666666666684, 0.6333333333333323, 0.09166666666666823, -0.5999999999999994, 0.5083333333333308, 1.885618083164126, -4.474464586219576, 5.583333333333338, -5.892556509887902, 3.897114317029992, -10.41666666666667 },
            { -1.091666666666672, 0.1833333333333383, -0.508333333333332, 1.508333333333333, -1.016666666666664, 0.09166666666666823, 3.683333333333327, -5.866666666666662, 2.183333333333336, -4.006938426723776, 2.742413778650684, -1.083333333333305, 2.357022603955136, 10.39230484541328, 4.166666666666627 },
            { 2.60000000000001, -1.200000000000006, 0.6000000000000023, -2.600000000000005, 1.200000000000001, -0.5999999999999994, -5.866666666666662, 11.73333333333333, -5.866666666666668, 5.656854249492416, 10.39230484541329, -2.000000000000022, 0.0, -20.78460969082657, 0.0 },
            { -1.508333333333339, 1.016666666666666, -0.09166666666667143, 1.091666666666674, -0.1833333333333387, 0.5083333333333308, 2.183333333333336, -5.866666666666668, 3.683333333333334, -1.649915822768647, -13.13471862406397, 3.083333333333321, -2.357022603955136, 10.39230484541331, -4.166666666666629 },
            { 1.649915822768663, 3.771236166328253, 4.006938426723797, -7.542472332656582, 8.013876853447597, 1.885618083164126, -4.006938426723776, 5.656854249492416, -1.649915822768647, 26.66666666666691, 4.082482904639015, 25.92724864350681, -33.3333333333335, -36.74234614174808, -58.92556509887924 },
            { 10.96965511460295, -8.948929172439186, -0.5773502691895601, -5.917840259193782, -1.154700538379158, -4.474464586219576, 2.742413778650684, 10.39230484541329, -13.13471862406397, 4.082482904639015, 189.9999999999996, -31.75426480542918, 28.57738033247003, -67.50000000000072, 50.51814855409165 },
            { -6.83333333333335, 11.1666666666667, 4.833333333333341, -3.583333333333351, 9.6666666666667, 5.583333333333338, -1.083333333333305, -2.000000000000022, 3.083333333333321, 25.92724864350681, -31.75426480542918, 53.33333333333347, -58.92556509887913, 12.99038105676676, -104.1666666666669 },
            { 5.892556509887892, -11.78511301977582, -5.892556509887916, 5.892556509887946, -11.78511301977585, -5.892556509887902, 2.357022603955136, 0.0, -2.357022603955136, -33.3333333333335, 28.57738033247003, -58.92556509887913, 66.66666666666688, 0.0, 117.8511301977583 },
            { -16.88749537379672, 7.794228634060021, -3.897114317030013, 16.88749537379669, -7.794228634060006, 3.897114317029992, 10.39230484541328, -20.78460969082657, 10.39230484541331, -36.74234614174808, -67.50000000000072, 12.99038105676676, 0.0, 135.0000000000012, 0.0 },
            { 10.41666666666666, -20.83333333333339, -10.4166666666667, 10.41666666666675, -20.83333333333344, -10.41666666666667, 4.166666666666627, 0.0, -4.166666666666629, -58.92556509887924, 50.51814855409165, -104.1666666666669, 117.8511301977583, 0.0, 208.333333333334 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { 0.358333333333344, 1.11666666666666, -0.8916666666666582, -0.650000000000013, -0.5333333333333208, 1.183333333333329, -1.108333333333339, 1.216666666666666, 0.3083333333333505, 0.4714045207910389, 0.7216878364870023, 1.583333333333382, -1.64991582276863, -7.361215932167809, -2.916666666666704 },
            { 0.2833333333333296, -1.733333333333331, 2.783333333333336, -0.9499999999999993, 3.06666666666667, -2.116666666666667, -0.03333333333332997, -0.4333333333333267, -0.3666666666666935, 6.128258770283463, -1.443375672973972, 1.833333333333295, -3.77123616632827, 1.732050807568899, -6.666666666666689 },
            { 0.4416666666666695, -0.7166666666666677, 1.691666666666672, -1.150000000000005, 2.133333333333341, -0.9833333333333357, -0.6916666666666664, 0.3833333333333377, -0.1083333333333441, 5.185449728701386, -0.7216878364869719, 2.416666666666672, -4.006938426723789, -3.031088913245562, -7.083333333333362 },
            { -0.9416666666666772, 0.4666666666666736, -2.191666666666682, 2.275000000000016, -3.133333333333355, 0.8583333333333418, 1.816666666666669, -1.383333333333339, -0.01666666666665895, -8.720983634634154, 0.7216878364869568, -4.916666666666694, 7.54247233265655, 9.526279441628908, 13.33333333333341 },
            { 0.8833333333333384, -1.433333333333336, 3.383333333333346, -2.300000000000011, 4.266666666666685, -1.966666666666673, -1.383333333333334, 0.7666666666666755, -0.2166666666666904, 10.37089945740278, -1.443375672973953, 4.833333333333321, -8.013876853447583, -6.062177826491118, -14.16666666666674 },
            { 0.1416666666666653, -0.866666666666664, 1.391666666666666, -0.475, 1.533333333333334, -1.058333333333332, -0.01666666666666501, -0.2166666666666625, -0.1833333333333454, 3.064129385141726, -0.7216878364869839, 0.9166666666666542, -1.885618083164135, 0.8660254037844397, -3.333333333333344 },
            { -0.7333333333333445, -0.1166666666666614, 0.2666666666666695, 0.7750000000000058, 0.03333333333333416, -0.3083333333333311, 5.508333333333313, -3.433333333333321, -0.2416666666666661, -6.835365551469948, 17.8978583448783, 12.16666666666667, 0.2357022603954948, 7.361215932167793, 0.4166666666666288 },
            { 1.466666666666685, -0.9333333333333411, 0.1333333333333369, -1.13333333333335, 0.2666666666666776, -0.4666666666666706, -7.933333333333306, 5.866666666666645, 2.066666666666679, 1.885618083164128, -30.02221399786043, -2.666666666666642, 1.885618083164127, -10.39230484541339, 3.333333333333328 },
            { -0.7333333333333414, 1.050000000000004, -0.4000000000000095, 0.3583333333333463, -0.3000000000000157, 0.7750000000000037, 2.424999999999994, -2.433333333333325, -1.825000000000014, 4.949747468305818, 12.12435565298213, -9.500000000000039, -2.121320343559614, 3.031088913245604, -3.749999999999945 },
            { 3.064129385141736, -3.771236166328265, 10.13519719700723, -7.778174593052074, 13.19932658214896, -5.421151989096885, -5.185449728701363, 3.299831645537259, -0.4714045207910846, 33.3333333333336, -4.082482904638328, 16.49915822768615, -26.66666666666683, -24.49489742783206, -47.14045207910343 },
            { 0.1443375672973322, -3.175426480542797, 4.474464586219653, -0.866025403784497, 4.618802153517125, -3.752776749732487, 0.721687836486848, -1.443375672974003, -0.7216878364868908, 8.1649658092776, 57.49999999999893, 105.3664241271069, -4.08248290463937, 7.500000000000014, -7.216878364871626 },
            { 2.416666666666663, -8.166666666666663, 14.91666666666669, -7.000000000000011, 17.33333333333336, -10.33333333333335, -2.416666666666642, -0.1666666666666392, -1.583333333333456, 37.7123616632828, -7.216878364869798, 14.16666666666656, -25.92724864350685, -4.330127018922193, -45.83333333333347 },
            { -3.299831645537227, 8.956685895029601, -17.44196726926822, 9.192388155425148, -20.74179891480546, 11.5494107593803, 4.006938426723758, -0.9428090415821062, 1.64991582276875, -46.66666666666704, 8.164965809276653, -18.85618083164118, 33.33333333333351, 12.24744871391599, 58.92556509887923 },
            { -5.196152422706708, -2.598076211353302, -5.196152422706665, 11.69134295109001, -10.39230484541333, -1.299038105676651, 11.69134295108994, -10.39230484541327, -1.299038105676694, -36.74234614174787, 0.0, -25.98076211353331, 36.74234614174782, 67.50000000000068, 64.95190528383316 },
            { -5.833333333333345, 15.83333333333333, -30.8333333333334, 16.25000000000005, -36.66666666666676, 20.41666666666669, 7.083333333333304, -1.666666666666739, 2.916666666666906, -82.49579113843117, 14.43375672973958, -33.33333333333317, 58.92556509887926, 21.65063509461116, 104.1666666666671 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { -0.6083333333333366, -0.6166666666666712, -0.1916666666666714, -2.283333333333348, -0.09999999999999498, -2.116666666666673, -1.108333333333342, 1.216666666666672, 0.3083333333333379, -5.185449728701377, -10.53664241271075, 0.08333333333331172, 16.73486048808172, -7.361215932167784, 10.08333333333337 },
            { 0.2166666666666666, 0.7333333333333403, -0.6166666666666715, 0.3166666666666691, 1.199999999999997, 2.483333333333341, -0.03333333333333588, -0.4333333333333333, -0.3666666666666711, 3.299831645537238, 3.752776749732587, -5.16666666666671, -12.25651754056685, 1.732050807568883, -12.66666666666669 },
            { -0.1916666666666691, 0.2166666666666698, -0.6083333333333393, -1.116666666666673, 0.8999999999999984, 0.7166666666666676, -0.691666666666673, 0.3833333333333367, -0.1083333333333346, -0.4714045207910352, -3.319764047840374, -4.083333333333375, 0.2357022603955543, -3.031088913245558, -4.08333333333332 },
            { 0.6916666666666705, 0.03333333333333133, 1.108333333333346, 3.241666666666683, -1.400000000000002, 0.1583333333333322, 1.816666666666681, -1.383333333333339, -0.01666666666666805, 4.006938426723784, 11.98001808568481, 6.583333333333417, -10.84230397819382, 9.526279441628894, 0.3333333333333033 },
            { -0.383333333333335, 0.4333333333333382, -1.216666666666679, -2.233333333333346, 1.8, 1.433333333333339, -1.383333333333344, 0.7666666666666697, -0.2166666666666674, -0.9428090415820638, -6.639528095680738, -8.166666666666757, 0.4714045207910802, -6.062177826491128, -8.166666666666657 },
            { 0.1083333333333311, 0.3666666666666702, -0.308333333333336, 0.1583333333333333, 0.5999999999999966, 1.241666666666668, -0.01666666666666963, -0.2166666666666637, -0.1833333333333362, 1.64991582276861, 1.876388374866279, -2.58333333333335, -6.128258770283405, 0.8660254037844418, -6.333333333333328 },
            { 2.133333333333351, -0.6833333333333448, 0.4666666666666722, 4.308333333333312, -2.866666666666651, 0.5583333333333294, 1.508333333333341, -2.766666666666685, 1.091666666666679, 5.892556509887912, 10.96965511460293, -1.833333333333347, -11.07800623858927, 7.361215932167624, 8.416666666666643 },
            { -4.933333333333366, 2.533333333333353, -0.9333333333333458, -7.5333333333333, 3.733333333333314, -1.533333333333322, -2.600000000000017, 5.866666666666702, -3.26666666666669, -9.428090415820673, -16.16580753730962, 5.333333333333352, 24.51303508113368, -10.3923048454131, -12.66666666666666 },
            { 2.800000000000016, -1.850000000000009, 0.4666666666666748, 3.224999999999992, -0.8666666666666634, 0.9749999999999913, 1.091666666666678, -3.100000000000021, 2.175000000000012, 3.535533905932763, 5.1961524227067, -3.499999999999999, -13.43502884254442, 3.031088913245477, 4.250000000000022 },
            { -1.649915822768635, 0.9428090415820809, -4.006938426723815, -8.720983634634148, 5.656854249492385, 3.064129385141711, -5.185449728701403, 3.299831645537258, -0.4714045207910387, -6.666666666666734, -28.5773803324707, -25.92724864350703, 13.33333333333366, -24.49489742783202, -18.85618083164119 },
            { 0.7216878364870783, 1.443375672974007, -0.7216878364870645, -11.83568051838745, -5.196152422706541, -8.94892917243919, 0.7216878364869883, -1.443375672974087, -0.7216878364869705, 8.164965809277179, 12.49999999999959, -7.216878364870679, 69.40220937885692, 7.499999999999009, 44.74464586219597 },
            { 0.08333333333332085, 3.166666666666706, -4.083333333333368, -2.666666666666659, 6.999999999999974, 10.6666666666667, -2.416666666666694, -0.166666666666652, -1.583333333333358, 9.42809041582068, 1.443375672974065, -30.83333333333358, -40.06938426723772, -4.330127018922164, -55.83333333333336 },
            { 0.4714045207910414, -3.299831645537257, 5.185449728701397, 5.421151989096894, -8.485281374238557, -11.07800623858928, 4.006938426723813, -0.9428090415820781, 1.649915822768628, -6.666666666666697, 8.16496580927735, 37.71236166328291, 33.33333333333323, 12.24744871391602, 58.92556509887896 },
            { 5.196152422706662, 2.598076211353341, 5.196152422706684, 22.08364779650327, -5.196152422706628, 9.093266739736661, 11.69134295109, -10.39230484541331, -1.29903810567669, 36.7423461417479, 90.00000000000067, 25.98076211353345, -110.2270384252438, 67.50000000000037, -38.97114317030022 },
            { 0.8333333333333612, -5.833333333333397, 9.166666666666751, 9.583333333333371, -14.99999999999997, -19.58333333333339, 7.083333333333415, -1.666666666666706, 2.916666666666702, -11.78511301977581, 14.43375672974085, 66.66666666666728, 58.92556509887876, 21.65063509461114, 104.1666666666666 } } };
    alignas(32) static const double PI3[1][15][15] =
        { { { -0.6083333333333273, -0.616666666666683, -0.1916666666666643, -0.6500000000000161, -0.5333333333333273, 1.183333333333332, -1.108333333333338, 1.216666666666663, 0.3083333333333492, -5.185449728701389, -10.53664241271076, 0.0833333333333357, 4.006938426723812, 3.897114317029939, -1.416666666666677 },
            { 0.2166666666666569, 0.7333333333333556, -0.6166666666666776, -0.9499999999999936, 3.066666666666668, -2.116666666666671, -0.03333333333333693, -0.4333333333333252, -0.3666666666666863, 3.299831645537264, 3.752776749732634, -5.166666666666728, -0.9428090415820629, -3.464101615137753, 0.3333333333333633 },
            { -0.1916666666666706, 0.2166666666666742, -0.6083333333333397, -1.150000000000003, 2.133333333333336, -0.9833333333333369, -0.6916666666666713, 0.3833333333333373, -0.1083333333333392, -0.471404520791022, -3.319764047840344, -4.083333333333375, 1.649915822768635, -0.4330127018922321, -0.5833333333333059 },
            { 0.6916666666666682, 0.03333333333332991, 1.108333333333342, 2.275000000000015, -3.133333333333343, 0.8583333333333423, 1.816666666666675, -1.383333333333336, -0.01666666666666634, 4.006938426723769, 11.98001808568477, 6.583333333333402, -5.185449728701408, -1.732050807568823, 1.833333333333301 },
            { -0.3833333333333405, 0.4333333333333507, -1.216666666666681, -2.300000000000008, 4.266666666666675, -1.966666666666677, -1.383333333333342, 0.7666666666666728, -0.2166666666666796, -0.9428090415820329, -6.639528095680675, -8.166666666666762, 3.299831645537266, -0.8660254037844821, -1.166666666666622 },
            { 0.1083333333333275, 0.3666666666666762, -0.3083333333333382, -0.4749999999999961, 1.533333333333331, -1.058333333333333, -0.01666666666666963, -0.2166666666666607, -0.1833333333333423, 1.649915822768622, 1.876388374866301, -2.583333333333357, -0.4714045207910259, -1.732050807568868, 0.16666666666668 },
            { 1.149999999999997, 0.9500000000000023, 0.65, 2.591666666666662, -3.933333333333315, 1.341666666666664, 2.274999999999998, -2.299999999999992, -0.475000000000005, 9.192388155425107, 19.91858428704207, 2.000000000000007, -7.778174593052075, -6.4951905283832, 2.749999999999952 },
            { -2.13333333333332, -3.066666666666681, 0.533333333333336, -3.933333333333339, 5.866666666666649, -1.933333333333329, -3.133333333333328, 4.266666666666646, 1.533333333333353, -20.74179891480538, -36.95041722813605, 9.333333333333329, 13.19932658214896, 17.3205080756886, -4.666666666666641 },
            { 0.9833333333333241, 2.11666666666668, -1.183333333333336, 1.341666666666679, -1.933333333333338, 0.5916666666666661, 0.8583333333333321, -1.966666666666655, -1.058333333333348, 11.54941075938028, 17.03183294109399, -11.33333333333334, -5.421151989096892, -10.8253175473054, 1.916666666666701 },
            { -1.649915822768637, 0.9428090415820957, -4.006938426723811, -7.778174593052064, 13.19932658214892, -5.421151989096891, -5.18544972870139, 3.299831645537254, -0.4714045207910558, -6.666666666666672, -28.57738033247053, -25.92724864350701, 13.33333333333355, 0.0, -4.714045207910227 },
            { 0.7216878364870569, 1.443375672973973, -0.7216878364870487, -0.8660254037845756, 4.618802153517152, -3.75277674973246, 0.721687836486959, -1.443375672974042, -0.7216878364869506, 8.164965809276961, 12.49999999999925, -7.216878364870524, -4.082482904638957, 52.50000000000033, 105.3664241271054 },
            { 0.08333333333328885, 3.166666666666765, -4.083333333333387, -6.999999999999978, 17.33333333333334, -10.33333333333336, -2.416666666666689, -0.166666666666629, -1.583333333333417, 9.42809041582081, 1.443375672974322, -30.83333333333365, 2.357022603955229, -12.99038105676662, -0.8333333333331372 },
            { 0.4714045207910811, -3.29983164553733, 5.185449728701419, 9.192388155425121, -20.74179891480542, 11.54941075938031, 4.006938426723806, -0.9428090415821074, 1.649915822768701, -6.666666666666856, 8.164965809277039, 37.71236166328296, -6.666666666666801, 12.24744871391599, 2.357022603954936 },
            { 5.196152422706612, 2.598076211353371, 5.196152422706654, 11.69134295109001, -10.39230484541325, -1.299038105676655, 11.69134295108997, -10.39230484541326, -1.299038105676722, 36.74234614174783, 90.00000000000045, 25.98076211353339, -36.74234614174807, -22.49999999999967, 12.99038105676646 },
            { 0.8333333333334234, -5.83333333333352, 9.166666666666787, 16.24999999999999, -36.6666666666667, 20.41666666666672, 7.0833333333334, -1.66666666666675, 2.916666666666823, -11.78511301977609, 14.4337567297403, 66.66666666666738, -11.78511301977604, 21.65063509461113, 4.166666666666318 } } };
    alignas(32) static const double PI4[1][15][15] =
        { { { 0.8583333333333474, -0.8000000000000033, 1.275000000000001, -1.295833333333347, 1.675000000000004, -0.8374999999999992, -0.3624999999999958, 0.3083333333333411, 0.7625000000000097, 1.767766952966342, -1.732050807568888, 3.749999999999968, -2.47487373415292, -6.278684177437303, -4.375000000000006 },
            { -0.8000000000000033, 2.766666666666656, -3.466666666666661, 1.258333333333342, -3.683333333333333, 3.008333333333322, -0.8583333333333482, 0.2166666666666544, -1.275000000000005, 1.178511301977639, 2.02072594216369, -16.66666666666664, 2.592724864350704, -0.4330127018921361, 4.583333333333381 },
            { 1.275000000000001, -3.466666666666661, 6.191666666666674, -3.170833333333341, 7.258333333333346, -4.295833333333333, 1.095833333333339, -0.4416666666666506, 0.6374999999999793, 7.660323462854299, 4.041451884327482, 22.91666666666667, -10.72445284799602, -4.113620667976129, -18.95833333333341 },
            { -1.295833333333347, 1.258333333333342, -3.170833333333341, 2.775000000000013, -4.216666666666677, 1.691666666666673, 0.3208333333333327, -0.2250000000000105, -0.3874999999999938, -8.249579113843078, -2.237232293109855, -7.708333333333321, 8.367430244040822, 10.60881119635948, 14.79166666666668 },
            { 1.675000000000004, -3.683333333333333, 7.258333333333346, -4.216666666666677, 8.766666666666683, -4.716666666666669, 0.9416666666666668, -0.3833333333333122, 0.524999999999973, 11.78511301977586, 5.917840259193786, 24.58333333333334, -14.37783788412652, -8.227241335952229, -25.41666666666674 },
            { -0.8374999999999992, 3.008333333333322, -4.295833333333333, 1.691666666666673, -4.716666666666669, 3.441666666666658, -1.054166666666675, 0.3583333333333191, -1.012499999999993, -1.178511301977565, -0.07216878364873397, -18.95833333333331, 4.831896338108114, -0.2165063509460596, 8.541666666666726 },
            { -0.3624999999999958, -0.8583333333333482, 1.095833333333339, 0.3208333333333327, 0.9416666666666668, -1.054166666666675, 10.04166666666666, -5.083333333333315, 1.625000000000026, -18.97403196183915, 24.75389279150503, 27.95833333333337, -0.2357022603954841, 6.062177826491054, -0.416666666666611 },
            { 0.3083333333333411, 0.2166666666666544, -0.4416666666666506, -0.2250000000000105, -0.3833333333333122, 0.3583333333333191, -5.083333333333315, 3.833333333333318, 0.4166666666666546, 2.592724864350734, -19.19689645055492, -8.416666666666634, 0.471404520791014, -3.46410161513778, 0.8333333333333011 },
            { 0.7625000000000097, -1.275000000000005, 0.6374999999999793, -0.3874999999999938, 0.524999999999973, -1.012499999999993, 1.625000000000026, 0.4166666666666546, 2.708333333333344, -13.08147545195123, -6.278684177437068, 13.37500000000006, 2.121320343559733, -2.598076211353377, 3.750000000000156 },
            { 1.767766952966342, 1.178511301977639, 7.660323462854299, -8.249579113843078, 11.78511301977586, -1.178511301977565, -18.97403196183915, 2.592724864350734, -13.08147545195123, 113.333333333334, 14.28869016623522, -64.81812160876716, -36.66666666666703, -30.61862178478967, -64.81812160876746 },
            { -1.732050807568888, 2.02072594216369, 4.041451884327482, -2.237232293109855, 5.917840259193786, -0.07216878364873397, 24.75389279150503, -19.19689645055492, -6.278684177437068, 14.28869016623522, 132.4999999999987, 57.73502691896253, -22.45365597551285, 3.749999999999947, -39.69283100678742 },
            { 3.749999999999968, -16.66666666666664, 22.91666666666667, -7.708333333333321, 24.58333333333334, -18.95833333333331, 27.95833333333337, -8.416666666666634, 13.37500000000006, -64.81812160876716, 57.73502691896253, 219.1666666666672, -22.39171473757408, 10.82531754730554, -39.58333333333345 },
            { -2.47487373415292, 2.592724864350704, -10.72445284799602, 8.367430244040822, -14.37783788412652, 4.831896338108114, -0.2357022603954841, 0.471404520791014, 2.121320343559733, -36.66666666666703, -22.45365597551285, -22.39171473757408, 33.33333333333341, 24.49489742783174, 58.92556509887907 },
            { -6.278684177437303, -0.4330127018921361, -4.113620667976129, 10.60881119635948, -8.227241335952229, -0.2165063509460596, 6.062177826491054, -3.46410161513778, -2.598076211353377, -30.61862178478967, 3.749999999999947, 10.82531754730554, 24.49489742783174, 67.50000000000085, 43.30127018922186 },
            { -4.375000000000006, 4.583333333333381, -18.95833333333341, 14.79166666666668, -25.41666666666674, 8.541666666666726, -0.416666666666611, 0.8333333333333011, 3.750000000000156, -64.81812160876746, -39.69283100678742, -39.58333333333345, 58.92556509887907, 43.30127018922186, 104.1666666666668 } } };
    alignas(32) static const double PI5[1][15][15] =
        { { { -1.875000000000026, 1.0, -0.7916666666666766, -0.1124999999999992, 0.141666666666664, 0.5125000000000011, -1.479166666666687, 2.375000000000033, -1.187500000000015, -3.889087296526073, -8.660254037844517, -1.250000000000001, 3.181980515339538, 4.979646071760516, -2.874999999999999 },
            { 1.666666666666689, -2.166666666666677, 1.0, -0.1083333333333425, -0.2833333333333242, -2.025000000000002, 0.7083333333333527, -1.583333333333364, 1.958333333333347, -1.649915822768553, -1.443375672973943, 3.333333333333344, 5.421151989096812, -5.629165124598803, 11.58333333333331 },
            { -0.7916666666666751, 1.666666666666677, -1.875000000000014, -1.154166666666675, 1.058333333333327, 2.887500000000006, -1.520833333333349, 0.9583333333333456, -1.14583333333334, 2.00346921336187, -2.886751345948191, -12.08333333333342, -5.067598598503524, -1.51554445662285, -12.45833333333331 },
            { 1.520833333333351, -0.7083333333333455, 1.479166666666679, 1.008333333333344, -0.6833333333333319, -1.075000000000002, 2.270833333333351, -2.291666666666688, 0.7291666666666773, 4.478342947514833, 13.35122497501018, 7.291666666666718, -4.36049181731713, -0.6495190528382935, 3.291666666666662 },
            { -0.9583333333333434, 1.583333333333346, -2.375000000000017, -1.683333333333352, 1.366666666666664, 3.150000000000005, -2.291666666666685, 1.41666666666668, -1.041666666666675, 0.4714045207910214, -7.938566201357421, -15.41666666666678, -3.06412938514161, -3.031088913245641, -12.41666666666665 },
            { 1.145833333333345, -1.95833333333334, 1.187500000000009, 0.2583333333333325, -0.5166666666666611, -2.325000000000003, 0.7291666666666817, -1.041666666666684, 1.604166666666675, -2.592724864350642, -1.8042195912175, 6.041666666666707, 6.246109900481126, -2.81458256229935, 12.04166666666665 },
            { 1.154166666666658, 0.1083333333333344, 0.1125000000000024, 7.504166666666652, -5.258333333333319, 0.9624999999999977, 1.008333333333329, -1.683333333333319, 0.258333333333328, 5.067598598503554, 9.165435523385268, -2.041666666666635, -12.96362432175337, 12.99038105676649, 13.58333333333327 },
            { -1.05833333333333, 0.2833333333333348, -0.1416666666666726, -5.258333333333321, 3.016666666666662, -1.008333333333322, -0.6833333333333345, 1.366666666666661, -0.5166666666666651, -3.064129385141685, -5.340489990004031, 1.583333333333289, 11.78511301977576, -17.32050807568872, -7.16666666666667 },
            { -2.887500000000017, 2.025000000000006, -0.512499999999996, 0.9625000000000143, -1.008333333333357, 0.170833333333314, -1.075000000000002, 3.150000000000021, -2.325000000000013, -3.181980515339501, -4.546633369868335, 3.375000000000091, 3.535533905932844, 4.33012701892233, -2.249999999999895 },
            { 5.067598598503613, -5.421151989096852, -3.181980515339506, -12.96362432175345, 11.78511301977583, 3.535533905932777, -4.360491817317071, -3.064129385141737, 6.246109900481187, -6.666666666666567, -34.70110468942838, -36.5338503613054, 3.333333333333378, -6.123724356958334, -22.39171473757412 },
            { 11.5470053837925, -7.216878364870323, 0.0, 18.25870226312177, -14.86676943163272, 0.2165063509461647, 2.525907427704558, -12.26869322027952, 9.021097956087909, 14.2886901662351, 12.49999999999968, -28.86751345948159, -22.45365597551257, 48.74999999999901, 72.89047148518968 },
            { -4.916666666666666, 10.66666666666667, -5.750000000000012, 4.458333333333293, -11.41666666666669, 4.874999999999972, -2.208333333333345, 3.583333333333345, -8.458333333333339, 20.03469213361881, 23.09401076758497, -30.83333333333341, 5.89255650988817, 2.165063509460765, 5.416666666666876 },
            { -2.003469213361916, 1.649915822768603, 3.889087296526036, 5.067598598503659, -3.064129385141718, -3.181980515339473, 4.478342947514802, 0.4714045207910762, -2.592724864350691, 3.333333333333211, 26.53613888015097, 34.1768277573501, -6.66666666666678, 24.4948974278319, 2.357022603955152 },
            { 11.90784930203619, -2.165063509461176, 5.412658773652812, 2.814582562299447, -1.299038105676648, 0.6495190528383179, 12.9903810567667, -17.32050807568897, 4.330127018922287, 42.86607049870595, 93.75000000000075, 10.82531754730554, -48.98979485566407, -22.50000000000009, -8.660254037844346 },
            { -3.541666666666715, 2.916666666666652, 6.875000000000043, 8.958333333333449, -5.416666666666681, -5.625000000000012, 7.916666666666669, 0.8333333333334045, -4.583333333333359, 5.892556509887697, 46.90970937165689, 60.41666666666717, -11.78511301977601, 43.30127018922211, 4.166666666666627 } } };
    alignas(32) static const double PI6[1][15][15] =
        { { { -0.6083333333333393, -0.6166666666666816, -0.1916666666666622, -0.4666666666666725, 0.933333333333322, -0.4666666666666604, -1.108333333333342, 1.216666666666679, 0.3083333333333427, -5.185449728701425, -10.5366424127108, 0.08333333333338033, 4.006938426723852, 3.897114317029917, -1.416666666666777 },
            { 0.2166666666666764, 0.7333333333333442, -0.6166666666666751, 0.6833333333333322, -2.533333333333307, 1.849999999999977, -0.03333333333332922, -0.4333333333333484, -0.3666666666666696, 3.299831645537291, 3.75277674973266, -5.166666666666755, -0.9428090415821053, -3.464101615137683, 0.3333333333335755 },
            { -0.1916666666666781, 0.2166666666666785, -0.6083333333333395, -2.133333333333336, 4.933333333333326, -2.799999999999998, -0.6916666666666733, 0.3833333333333463, -0.108333333333346, -0.471404520791032, -3.319764047840344, -4.083333333333358, 1.649915822768646, -0.4330127018922634, -0.5833333333334048 },
            { 0.6916666666666733, 0.0333333333333353, 1.108333333333337, 1.508333333333342, -2.599999999999999, 1.091666666666673, 1.816666666666676, -1.383333333333343, -0.01666666666666716, 4.006938426723806, 11.9800180856848, 6.583333333333346, -5.185449728701433, -1.732050807568829, 1.833333333333338 },
            { -0.3833333333333465, 0.4333333333333484, -1.216666666666677, -2.766666666666675, 5.866666666666667, -3.100000000000006, -1.383333333333343, 0.7666666666666815, -0.2166666666666816, -0.9428090415820612, -6.639528095680697, -8.166666666666718, 3.29983164553728, -0.8660254037844848, -1.166666666666691 },
            { 0.1083333333333426, 0.3666666666666663, -0.3083333333333351, 1.091666666666668, -3.266666666666652, 2.174999999999984, -0.01666666666666283, -0.2166666666666791, -0.1833333333333288, 1.64991582276864, 1.876388374866317, -2.583333333333367, -0.4714045207910569, -1.732050807568816, 0.1666666666668424 },
            { 1.11666666666666, -0.3166666666666945, 2.283333333333358, 4.308333333333327, -7.533333333333334, 3.224999999999999, 3.241666666666669, -2.233333333333316, 0.1583333333333451, 5.421151989096741, 19.34123401785233, 14.33333333333354, -8.720983634634075, -8.227241335952138, -8.916666666666877 },
            { -0.8999999999999918, -1.199999999999988, 0.09999999999999132, -2.866666666666673, 3.73333333333334, -0.8666666666666787, -1.399999999999994, 1.799999999999982, 0.5999999999999973, -8.485281374238488, -15.58845726811979, 2.999999999999919, 5.6568542494924, 3.464101615137629, -7.999999999999901 },
            { -0.7166666666666583, -2.483333333333351, 2.116666666666684, 0.5583333333333446, -1.533333333333373, 0.9750000000000071, 0.1583333333333484, 1.43333333333332, 1.241666666666681, -11.07800623858926, -12.41303078757693, 17.66666666666678, 3.064129385141747, 4.763139720814355, -13.08333333333323 },
            { -0.235702260395567, 12.25651754056693, -16.73486048808174, -11.07800623858927, 24.51303508113376, -13.43502884254443, -10.84230397819383, 0.471404520791102, -6.128258770283491, 33.33333333333343, -4.082482904638766, -124.9221980096242, 13.33333333333335, 0.0, 80.13876853447555 },
            { 5.051814855409163, 10.10362971081836, -5.051814855409205, 10.96965511460279, -16.16580753730935, 5.19615242270663, 5.051814855409132, -10.10362971081831, -5.051814855409194, 57.15476066494018, 87.49999999999893, -50.518148554092, -28.57738033247043, -22.4999999999995, 62.06515393788337 },
            { 0.5833333333333566, -7.833333333333404, 11.41666666666674, 2.166666666666636, -2.666666666666726, 0.5, 8.083333333333389, -1.166666666666691, 3.91666666666671, -18.85618083164136, 10.10362971081852, 84.1666666666672, -11.78511301977594, 12.99038105676643, -25.83333333333386 },
            { 0.4714045207910417, -3.299831645537296, 5.185449728701403, 5.892556509887917, -9.428090415820703, 3.535533905932819, 4.006938426723787, -0.9428090415820634, 1.649915822768662, -6.66666666666687, 8.164965809277014, 37.71236166328295, -6.666666666666718, 12.24744871391582, 2.357022603954537 },
            { 5.196152422706656, 2.598076211353407, 5.196152422706618, 3.897114317030026, -3.46410161513773, -0.4330127018921888, 11.69134295108998, -10.39230484541332, -1.299038105676726, 36.74234614174813, 90.0000000000008, 25.98076211353301, -36.7423461417483, -22.49999999999968, 12.99038105676674 },
            { 0.8333333333333528, -5.833333333333458, 9.166666666666757, 10.4166666666667, -16.66666666666677, 6.250000000000133, 7.083333333333363, -1.666666666666669, 2.916666666666754, -11.78511301977612, 14.43375672974024, 66.66666666666734, -11.78511301977589, 21.65063509461082, 4.166666666665584 } } };
    alignas(32) static const double PI7[1][15][15] =
        { { { 6.191666666666713, -3.466666666666697, 1.275000000000014, -1.09583333333334, 0.4416666666666712, -0.6375000000000123, 3.170833333333356, -7.258333333333385, 4.29583333333337, 10.72445284799602, 18.47520861406813, -5.916666666666711, -7.660323462854306, -21.86714144555719, 7.958333333333419 },
            { -3.466666666666697, 2.766666666666691, -0.8000000000000107, 0.8583333333333394, -0.2166666666666678, 1.275000000000014, -1.25833333333335, 3.68333333333337, -3.008333333333361, -2.592724864350709, -3.752776749732635, 2.666666666666683, -1.178511301977582, 13.4233937586589, -10.08333333333342 },
            { 1.275000000000014, -0.8000000000000107, 0.8583333333333439, 0.3625000000000089, -0.3083333333333361, -0.7625000000000073, 1.295833333333346, -1.675000000000016, 0.8375000000000099, 2.474873734152935, 6.928203230275569, 3.250000000000042, -1.767766952966406, -2.3815698604072, 3.37500000000003 },
            { -1.09583333333334, 0.8583333333333394, 0.3625000000000089, 10.04166666666665, -5.08333333333332, 1.624999999999996, 0.3208333333333414, 0.9416666666666734, -1.054166666666677, -0.2357022603955139, 2.670244995002077, 5.458333333333421, -18.97403196183906, 36.58957330989251, 7.458333333333238 },
            { 0.4416666666666712, -0.2166666666666678, -0.3083333333333361, -5.08333333333332, 3.833333333333319, 0.4166666666666659, -0.2250000000000006, -0.3833333333333396, 0.3583333333333373, 0.4714045207910433, -1.010362971081841, -3.416666666666702, 2.592724864350691, -16.88749537379653, -12.4166666666666 },
            { -0.6375000000000123, 1.275000000000014, -0.7625000000000073, 1.624999999999996, 0.4166666666666659, 2.708333333333341, -0.3875000000000084, 0.5250000000000143, -1.012500000000014, 2.12132034355964, 1.948557158514977, -4.125000000000025, -13.08147545195113, 8.443747686898295, -12.12500000000005 },
            { 3.170833333333356, -1.25833333333335, 1.295833333333346, 0.3208333333333414, -0.2250000000000006, -0.3875000000000084, 2.775000000000016, -4.216666666666692, 1.691666666666683, 8.367430244040834, 18.11436469582458, 1.791666666666698, -8.249579113843112, -7.794228634059956, 1.916666666666706 },
            { -7.258333333333385, 3.68333333333337, -1.675000000000016, 0.9416666666666734, -0.3833333333333396, 0.5250000000000143, -4.216666666666692, 8.766666666666726, -4.716666666666709, -14.37783788412652, -26.12509968083068, 5.583333333333377, 11.78511301977585, 24.24871130596442, -7.166666666666767 },
            { 4.29583333333337, -3.008333333333361, 0.8375000000000099, -1.054166666666677, 0.3583333333333373, -1.012500000000014, 1.691666666666683, -4.716666666666709, 3.441666666666699, 4.831896338108113, 7.289047148519093, -4.458333333333374, -1.178511301977577, -16.45448267190446, 9.416666666666758 },
            { 10.72445284799602, -2.592724864350709, 2.474873734152935, -0.2357022603955139, 0.4714045207910433, 2.12132034355964, 8.367430244040834, -14.37783788412652, 4.831896338108113, 33.33333333333338, 63.27848502189889, -8.249579113843108, -36.66666666666682, -30.61862178478978, -8.249579113843023 },
            { 18.47520861406813, -3.752776749732635, 6.928203230275569, 2.670244995002077, -1.010362971081841, 1.948557158514977, 18.11436469582458, -26.12509968083068, 7.289047148519093, 63.27848502189889, 132.5000000000004, 5.773502691896367, -71.44345083117648, -41.24999999999993, -13.71206889325356 },
            { -5.916666666666711, 2.666666666666683, 3.250000000000042, 5.458333333333421, -3.416666666666702, -4.125000000000025, 1.791666666666698, 5.583333333333377, -4.458333333333374, -8.249579113843108, 5.773502691896367, 39.16666666666715, 5.892556509887774, 36.8060796608391, 5.416666666666655 },
            { -7.660323462854306, -1.178511301977582, -1.767766952966406, -18.97403196183906, 2.592724864350691, -13.08147545195113, -8.249579113843112, 11.78511301977585, -1.178511301977577, -36.66666666666682, -71.44345083117648, 5.892556509887774, 113.3333333333337, -48.9897948556637, 44.78342947514811 },
            { -21.86714144555719, 13.4233937586589, -2.3815698604072, 36.58957330989251, -16.88749537379653, 8.443747686898295, -7.794228634059956, 24.24871130596442, -16.45448267190446, -30.61862178478978, -41.24999999999993, 36.8060796608391, -48.9897948556637, 247.4999999999999, -8.660254037844924 },
            { 7.958333333333419, -10.08333333333342, 3.37500000000003, 7.458333333333238, -12.4166666666666, -12.12500000000005, 1.916666666666706, -7.166666666666767, 9.416666666666758, -8.249579113843023, -13.71206889325356, 5.416666666666655, 44.78342947514811, -8.660254037844924, 104.1666666666668 } } };
    alignas(32) static const double PI8[1][15][15] =
        { { { 1.691666666666661, 2.783333333333359, -0.8916666666666762, -0.2666666666666527, -0.1333333333333361, 0.400000000000012, 2.191666666666668, -3.383333333333328, -1.391666666666689, 17.44196726926823, 29.30052616137362, -10.91666666666673, -10.1351971970073, -15.15544456622755, 3.583333333333335 },
            { -0.716666666666667, -1.733333333333344, 1.116666666666669, 0.116666666666658, 0.9333333333333433, -1.050000000000008, -0.4666666666666702, 1.433333333333335, 0.8666666666666749, -8.956685895029636, -12.41303078757702, 10.16666666666669, 3.771236166328308, 8.660254037844336, -1.333333333333356 },
            { 0.4416666666666703, 0.2833333333333333, 0.3583333333333381, 0.7333333333333435, -1.466666666666678, 0.7333333333333441, 0.9416666666666742, -0.883333333333339, -0.1416666666666668, 3.299831645537239, 7.649891066762588, 1.583333333333362, -3.064129385141759, -2.165063509461067, 1.083333333333323 },
            { 0.6916666666666647, 0.03333333333331631, 1.108333333333349, 5.508333333333335, -7.933333333333323, 2.424999999999992, 1.81666666666667, -1.383333333333326, -0.01666666666665902, 4.006938426723702, 11.98001808568467, 6.583333333333456, -5.18544972870135, -1.732050807568815, 1.833333333333295 },
            { -0.3833333333333369, 0.4333333333333542, -1.216666666666678, -3.433333333333323, 5.866666666666649, -2.433333333333326, -1.383333333333333, 0.7666666666666646, -0.2166666666666812, -0.9428090415819987, -6.639528095680602, -8.166666666666742, 3.299831645537226, -0.8660254037844812, -1.166666666666608 },
            { 0.1083333333333222, 0.3666666666666799, -0.3083333333333405, -0.2416666666666649, 2.066666666666674, -1.825000000000008, -0.01666666666667316, -0.216666666666654, -0.1833333333333471, 1.649915822768615, 1.876388374866289, -2.583333333333362, -0.4714045207910057, -1.732050807568864, 0.1666666666666861 },
            { 1.149999999999999, 0.9500000000000086, 0.6500000000000011, 0.7750000000000142, -1.133333333333342, 0.3583333333333495, 2.275000000000005, -2.299999999999999, -0.4750000000000087, 9.192388155425146, 19.91858428704214, 2.000000000000013, -7.778174593052118, -6.495190528383198, 2.749999999999963 },
            { -2.133333333333326, -3.066666666666698, 0.5333333333333448, 0.03333333333331689, 0.266666666666669, -0.3000000000000175, -3.133333333333333, 4.266666666666659, 1.533333333333361, -20.74179891480546, -36.95041722813617, 9.333333333333407, 13.19932658214903, 17.32050807568861, -4.666666666666642 },
            { 0.9833333333333314, 2.116666666666683, -1.183333333333341, -0.3083333333333262, -0.4666666666666712, 0.7750000000000079, 0.8583333333333336, -1.966666666666665, -1.058333333333347, 11.54941075938032, 17.03183294109403, -11.33333333333339, -5.421151989096929, -10.82531754730542, 1.916666666666683 },
            { 4.006938426723746, 3.771236166328306, 1.649915822768588, 0.2357022603955432, 1.885618083164142, -2.121320343559614, 7.542472332656496, -8.01387685344751, -1.885618083164179, 33.33333333333343, 69.40220937885684, 2.357022603955041, -26.66666666666693, -24.49489742783145, 9.428090415820513 },
            { 7.649891066762519, 4.907477288111891, 6.206515393788465, 4.041451884327459, -2.309401076758516, -1.732050807568793, 16.31014510460694, -15.29978213352506, -2.453738644055984, 57.154760664941, 132.5000000000003, 27.42413778650722, -53.07227776030279, -37.4999999999994, 18.76388374866251 },
            { -0.9166666666666341, -4.833333333333415, 4.916666666666736, 6.166666666666712, -10.66666666666675, 4.500000000000052, 1.583333333333379, 1.833333333333296, 2.416666666666732, -18.8561808316414, -15.87713240271478, 39.16666666666713, 2.357022603955107, 21.65063509461096, -0.8333333333334387 },
            { -5.185449728701299, -6.128258770283511, -0.4714045207910167, -6.835365551470055, 1.885618083164159, 4.949747468305814, -8.7209836346341, 10.37089945740265, 3.064129385141809, -46.66666666666684, -89.8146239020503, 9.428090415820634, 33.33333333333361, 36.74234614174728, -11.78511301977587 },
            { -1.732050807568875, -0.8660254037845836, -1.732050807568797, 19.48557158514986, -17.32050807568877, -2.165063509461029, -3.897114317029984, 3.464101615137791, 0.4330127018923157, -12.24744871391641, -30.0000000000007, -8.660254037843803, 12.24744871391591, 67.5000000000002, 99.59292143520955 },
            { 1.833333333333372, 2.166666666666589, 0.1666666666667003, 9.416666666666613, -24.66666666666661, 15.24999999999999, 3.083333333333338, -3.666666666666689, -1.083333333333268, 16.49915822768593, 31.75426480542914, -3.333333333333183, -11.7851130197759, -12.99038105676642, 4.16666666666652 } } };
    alignas(32) static const double PI9[1][15][15] =
        { { { 0.6333333333333256, 0.81666666666666, -0.03333333333332728, 0.5083333333333417, -0.6000000000000111, 0.09166666666668005, 1.008333333333329, -1.266666666666652, -0.4083333333333333, 5.89255650988784, 10.96965511460282, -1.83333333333327, -4.006938426723784, -3.897114317029867, 2.916666666666616 },
            { 0.81666666666666, 2.533333333333355, -2.016666666666684, -0.1833333333333403, 1.200000000000034, -1.016666666666673, 0.06666666666665591, -1.633333333333324, -1.266666666666684, 11.78511301977583, 14.14508159514586, -17.16666666666679, -3.771236166328314, -5.196152422706562, 13.33333333333327 },
            { -0.03333333333332728, -2.016666666666684, 2.633333333333353, 1.091666666666673, -2.600000000000024, 1.508333333333341, 1.591666666666682, 0.06666666666665799, 1.008333333333345, -5.892556509887919, -0.5773502691896111, 19.83333333333348, -1.649915822768608, 0.4330127018921672, -12.9166666666667 },
            { 0.5083333333333417, -0.1833333333333403, 1.091666666666673, 3.683333333333334, -5.866666666666657, 2.18333333333333, 1.508333333333341, -1.016666666666676, 0.09166666666667288, 2.357022603955166, 8.80459160514182, 6.916666666666698, -4.006938426723821, 0.4330127018922301, 2.916666666666642 },
            { -0.6000000000000111, 1.200000000000034, -2.600000000000024, -5.866666666666657, 11.73333333333332, -5.866666666666654, -2.60000000000001, 1.200000000000007, -0.6000000000000252, 0.0, -10.39230484541317, -18.00000000000016, 5.656854249492376, 3.464101615137755, 10.00000000000004 },
            { 0.09166666666668005, -1.016666666666673, 1.508333333333341, 2.18333333333333, -5.866666666666654, 3.683333333333307, 1.09166666666668, -0.1833333333333524, 0.508333333333342, -2.357022603955126, 1.587713240271539, 11.08333333333336, -1.649915822768616, -3.897114317029975, -12.91666666666646 },
            { 1.008333333333329, 0.06666666666665591, 1.591666666666682, 1.508333333333341, -2.60000000000001, 1.09166666666668, 2.633333333333339, -2.016666666666658, -0.03333333333333113, 5.892556509887847, 17.46484564298614, 9.416666666666796, -7.542472332656553, -6.062177826491001, -3.333333333333457 },
            { -1.266666666666652, -1.633333333333324, 0.06666666666665799, -1.016666666666676, 1.200000000000007, -0.1833333333333524, -2.016666666666658, 2.533333333333307, 0.8166666666666688, -11.7851130197757, -21.93931022920566, 3.666666666666568, 8.013876853447574, 7.794228634059769, -5.833333333333203 },
            { -0.4083333333333333, -1.266666666666684, 1.008333333333345, 0.09166666666667288, -0.6000000000000252, 0.508333333333342, -0.03333333333333113, 0.8166666666666688, 0.6333333333333453, -5.892556509887952, -7.072540797572987, 8.583333333333428, 1.885618083164176, 2.598076211353318, -6.666666666666641 },
            { 5.89255650988784, 11.78511301977583, -5.892556509887919, 2.357022603955166, 0.0, -2.357022603955126, 5.892556509887847, -11.7851130197757, -5.892556509887952, 66.66666666666652, 102.0620726159655, -58.92556509887902, -33.33333333333363, -36.74234614174699, 54.21151989096813 },
            { 10.96965511460282, 14.14508159514586, -0.5773502691896111, 8.80459160514182, -10.39230484541317, 1.587713240271539, 17.46484564298614, -21.93931022920566, -7.072540797572987, 102.0620726159655, 189.9999999999998, -31.75426480542914, -69.40220937885726, -67.49999999999902, 50.5181485540912 },
            { -1.83333333333327, -17.16666666666679, 19.83333333333348, 6.916666666666698, -18.00000000000016, 11.08333333333336, 9.416666666666796, 3.666666666666568, 8.583333333333428, -58.92556509887902, -31.75426480542914, 153.3333333333343, -2.357022603955098, 12.99038105676593, -104.1666666666668 },
            { -4.006938426723784, -3.771236166328314, -1.649915822768608, -4.006938426723821, 5.656854249492376, -1.649915822768616, -7.542472332656553, 8.013876853447574, 1.885618083164176, -33.33333333333363, -69.40220937885726, -2.357022603955098, 26.66666666666709, 24.49489742783141, -9.428090415820977 },
            { -3.897114317029867, -5.196152422706562, 0.4330127018921672, 0.4330127018922301, 3.464101615137755, -3.897114317029975, -6.062177826491001, 7.794228634059769, 2.598076211353318, -36.74234614174699, -67.49999999999902, 12.99038105676593, 24.49489742783141, 59.99999999999963, 43.30127018922268 },
            { 2.916666666666616, 13.33333333333327, -12.9166666666667, 2.916666666666642, 10.00000000000004, -12.91666666666646, -3.333333333333457, -5.833333333333203, -6.666666666666641, 54.21151989096813, 50.5181485540912, -104.1666666666668, -9.428090415820977, 43.30127018922268, 183.3333333333315 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = sp[33] * PI0[0][0][0] + sp[34] * PI1[0][0][0] + sp[28] * PI2[0][0][0] + sp[31] * PI3[0][0][0] + sp[34] * PI1[0][0][0] + sp[35] * PI4[0][0][0] + sp[29] * PI5[0][0][0] + sp[32] * PI6[0][0][0] + sp[28] * PI2[0][0][0] + sp[29] * PI5[0][0][0] + sp[26] * PI7[0][0][0] + sp[27] * PI8[0][0][0] + sp[31] * PI3[0][0][0] + sp[32] * PI6[0][0][0] + sp[27] * PI8[0][0][0] + sp[30] * PI9[0][0][0];
    A[1] = sp[33] * PI0[0][0][1] + sp[34] * PI1[0][0][1] + sp[28] * PI2[0][0][1] + sp[31] * PI3[0][0][1] + sp[34] * PI1[0][1][0] + sp[35] * PI4[0][0][1] + sp[29] * PI5[0][0][1] + sp[32] * PI6[0][0][1] + sp[28] * PI2[0][1][0] + sp[29] * PI5[0][1][0] + sp[26] * PI7[0][0][1] + sp[27] * PI8[0][0][1] + sp[31] * PI3[0][1][0] + sp[32] * PI6[0][1][0] + sp[27] * PI8[0][1][0] + sp[30] * PI9[0][0][1];
    A[2] = sp[33] * PI0[0][0][2] + sp[34] * PI1[0][0][2] + sp[28] * PI2[0][0][2] + sp[31] * PI3[0][0][2] + sp[34] * PI1[0][2][0] + sp[35] * PI4[0][0][2] + sp[29] * PI5[0][0][2] + sp[32] * PI6[0][0][2] + sp[28] * PI2[0][2][0] + sp[29] * PI5[0][2][0] + sp[26] * PI7[0][0][2] + sp[27] * PI8[0][0][2] + sp[31] * PI3[0][2][0] + sp[32] * PI6[0][2][0] + sp[27] * PI8[0][2][0] + sp[30] * PI9[0][0][2];
    A[3] = sp[33] * PI0[0][0][3] + sp[34] * PI1[0][0][3] + sp[28] * PI2[0][0][3] + sp[31] * PI3[0][0][3] + sp[34] * PI1[0][3][0] + sp[35] * PI4[0][0][3] + sp[29] * PI5[0][0][3] + sp[32] * PI6[0][0][3] + sp[28] * PI2[0][3][0] + sp[29] * PI5[0][3][0] + sp[26] * PI7[0][0][3] + sp[27] * PI8[0][0][3] + sp[31] * PI3[0][3][0] + sp[32] * PI6[0][3][0] + sp[27] * PI8[0][3][0] + sp[30] * PI9[0][0][3];
    A[4] = sp[33] * PI0[0][0][4] + sp[34] * PI1[0][0][4] + sp[28] * PI2[0][0][4] + sp[31] * PI3[0][0][4] + sp[34] * PI1[0][4][0] + sp[35] * PI4[0][0][4] + sp[29] * PI5[0][0][4] + sp[32] * PI6[0][0][4] + sp[28] * PI2[0][4][0] + sp[29] * PI5[0][4][0] + sp[26] * PI7[0][0][4] + sp[27] * PI8[0][0][4] + sp[31] * PI3[0][4][0] + sp[32] * PI6[0][4][0] + sp[27] * PI8[0][4][0] + sp[30] * PI9[0][0][4];
    A[5] = sp[33] * PI0[0][0][5] + sp[34] * PI1[0][0][5] + sp[28] * PI2[0][0][5] + sp[31] * PI3[0][0][5] + sp[34] * PI1[0][5][0] + sp[35] * PI4[0][0][5] + sp[29] * PI5[0][0][5] + sp[32] * PI6[0][0][5] + sp[28] * PI2[0][5][0] + sp[29] * PI5[0][5][0] + sp[26] * PI7[0][0][5] + sp[27] * PI8[0][0][5] + sp[31] * PI3[0][5][0] + sp[32] * PI6[0][5][0] + sp[27] * PI8[0][5][0] + sp[30] * PI9[0][0][5];
    A[6] = sp[33] * PI0[0][0][6] + sp[34] * PI1[0][0][6] + sp[28] * PI2[0][0][6] + sp[31] * PI3[0][0][6] + sp[34] * PI1[0][6][0] + sp[35] * PI4[0][0][6] + sp[29] * PI5[0][0][6] + sp[32] * PI6[0][0][6] + sp[28] * PI2[0][6][0] + sp[29] * PI5[0][6][0] + sp[26] * PI7[0][0][6] + sp[27] * PI8[0][0][6] + sp[31] * PI3[0][6][0] + sp[32] * PI6[0][6][0] + sp[27] * PI8[0][6][0] + sp[30] * PI9[0][0][6];
    A[7] = sp[33] * PI0[0][0][7] + sp[34] * PI1[0][0][7] + sp[28] * PI2[0][0][7] + sp[31] * PI3[0][0][7] + sp[34] * PI1[0][7][0] + sp[35] * PI4[0][0][7] + sp[29] * PI5[0][0][7] + sp[32] * PI6[0][0][7] + sp[28] * PI2[0][7][0] + sp[29] * PI5[0][7][0] + sp[26] * PI7[0][0][7] + sp[27] * PI8[0][0][7] + sp[31] * PI3[0][7][0] + sp[32] * PI6[0][7][0] + sp[27] * PI8[0][7][0] + sp[30] * PI9[0][0][7];
    A[8] = sp[33] * PI0[0][0][8] + sp[34] * PI1[0][0][8] + sp[28] * PI2[0][0][8] + sp[31] * PI3[0][0][8] + sp[34] * PI1[0][8][0] + sp[35] * PI4[0][0][8] + sp[29] * PI5[0][0][8] + sp[32] * PI6[0][0][8] + sp[28] * PI2[0][8][0] + sp[29] * PI5[0][8][0] + sp[26] * PI7[0][0][8] + sp[27] * PI8[0][0][8] + sp[31] * PI3[0][8][0] + sp[32] * PI6[0][8][0] + sp[27] * PI8[0][8][0] + sp[30] * PI9[0][0][8];
    A[9] = sp[33] * PI0[0][0][9] + sp[34] * PI1[0][0][9] + sp[28] * PI2[0][0][9] + sp[31] * PI3[0][0][9] + sp[34] * PI1[0][9][0] + sp[35] * PI4[0][0][9] + sp[29] * PI5[0][0][9] + sp[32] * PI6[0][0][9] + sp[28] * PI2[0][9][0] + sp[29] * PI5[0][9][0] + sp[26] * PI7[0][0][9] + sp[27] * PI8[0][0][9] + sp[31] * PI3[0][9][0] + sp[32] * PI6[0][9][0] + sp[27] * PI8[0][9][0] + sp[30] * PI9[0][0][9];
    A[10] = sp[33] * PI0[0][0][10] + sp[34] * PI1[0][0][10] + sp[28] * PI2[0][0][10] + sp[31] * PI3[0][0][10] + sp[34] * PI1[0][10][0] + sp[35] * PI4[0][0][10] + sp[29] * PI5[0][0][10] + sp[32] * PI6[0][0][10] + sp[28] * PI2[0][10][0] + sp[29] * PI5[0][10][0] + sp[26] * PI7[0][0][10] + sp[27] * PI8[0][0][10] + sp[31] * PI3[0][10][0] + sp[32] * PI6[0][10][0] + sp[27] * PI8[0][10][0] + sp[30] * PI9[0][0][10];
    A[11] = sp[33] * PI0[0][0][11] + sp[34] * PI1[0][0][11] + sp[28] * PI2[0][0][11] + sp[31] * PI3[0][0][11] + sp[34] * PI1[0][11][0] + sp[35] * PI4[0][0][11] + sp[29] * PI5[0][0][11] + sp[32] * PI6[0][0][11] + sp[28] * PI2[0][11][0] + sp[29] * PI5[0][11][0] + sp[26] * PI7[0][0][11] + sp[27] * PI8[0][0][11] + sp[31] * PI3[0][11][0] + sp[32] * PI6[0][11][0] + sp[27] * PI8[0][11][0] + sp[30] * PI9[0][0][11];
    A[12] = sp[33] * PI0[0][0][12] + sp[34] * PI1[0][0][12] + sp[28] * PI2[0][0][12] + sp[31] * PI3[0][0][12] + sp[34] * PI1[0][12][0] + sp[35] * PI4[0][0][12] + sp[29] * PI5[0][0][12] + sp[32] * PI6[0][0][12] + sp[28] * PI2[0][12][0] + sp[29] * PI5[0][12][0] + sp[26] * PI7[0][0][12] + sp[27] * PI8[0][0][12] + sp[31] * PI3[0][12][0] + sp[32] * PI6[0][12][0] + sp[27] * PI8[0][12][0] + sp[30] * PI9[0][0][12];
    A[13] = sp[33] * PI0[0][0][13] + sp[34] * PI1[0][0][13] + sp[28] * PI2[0][0][13] + sp[31] * PI3[0][0][13] + sp[34] * PI1[0][13][0] + sp[35] * PI4[0][0][13] + sp[29] * PI5[0][0][13] + sp[32] * PI6[0][0][13] + sp[28] * PI2[0][13][0] + sp[29] * PI5[0][13][0] + sp[26] * PI7[0][0][13] + sp[27] * PI8[0][0][13] + sp[31] * PI3[0][13][0] + sp[32] * PI6[0][13][0] + sp[27] * PI8[0][13][0] + sp[30] * PI9[0][0][13];
    A[14] = sp[33] * PI0[0][0][14] + sp[34] * PI1[0][0][14] + sp[28] * PI2[0][0][14] + sp[31] * PI3[0][0][14] + sp[34] * PI1[0][14][0] + sp[35] * PI4[0][0][14] + sp[29] * PI5[0][0][14] + sp[32] * PI6[0][0][14] + sp[28] * PI2[0][14][0] + sp[29] * PI5[0][14][0] + sp[26] * PI7[0][0][14] + sp[27] * PI8[0][0][14] + sp[31] * PI3[0][14][0] + sp[32] * PI6[0][14][0] + sp[27] * PI8[0][14][0] + sp[30] * PI9[0][0][14];
    A[15] = sp[33] * PI0[0][1][0] + sp[34] * PI1[0][1][0] + sp[28] * PI2[0][1][0] + sp[31] * PI3[0][1][0] + sp[34] * PI1[0][0][1] + sp[35] * PI4[0][1][0] + sp[29] * PI5[0][1][0] + sp[32] * PI6[0][1][0] + sp[28] * PI2[0][0][1] + sp[29] * PI5[0][0][1] + sp[26] * PI7[0][1][0] + sp[27] * PI8[0][1][0] + sp[31] * PI3[0][0][1] + sp[32] * PI6[0][0][1] + sp[27] * PI8[0][0][1] + sp[30] * PI9[0][1][0];
    A[16] = sp[33] * PI0[0][1][1] + sp[34] * PI1[0][1][1] + sp[28] * PI2[0][1][1] + sp[31] * PI3[0][1][1] + sp[34] * PI1[0][1][1] + sp[35] * PI4[0][1][1] + sp[29] * PI5[0][1][1] + sp[32] * PI6[0][1][1] + sp[28] * PI2[0][1][1] + sp[29] * PI5[0][1][1] + sp[26] * PI7[0][1][1] + sp[27] * PI8[0][1][1] + sp[31] * PI3[0][1][1] + sp[32] * PI6[0][1][1] + sp[27] * PI8[0][1][1] + sp[30] * PI9[0][1][1];
    A[17] = sp[33] * PI0[0][1][2] + sp[34] * PI1[0][1][2] + sp[28] * PI2[0][1][2] + sp[31] * PI3[0][1][2] + sp[34] * PI1[0][2][1] + sp[35] * PI4[0][1][2] + sp[29] * PI5[0][1][2] + sp[32] * PI6[0][1][2] + sp[28] * PI2[0][2][1] + sp[29] * PI5[0][2][1] + sp[26] * PI7[0][1][2] + sp[27] * PI8[0][1][2] + sp[31] * PI3[0][2][1] + sp[32] * PI6[0][2][1] + sp[27] * PI8[0][2][1] + sp[30] * PI9[0][1][2];
    A[18] = sp[33] * PI0[0][1][3] + sp[34] * PI1[0][1][3] + sp[28] * PI2[0][1][3] + sp[31] * PI3[0][1][3] + sp[34] * PI1[0][3][1] + sp[35] * PI4[0][1][3] + sp[29] * PI5[0][1][3] + sp[32] * PI6[0][1][3] + sp[28] * PI2[0][3][1] + sp[29] * PI5[0][3][1] + sp[26] * PI7[0][1][3] + sp[27] * PI8[0][1][3] + sp[31] * PI3[0][3][1] + sp[32] * PI6[0][3][1] + sp[27] * PI8[0][3][1] + sp[30] * PI9[0][1][3];
    A[19] = sp[33] * PI0[0][1][4] + sp[34] * PI1[0][1][4] + sp[28] * PI2[0][1][4] + sp[31] * PI3[0][1][4] + sp[34] * PI1[0][4][1] + sp[35] * PI4[0][1][4] + sp[29] * PI5[0][1][4] + sp[32] * PI6[0][1][4] + sp[28] * PI2[0][4][1] + sp[29] * PI5[0][4][1] + sp[26] * PI7[0][1][4] + sp[27] * PI8[0][1][4] + sp[31] * PI3[0][4][1] + sp[32] * PI6[0][4][1] + sp[27] * PI8[0][4][1] + sp[30] * PI9[0][1][4];
    A[20] = sp[33] * PI0[0][1][5] + sp[34] * PI1[0][1][5] + sp[28] * PI2[0][1][5] + sp[31] * PI3[0][1][5] + sp[34] * PI1[0][5][1] + sp[35] * PI4[0][1][5] + sp[29] * PI5[0][1][5] + sp[32] * PI6[0][1][5] + sp[28] * PI2[0][5][1] + sp[29] * PI5[0][5][1] + sp[26] * PI7[0][1][5] + sp[27] * PI8[0][1][5] + sp[31] * PI3[0][5][1] + sp[32] * PI6[0][5][1] + sp[27] * PI8[0][5][1] + sp[30] * PI9[0][1][5];
    A[21] = sp[33] * PI0[0][1][6] + sp[34] * PI1[0][1][6] + sp[28] * PI2[0][1][6] + sp[31] * PI3[0][1][6] + sp[34] * PI1[0][6][1] + sp[35] * PI4[0][1][6] + sp[29] * PI5[0][1][6] + sp[32] * PI6[0][1][6] + sp[28] * PI2[0][6][1] + sp[29] * PI5[0][6][1] + sp[26] * PI7[0][1][6] + sp[27] * PI8[0][1][6] + sp[31] * PI3[0][6][1] + sp[32] * PI6[0][6][1] + sp[27] * PI8[0][6][1] + sp[30] * PI9[0][1][6];
    A[22] = sp[33] * PI0[0][1][7] + sp[34] * PI1[0][1][7] + sp[28] * PI2[0][1][7] + sp[31] * PI3[0][1][7] + sp[34] * PI1[0][7][1] + sp[35] * PI4[0][1][7] + sp[29] * PI5[0][1][7] + sp[32] * PI6[0][1][7] + sp[28] * PI2[0][7][1] + sp[29] * PI5[0][7][1] + sp[26] * PI7[0][1][7] + sp[27] * PI8[0][1][7] + sp[31] * PI3[0][7][1] + sp[32] * PI6[0][7][1] + sp[27] * PI8[0][7][1] + sp[30] * PI9[0][1][7];
    A[23] = sp[33] * PI0[0][1][8] + sp[34] * PI1[0][1][8] + sp[28] * PI2[0][1][8] + sp[31] * PI3[0][1][8] + sp[34] * PI1[0][8][1] + sp[35] * PI4[0][1][8] + sp[29] * PI5[0][1][8] + sp[32] * PI6[0][1][8] + sp[28] * PI2[0][8][1] + sp[29] * PI5[0][8][1] + sp[26] * PI7[0][1][8] + sp[27] * PI8[0][1][8] + sp[31] * PI3[0][8][1] + sp[32] * PI6[0][8][1] + sp[27] * PI8[0][8][1] + sp[30] * PI9[0][1][8];
    A[24] = sp[33] * PI0[0][1][9] + sp[34] * PI1[0][1][9] + sp[28] * PI2[0][1][9] + sp[31] * PI3[0][1][9] + sp[34] * PI1[0][9][1] + sp[35] * PI4[0][1][9] + sp[29] * PI5[0][1][9] + sp[32] * PI6[0][1][9] + sp[28] * PI2[0][9][1] + sp[29] * PI5[0][9][1] + sp[26] * PI7[0][1][9] + sp[27] * PI8[0][1][9] + sp[31] * PI3[0][9][1] + sp[32] * PI6[0][9][1] + sp[27] * PI8[0][9][1] + sp[30] * PI9[0][1][9];
    A[25] = sp[33] * PI0[0][1][10] + sp[34] * PI1[0][1][10] + sp[28] * PI2[0][1][10] + sp[31] * PI3[0][1][10] + sp[34] * PI1[0][10][1] + sp[35] * PI4[0][1][10] + sp[29] * PI5[0][1][10] + sp[32] * PI6[0][1][10] + sp[28] * PI2[0][10][1] + sp[29] * PI5[0][10][1] + sp[26] * PI7[0][1][10] + sp[27] * PI8[0][1][10] + sp[31] * PI3[0][10][1] + sp[32] * PI6[0][10][1] + sp[27] * PI8[0][10][1] + sp[30] * PI9[0][1][10];
    A[26] = sp[33] * PI0[0][1][11] + sp[34] * PI1[0][1][11] + sp[28] * PI2[0][1][11] + sp[31] * PI3[0][1][11] + sp[34] * PI1[0][11][1] + sp[35] * PI4[0][1][11] + sp[29] * PI5[0][1][11] + sp[32] * PI6[0][1][11] + sp[28] * PI2[0][11][1] + sp[29] * PI5[0][11][1] + sp[26] * PI7[0][1][11] + sp[27] * PI8[0][1][11] + sp[31] * PI3[0][11][1] + sp[32] * PI6[0][11][1] + sp[27] * PI8[0][11][1] + sp[30] * PI9[0][1][11];
    A[27] = sp[33] * PI0[0][1][12] + sp[34] * PI1[0][1][12] + sp[28] * PI2[0][1][12] + sp[31] * PI3[0][1][12] + sp[34] * PI1[0][12][1] + sp[35] * PI4[0][1][12] + sp[29] * PI5[0][1][12] + sp[32] * PI6[0][1][12] + sp[28] * PI2[0][12][1] + sp[29] * PI5[0][12][1] + sp[26] * PI7[0][1][12] + sp[27] * PI8[0][1][12] + sp[31] * PI3[0][12][1] + sp[32] * PI6[0][12][1] + sp[27] * PI8[0][12][1] + sp[30] * PI9[0][1][12];
    A[28] = sp[33] * PI0[0][1][13] + sp[34] * PI1[0][1][13] + sp[28] * PI2[0][1][13] + sp[31] * PI3[0][1][13] + sp[34] * PI1[0][13][1] + sp[35] * PI4[0][1][13] + sp[29] * PI5[0][1][13] + sp[32] * PI6[0][1][13] + sp[28] * PI2[0][13][1] + sp[29] * PI5[0][13][1] + sp[26] * PI7[0][1][13] + sp[27] * PI8[0][1][13] + sp[31] * PI3[0][13][1] + sp[32] * PI6[0][13][1] + sp[27] * PI8[0][13][1] + sp[30] * PI9[0][1][13];
    A[29] = sp[33] * PI0[0][1][14] + sp[34] * PI1[0][1][14] + sp[28] * PI2[0][1][14] + sp[31] * PI3[0][1][14] + sp[34] * PI1[0][14][1] + sp[35] * PI4[0][1][14] + sp[29] * PI5[0][1][14] + sp[32] * PI6[0][1][14] + sp[28] * PI2[0][14][1] + sp[29] * PI5[0][14][1] + sp[26] * PI7[0][1][14] + sp[27] * PI8[0][1][14] + sp[31] * PI3[0][14][1] + sp[32] * PI6[0][14][1] + sp[27] * PI8[0][14][1] + sp[30] * PI9[0][1][14];
    A[30] = sp[33] * PI0[0][2][0] + sp[34] * PI1[0][2][0] + sp[28] * PI2[0][2][0] + sp[31] * PI3[0][2][0] + sp[34] * PI1[0][0][2] + sp[35] * PI4[0][2][0] + sp[29] * PI5[0][2][0] + sp[32] * PI6[0][2][0] + sp[28] * PI2[0][0][2] + sp[29] * PI5[0][0][2] + sp[26] * PI7[0][2][0] + sp[27] * PI8[0][2][0] + sp[31] * PI3[0][0][2] + sp[32] * PI6[0][0][2] + sp[27] * PI8[0][0][2] + sp[30] * PI9[0][2][0];
    A[31] = sp[33] * PI0[0][2][1] + sp[34] * PI1[0][2][1] + sp[28] * PI2[0][2][1] + sp[31] * PI3[0][2][1] + sp[34] * PI1[0][1][2] + sp[35] * PI4[0][2][1] + sp[29] * PI5[0][2][1] + sp[32] * PI6[0][2][1] + sp[28] * PI2[0][1][2] + sp[29] * PI5[0][1][2] + sp[26] * PI7[0][2][1] + sp[27] * PI8[0][2][1] + sp[31] * PI3[0][1][2] + sp[32] * PI6[0][1][2] + sp[27] * PI8[0][1][2] + sp[30] * PI9[0][2][1];
    A[32] = sp[33] * PI0[0][2][2] + sp[34] * PI1[0][2][2] + sp[28] * PI2[0][2][2] + sp[31] * PI3[0][2][2] + sp[34] * PI1[0][2][2] + sp[35] * PI4[0][2][2] + sp[29] * PI5[0][2][2] + sp[32] * PI6[0][2][2] + sp[28] * PI2[0][2][2] + sp[29] * PI5[0][2][2] + sp[26] * PI7[0][2][2] + sp[27] * PI8[0][2][2] + sp[31] * PI3[0][2][2] + sp[32] * PI6[0][2][2] + sp[27] * PI8[0][2][2] + sp[30] * PI9[0][2][2];
    A[33] = sp[33] * PI0[0][2][3] + sp[34] * PI1[0][2][3] + sp[28] * PI2[0][2][3] + sp[31] * PI3[0][2][3] + sp[34] * PI1[0][3][2] + sp[35] * PI4[0][2][3] + sp[29] * PI5[0][2][3] + sp[32] * PI6[0][2][3] + sp[28] * PI2[0][3][2] + sp[29] * PI5[0][3][2] + sp[26] * PI7[0][2][3] + sp[27] * PI8[0][2][3] + sp[31] * PI3[0][3][2] + sp[32] * PI6[0][3][2] + sp[27] * PI8[0][3][2] + sp[30] * PI9[0][2][3];
    A[34] = sp[33] * PI0[0][2][4] + sp[34] * PI1[0][2][4] + sp[28] * PI2[0][2][4] + sp[31] * PI3[0][2][4] + sp[34] * PI1[0][4][2] + sp[35] * PI4[0][2][4] + sp[29] * PI5[0][2][4] + sp[32] * PI6[0][2][4] + sp[28] * PI2[0][4][2] + sp[29] * PI5[0][4][2] + sp[26] * PI7[0][2][4] + sp[27] * PI8[0][2][4] + sp[31] * PI3[0][4][2] + sp[32] * PI6[0][4][2] + sp[27] * PI8[0][4][2] + sp[30] * PI9[0][2][4];
    A[35] = sp[33] * PI0[0][2][5] + sp[34] * PI1[0][2][5] + sp[28] * PI2[0][2][5] + sp[31] * PI3[0][2][5] + sp[34] * PI1[0][5][2] + sp[35] * PI4[0][2][5] + sp[29] * PI5[0][2][5] + sp[32] * PI6[0][2][5] + sp[28] * PI2[0][5][2] + sp[29] * PI5[0][5][2] + sp[26] * PI7[0][2][5] + sp[27] * PI8[0][2][5] + sp[31] * PI3[0][5][2] + sp[32] * PI6[0][5][2] + sp[27] * PI8[0][5][2] + sp[30] * PI9[0][2][5];
    A[36] = sp[33] * PI0[0][2][6] + sp[34] * PI1[0][2][6] + sp[28] * PI2[0][2][6] + sp[31] * PI3[0][2][6] + sp[34] * PI1[0][6][2] + sp[35] * PI4[0][2][6] + sp[29] * PI5[0][2][6] + sp[32] * PI6[0][2][6] + sp[28] * PI2[0][6][2] + sp[29] * PI5[0][6][2] + sp[26] * PI7[0][2][6] + sp[27] * PI8[0][2][6] + sp[31] * PI3[0][6][2] + sp[32] * PI6[0][6][2] + sp[27] * PI8[0][6][2] + sp[30] * PI9[0][2][6];
    A[37] = sp[33] * PI0[0][2][7] + sp[34] * PI1[0][2][7] + sp[28] * PI2[0][2][7] + sp[31] * PI3[0][2][7] + sp[34] * PI1[0][7][2] + sp[35] * PI4[0][2][7] + sp[29] * PI5[0][2][7] + sp[32] * PI6[0][2][7] + sp[28] * PI2[0][7][2] + sp[29] * PI5[0][7][2] + sp[26] * PI7[0][2][7] + sp[27] * PI8[0][2][7] + sp[31] * PI3[0][7][2] + sp[32] * PI6[0][7][2] + sp[27] * PI8[0][7][2] + sp[30] * PI9[0][2][7];
    A[38] = sp[33] * PI0[0][2][8] + sp[34] * PI1[0][2][8] + sp[28] * PI2[0][2][8] + sp[31] * PI3[0][2][8] + sp[34] * PI1[0][8][2] + sp[35] * PI4[0][2][8] + sp[29] * PI5[0][2][8] + sp[32] * PI6[0][2][8] + sp[28] * PI2[0][8][2] + sp[29] * PI5[0][8][2] + sp[26] * PI7[0][2][8] + sp[27] * PI8[0][2][8] + sp[31] * PI3[0][8][2] + sp[32] * PI6[0][8][2] + sp[27] * PI8[0][8][2] + sp[30] * PI9[0][2][8];
    A[39] = sp[33] * PI0[0][2][9] + sp[34] * PI1[0][2][9] + sp[28] * PI2[0][2][9] + sp[31] * PI3[0][2][9] + sp[34] * PI1[0][9][2] + sp[35] * PI4[0][2][9] + sp[29] * PI5[0][2][9] + sp[32] * PI6[0][2][9] + sp[28] * PI2[0][9][2] + sp[29] * PI5[0][9][2] + sp[26] * PI7[0][2][9] + sp[27] * PI8[0][2][9] + sp[31] * PI3[0][9][2] + sp[32] * PI6[0][9][2] + sp[27] * PI8[0][9][2] + sp[30] * PI9[0][2][9];
    A[40] = sp[33] * PI0[0][2][10] + sp[34] * PI1[0][2][10] + sp[28] * PI2[0][2][10] + sp[31] * PI3[0][2][10] + sp[34] * PI1[0][10][2] + sp[35] * PI4[0][2][10] + sp[29] * PI5[0][2][10] + sp[32] * PI6[0][2][10] + sp[28] * PI2[0][10][2] + sp[29] * PI5[0][10][2] + sp[26] * PI7[0][2][10] + sp[27] * PI8[0][2][10] + sp[31] * PI3[0][10][2] + sp[32] * PI6[0][10][2] + sp[27] * PI8[0][10][2] + sp[30] * PI9[0][2][10];
    A[41] = sp[33] * PI0[0][2][11] + sp[34] * PI1[0][2][11] + sp[28] * PI2[0][2][11] + sp[31] * PI3[0][2][11] + sp[34] * PI1[0][11][2] + sp[35] * PI4[0][2][11] + sp[29] * PI5[0][2][11] + sp[32] * PI6[0][2][11] + sp[28] * PI2[0][11][2] + sp[29] * PI5[0][11][2] + sp[26] * PI7[0][2][11] + sp[27] * PI8[0][2][11] + sp[31] * PI3[0][11][2] + sp[32] * PI6[0][11][2] + sp[27] * PI8[0][11][2] + sp[30] * PI9[0][2][11];
    A[42] = sp[33] * PI0[0][2][12] + sp[34] * PI1[0][2][12] + sp[28] * PI2[0][2][12] + sp[31] * PI3[0][2][12] + sp[34] * PI1[0][12][2] + sp[35] * PI4[0][2][12] + sp[29] * PI5[0][2][12] + sp[32] * PI6[0][2][12] + sp[28] * PI2[0][12][2] + sp[29] * PI5[0][12][2] + sp[26] * PI7[0][2][12] + sp[27] * PI8[0][2][12] + sp[31] * PI3[0][12][2] + sp[32] * PI6[0][12][2] + sp[27] * PI8[0][12][2] + sp[30] * PI9[0][2][12];
    A[43] = sp[33] * PI0[0][2][13] + sp[34] * PI1[0][2][13] + sp[28] * PI2[0][2][13] + sp[31] * PI3[0][2][13] + sp[34] * PI1[0][13][2] + sp[35] * PI4[0][2][13] + sp[29] * PI5[0][2][13] + sp[32] * PI6[0][2][13] + sp[28] * PI2[0][13][2] + sp[29] * PI5[0][13][2] + sp[26] * PI7[0][2][13] + sp[27] * PI8[0][2][13] + sp[31] * PI3[0][13][2] + sp[32] * PI6[0][13][2] + sp[27] * PI8[0][13][2] + sp[30] * PI9[0][2][13];
    A[44] = sp[33] * PI0[0][2][14] + sp[34] * PI1[0][2][14] + sp[28] * PI2[0][2][14] + sp[31] * PI3[0][2][14] + sp[34] * PI1[0][14][2] + sp[35] * PI4[0][2][14] + sp[29] * PI5[0][2][14] + sp[32] * PI6[0][2][14] + sp[28] * PI2[0][14][2] + sp[29] * PI5[0][14][2] + sp[26] * PI7[0][2][14] + sp[27] * PI8[0][2][14] + sp[31] * PI3[0][14][2] + sp[32] * PI6[0][14][2] + sp[27] * PI8[0][14][2] + sp[30] * PI9[0][2][14];
    A[45] = sp[33] * PI0[0][3][0] + sp[34] * PI1[0][3][0] + sp[28] * PI2[0][3][0] + sp[31] * PI3[0][3][0] + sp[34] * PI1[0][0][3] + sp[35] * PI4[0][3][0] + sp[29] * PI5[0][3][0] + sp[32] * PI6[0][3][0] + sp[28] * PI2[0][0][3] + sp[29] * PI5[0][0][3] + sp[26] * PI7[0][3][0] + sp[27] * PI8[0][3][0] + sp[31] * PI3[0][0][3] + sp[32] * PI6[0][0][3] + sp[27] * PI8[0][0][3] + sp[30] * PI9[0][3][0];
    A[46] = sp[33] * PI0[0][3][1] + sp[34] * PI1[0][3][1] + sp[28] * PI2[0][3][1] + sp[31] * PI3[0][3][1] + sp[34] * PI1[0][1][3] + sp[35] * PI4[0][3][1] + sp[29] * PI5[0][3][1] + sp[32] * PI6[0][3][1] + sp[28] * PI2[0][1][3] + sp[29] * PI5[0][1][3] + sp[26] * PI7[0][3][1] + sp[27] * PI8[0][3][1] + sp[31] * PI3[0][1][3] + sp[32] * PI6[0][1][3] + sp[27] * PI8[0][1][3] + sp[30] * PI9[0][3][1];
    A[47] = sp[33] * PI0[0][3][2] + sp[34] * PI1[0][3][2] + sp[28] * PI2[0][3][2] + sp[31] * PI3[0][3][2] + sp[34] * PI1[0][2][3] + sp[35] * PI4[0][3][2] + sp[29] * PI5[0][3][2] + sp[32] * PI6[0][3][2] + sp[28] * PI2[0][2][3] + sp[29] * PI5[0][2][3] + sp[26] * PI7[0][3][2] + sp[27] * PI8[0][3][2] + sp[31] * PI3[0][2][3] + sp[32] * PI6[0][2][3] + sp[27] * PI8[0][2][3] + sp[30] * PI9[0][3][2];
    A[48] = sp[33] * PI0[0][3][3] + sp[34] * PI1[0][3][3] + sp[28] * PI2[0][3][3] + sp[31] * PI3[0][3][3] + sp[34] * PI1[0][3][3] + sp[35] * PI4[0][3][3] + sp[29] * PI5[0][3][3] + sp[32] * PI6[0][3][3] + sp[28] * PI2[0][3][3] + sp[29] * PI5[0][3][3] + sp[26] * PI7[0][3][3] + sp[27] * PI8[0][3][3] + sp[31] * PI3[0][3][3] + sp[32] * PI6[0][3][3] + sp[27] * PI8[0][3][3] + sp[30] * PI9[0][3][3];
    A[49] = sp[33] * PI0[0][3][4] + sp[34] * PI1[0][3][4] + sp[28] * PI2[0][3][4] + sp[31] * PI3[0][3][4] + sp[34] * PI1[0][4][3] + sp[35] * PI4[0][3][4] + sp[29] * PI5[0][3][4] + sp[32] * PI6[0][3][4] + sp[28] * PI2[0][4][3] + sp[29] * PI5[0][4][3] + sp[26] * PI7[0][3][4] + sp[27] * PI8[0][3][4] + sp[31] * PI3[0][4][3] + sp[32] * PI6[0][4][3] + sp[27] * PI8[0][4][3] + sp[30] * PI9[0][3][4];
    A[50] = sp[33] * PI0[0][3][5] + sp[34] * PI1[0][3][5] + sp[28] * PI2[0][3][5] + sp[31] * PI3[0][3][5] + sp[34] * PI1[0][5][3] + sp[35] * PI4[0][3][5] + sp[29] * PI5[0][3][5] + sp[32] * PI6[0][3][5] + sp[28] * PI2[0][5][3] + sp[29] * PI5[0][5][3] + sp[26] * PI7[0][3][5] + sp[27] * PI8[0][3][5] + sp[31] * PI3[0][5][3] + sp[32] * PI6[0][5][3] + sp[27] * PI8[0][5][3] + sp[30] * PI9[0][3][5];
    A[51] = sp[33] * PI0[0][3][6] + sp[34] * PI1[0][3][6] + sp[28] * PI2[0][3][6] + sp[31] * PI3[0][3][6] + sp[34] * PI1[0][6][3] + sp[35] * PI4[0][3][6] + sp[29] * PI5[0][3][6] + sp[32] * PI6[0][3][6] + sp[28] * PI2[0][6][3] + sp[29] * PI5[0][6][3] + sp[26] * PI7[0][3][6] + sp[27] * PI8[0][3][6] + sp[31] * PI3[0][6][3] + sp[32] * PI6[0][6][3] + sp[27] * PI8[0][6][3] + sp[30] * PI9[0][3][6];
    A[52] = sp[33] * PI0[0][3][7] + sp[34] * PI1[0][3][7] + sp[28] * PI2[0][3][7] + sp[31] * PI3[0][3][7] + sp[34] * PI1[0][7][3] + sp[35] * PI4[0][3][7] + sp[29] * PI5[0][3][7] + sp[32] * PI6[0][3][7] + sp[28] * PI2[0][7][3] + sp[29] * PI5[0][7][3] + sp[26] * PI7[0][3][7] + sp[27] * PI8[0][3][7] + sp[31] * PI3[0][7][3] + sp[32] * PI6[0][7][3] + sp[27] * PI8[0][7][3] + sp[30] * PI9[0][3][7];
    A[53] = sp[33] * PI0[0][3][8] + sp[34] * PI1[0][3][8] + sp[28] * PI2[0][3][8] + sp[31] * PI3[0][3][8] + sp[34] * PI1[0][8][3] + sp[35] * PI4[0][3][8] + sp[29] * PI5[0][3][8] + sp[32] * PI6[0][3][8] + sp[28] * PI2[0][8][3] + sp[29] * PI5[0][8][3] + sp[26] * PI7[0][3][8] + sp[27] * PI8[0][3][8] + sp[31] * PI3[0][8][3] + sp[32] * PI6[0][8][3] + sp[27] * PI8[0][8][3] + sp[30] * PI9[0][3][8];
    A[54] = sp[33] * PI0[0][3][9] + sp[34] * PI1[0][3][9] + sp[28] * PI2[0][3][9] + sp[31] * PI3[0][3][9] + sp[34] * PI1[0][9][3] + sp[35] * PI4[0][3][9] + sp[29] * PI5[0][3][9] + sp[32] * PI6[0][3][9] + sp[28] * PI2[0][9][3] + sp[29] * PI5[0][9][3] + sp[26] * PI7[0][3][9] + sp[27] * PI8[0][3][9] + sp[31] * PI3[0][9][3] + sp[32] * PI6[0][9][3] + sp[27] * PI8[0][9][3] + sp[30] * PI9[0][3][9];
    A[55] = sp[33] * PI0[0][3][10] + sp[34] * PI1[0][3][10] + sp[28] * PI2[0][3][10] + sp[31] * PI3[0][3][10] + sp[34] * PI1[0][10][3] + sp[35] * PI4[0][3][10] + sp[29] * PI5[0][3][10] + sp[32] * PI6[0][3][10] + sp[28] * PI2[0][10][3] + sp[29] * PI5[0][10][3] + sp[26] * PI7[0][3][10] + sp[27] * PI8[0][3][10] + sp[31] * PI3[0][10][3] + sp[32] * PI6[0][10][3] + sp[27] * PI8[0][10][3] + sp[30] * PI9[0][3][10];
    A[56] = sp[33] * PI0[0][3][11] + sp[34] * PI1[0][3][11] + sp[28] * PI2[0][3][11] + sp[31] * PI3[0][3][11] + sp[34] * PI1[0][11][3] + sp[35] * PI4[0][3][11] + sp[29] * PI5[0][3][11] + sp[32] * PI6[0][3][11] + sp[28] * PI2[0][11][3] + sp[29] * PI5[0][11][3] + sp[26] * PI7[0][3][11] + sp[27] * PI8[0][3][11] + sp[31] * PI3[0][11][3] + sp[32] * PI6[0][11][3] + sp[27] * PI8[0][11][3] + sp[30] * PI9[0][3][11];
    A[57] = sp[33] * PI0[0][3][12] + sp[34] * PI1[0][3][12] + sp[28] * PI2[0][3][12] + sp[31] * PI3[0][3][12] + sp[34] * PI1[0][12][3] + sp[35] * PI4[0][3][12] + sp[29] * PI5[0][3][12] + sp[32] * PI6[0][3][12] + sp[28] * PI2[0][12][3] + sp[29] * PI5[0][12][3] + sp[26] * PI7[0][3][12] + sp[27] * PI8[0][3][12] + sp[31] * PI3[0][12][3] + sp[32] * PI6[0][12][3] + sp[27] * PI8[0][12][3] + sp[30] * PI9[0][3][12];
    A[58] = sp[33] * PI0[0][3][13] + sp[34] * PI1[0][3][13] + sp[28] * PI2[0][3][13] + sp[31] * PI3[0][3][13] + sp[34] * PI1[0][13][3] + sp[35] * PI4[0][3][13] + sp[29] * PI5[0][3][13] + sp[32] * PI6[0][3][13] + sp[28] * PI2[0][13][3] + sp[29] * PI5[0][13][3] + sp[26] * PI7[0][3][13] + sp[27] * PI8[0][3][13] + sp[31] * PI3[0][13][3] + sp[32] * PI6[0][13][3] + sp[27] * PI8[0][13][3] + sp[30] * PI9[0][3][13];
    A[59] = sp[33] * PI0[0][3][14] + sp[34] * PI1[0][3][14] + sp[28] * PI2[0][3][14] + sp[31] * PI3[0][3][14] + sp[34] * PI1[0][14][3] + sp[35] * PI4[0][3][14] + sp[29] * PI5[0][3][14] + sp[32] * PI6[0][3][14] + sp[28] * PI2[0][14][3] + sp[29] * PI5[0][14][3] + sp[26] * PI7[0][3][14] + sp[27] * PI8[0][3][14] + sp[31] * PI3[0][14][3] + sp[32] * PI6[0][14][3] + sp[27] * PI8[0][14][3] + sp[30] * PI9[0][3][14];
    A[60] = sp[33] * PI0[0][4][0] + sp[34] * PI1[0][4][0] + sp[28] * PI2[0][4][0] + sp[31] * PI3[0][4][0] + sp[34] * PI1[0][0][4] + sp[35] * PI4[0][4][0] + sp[29] * PI5[0][4][0] + sp[32] * PI6[0][4][0] + sp[28] * PI2[0][0][4] + sp[29] * PI5[0][0][4] + sp[26] * PI7[0][4][0] + sp[27] * PI8[0][4][0] + sp[31] * PI3[0][0][4] + sp[32] * PI6[0][0][4] + sp[27] * PI8[0][0][4] + sp[30] * PI9[0][4][0];
    A[61] = sp[33] * PI0[0][4][1] + sp[34] * PI1[0][4][1] + sp[28] * PI2[0][4][1] + sp[31] * PI3[0][4][1] + sp[34] * PI1[0][1][4] + sp[35] * PI4[0][4][1] + sp[29] * PI5[0][4][1] + sp[32] * PI6[0][4][1] + sp[28] * PI2[0][1][4] + sp[29] * PI5[0][1][4] + sp[26] * PI7[0][4][1] + sp[27] * PI8[0][4][1] + sp[31] * PI3[0][1][4] + sp[32] * PI6[0][1][4] + sp[27] * PI8[0][1][4] + sp[30] * PI9[0][4][1];
    A[62] = sp[33] * PI0[0][4][2] + sp[34] * PI1[0][4][2] + sp[28] * PI2[0][4][2] + sp[31] * PI3[0][4][2] + sp[34] * PI1[0][2][4] + sp[35] * PI4[0][4][2] + sp[29] * PI5[0][4][2] + sp[32] * PI6[0][4][2] + sp[28] * PI2[0][2][4] + sp[29] * PI5[0][2][4] + sp[26] * PI7[0][4][2] + sp[27] * PI8[0][4][2] + sp[31] * PI3[0][2][4] + sp[32] * PI6[0][2][4] + sp[27] * PI8[0][2][4] + sp[30] * PI9[0][4][2];
    A[63] = sp[33] * PI0[0][4][3] + sp[34] * PI1[0][4][3] + sp[28] * PI2[0][4][3] + sp[31] * PI3[0][4][3] + sp[34] * PI1[0][3][4] + sp[35] * PI4[0][4][3] + sp[29] * PI5[0][4][3] + sp[32] * PI6[0][4][3] + sp[28] * PI2[0][3][4] + sp[29] * PI5[0][3][4] + sp[26] * PI7[0][4][3] + sp[27] * PI8[0][4][3] + sp[31] * PI3[0][3][4] + sp[32] * PI6[0][3][4] + sp[27] * PI8[0][3][4] + sp[30] * PI9[0][4][3];
    A[64] = sp[33] * PI0[0][4][4] + sp[34] * PI1[0][4][4] + sp[28] * PI2[0][4][4] + sp[31] * PI3[0][4][4] + sp[34] * PI1[0][4][4] + sp[35] * PI4[0][4][4] + sp[29] * PI5[0][4][4] + sp[32] * PI6[0][4][4] + sp[28] * PI2[0][4][4] + sp[29] * PI5[0][4][4] + sp[26] * PI7[0][4][4] + sp[27] * PI8[0][4][4] + sp[31] * PI3[0][4][4] + sp[32] * PI6[0][4][4] + sp[27] * PI8[0][4][4] + sp[30] * PI9[0][4][4];
    A[65] = sp[33] * PI0[0][4][5] + sp[34] * PI1[0][4][5] + sp[28] * PI2[0][4][5] + sp[31] * PI3[0][4][5] + sp[34] * PI1[0][5][4] + sp[35] * PI4[0][4][5] + sp[29] * PI5[0][4][5] + sp[32] * PI6[0][4][5] + sp[28] * PI2[0][5][4] + sp[29] * PI5[0][5][4] + sp[26] * PI7[0][4][5] + sp[27] * PI8[0][4][5] + sp[31] * PI3[0][5][4] + sp[32] * PI6[0][5][4] + sp[27] * PI8[0][5][4] + sp[30] * PI9[0][4][5];
    A[66] = sp[33] * PI0[0][4][6] + sp[34] * PI1[0][4][6] + sp[28] * PI2[0][4][6] + sp[31] * PI3[0][4][6] + sp[34] * PI1[0][6][4] + sp[35] * PI4[0][4][6] + sp[29] * PI5[0][4][6] + sp[32] * PI6[0][4][6] + sp[28] * PI2[0][6][4] + sp[29] * PI5[0][6][4] + sp[26] * PI7[0][4][6] + sp[27] * PI8[0][4][6] + sp[31] * PI3[0][6][4] + sp[32] * PI6[0][6][4] + sp[27] * PI8[0][6][4] + sp[30] * PI9[0][4][6];
    A[67] = sp[33] * PI0[0][4][7] + sp[34] * PI1[0][4][7] + sp[28] * PI2[0][4][7] + sp[31] * PI3[0][4][7] + sp[34] * PI1[0][7][4] + sp[35] * PI4[0][4][7] + sp[29] * PI5[0][4][7] + sp[32] * PI6[0][4][7] + sp[28] * PI2[0][7][4] + sp[29] * PI5[0][7][4] + sp[26] * PI7[0][4][7] + sp[27] * PI8[0][4][7] + sp[31] * PI3[0][7][4] + sp[32] * PI6[0][7][4] + sp[27] * PI8[0][7][4] + sp[30] * PI9[0][4][7];
    A[68] = sp[33] * PI0[0][4][8] + sp[34] * PI1[0][4][8] + sp[28] * PI2[0][4][8] + sp[31] * PI3[0][4][8] + sp[34] * PI1[0][8][4] + sp[35] * PI4[0][4][8] + sp[29] * PI5[0][4][8] + sp[32] * PI6[0][4][8] + sp[28] * PI2[0][8][4] + sp[29] * PI5[0][8][4] + sp[26] * PI7[0][4][8] + sp[27] * PI8[0][4][8] + sp[31] * PI3[0][8][4] + sp[32] * PI6[0][8][4] + sp[27] * PI8[0][8][4] + sp[30] * PI9[0][4][8];
    A[69] = sp[33] * PI0[0][4][9] + sp[34] * PI1[0][4][9] + sp[28] * PI2[0][4][9] + sp[31] * PI3[0][4][9] + sp[34] * PI1[0][9][4] + sp[35] * PI4[0][4][9] + sp[29] * PI5[0][4][9] + sp[32] * PI6[0][4][9] + sp[28] * PI2[0][9][4] + sp[29] * PI5[0][9][4] + sp[26] * PI7[0][4][9] + sp[27] * PI8[0][4][9] + sp[31] * PI3[0][9][4] + sp[32] * PI6[0][9][4] + sp[27] * PI8[0][9][4] + sp[30] * PI9[0][4][9];
    A[70] = sp[33] * PI0[0][4][10] + sp[34] * PI1[0][4][10] + sp[28] * PI2[0][4][10] + sp[31] * PI3[0][4][10] + sp[34] * PI1[0][10][4] + sp[35] * PI4[0][4][10] + sp[29] * PI5[0][4][10] + sp[32] * PI6[0][4][10] + sp[28] * PI2[0][10][4] + sp[29] * PI5[0][10][4] + sp[26] * PI7[0][4][10] + sp[27] * PI8[0][4][10] + sp[31] * PI3[0][10][4] + sp[32] * PI6[0][10][4] + sp[27] * PI8[0][10][4] + sp[30] * PI9[0][4][10];
    A[71] = sp[33] * PI0[0][4][11] + sp[34] * PI1[0][4][11] + sp[28] * PI2[0][4][11] + sp[31] * PI3[0][4][11] + sp[34] * PI1[0][11][4] + sp[35] * PI4[0][4][11] + sp[29] * PI5[0][4][11] + sp[32] * PI6[0][4][11] + sp[28] * PI2[0][11][4] + sp[29] * PI5[0][11][4] + sp[26] * PI7[0][4][11] + sp[27] * PI8[0][4][11] + sp[31] * PI3[0][11][4] + sp[32] * PI6[0][11][4] + sp[27] * PI8[0][11][4] + sp[30] * PI9[0][4][11];
    A[72] = sp[33] * PI0[0][4][12] + sp[34] * PI1[0][4][12] + sp[28] * PI2[0][4][12] + sp[31] * PI3[0][4][12] + sp[34] * PI1[0][12][4] + sp[35] * PI4[0][4][12] + sp[29] * PI5[0][4][12] + sp[32] * PI6[0][4][12] + sp[28] * PI2[0][12][4] + sp[29] * PI5[0][12][4] + sp[26] * PI7[0][4][12] + sp[27] * PI8[0][4][12] + sp[31] * PI3[0][12][4] + sp[32] * PI6[0][12][4] + sp[27] * PI8[0][12][4] + sp[30] * PI9[0][4][12];
    A[73] = sp[33] * PI0[0][4][13] + sp[34] * PI1[0][4][13] + sp[28] * PI2[0][4][13] + sp[31] * PI3[0][4][13] + sp[34] * PI1[0][13][4] + sp[35] * PI4[0][4][13] + sp[29] * PI5[0][4][13] + sp[32] * PI6[0][4][13] + sp[28] * PI2[0][13][4] + sp[29] * PI5[0][13][4] + sp[26] * PI7[0][4][13] + sp[27] * PI8[0][4][13] + sp[31] * PI3[0][13][4] + sp[32] * PI6[0][13][4] + sp[27] * PI8[0][13][4] + sp[30] * PI9[0][4][13];
    A[74] = sp[33] * PI0[0][4][14] + sp[34] * PI1[0][4][14] + sp[28] * PI2[0][4][14] + sp[31] * PI3[0][4][14] + sp[34] * PI1[0][14][4] + sp[35] * PI4[0][4][14] + sp[29] * PI5[0][4][14] + sp[32] * PI6[0][4][14] + sp[28] * PI2[0][14][4] + sp[29] * PI5[0][14][4] + sp[26] * PI7[0][4][14] + sp[27] * PI8[0][4][14] + sp[31] * PI3[0][14][4] + sp[32] * PI6[0][14][4] + sp[27] * PI8[0][14][4] + sp[30] * PI9[0][4][14];
    A[75] = sp[33] * PI0[0][5][0] + sp[34] * PI1[0][5][0] + sp[28] * PI2[0][5][0] + sp[31] * PI3[0][5][0] + sp[34] * PI1[0][0][5] + sp[35] * PI4[0][5][0] + sp[29] * PI5[0][5][0] + sp[32] * PI6[0][5][0] + sp[28] * PI2[0][0][5] + sp[29] * PI5[0][0][5] + sp[26] * PI7[0][5][0] + sp[27] * PI8[0][5][0] + sp[31] * PI3[0][0][5] + sp[32] * PI6[0][0][5] + sp[27] * PI8[0][0][5] + sp[30] * PI9[0][5][0];
    A[76] = sp[33] * PI0[0][5][1] + sp[34] * PI1[0][5][1] + sp[28] * PI2[0][5][1] + sp[31] * PI3[0][5][1] + sp[34] * PI1[0][1][5] + sp[35] * PI4[0][5][1] + sp[29] * PI5[0][5][1] + sp[32] * PI6[0][5][1] + sp[28] * PI2[0][1][5] + sp[29] * PI5[0][1][5] + sp[26] * PI7[0][5][1] + sp[27] * PI8[0][5][1] + sp[31] * PI3[0][1][5] + sp[32] * PI6[0][1][5] + sp[27] * PI8[0][1][5] + sp[30] * PI9[0][5][1];
    A[77] = sp[33] * PI0[0][5][2] + sp[34] * PI1[0][5][2] + sp[28] * PI2[0][5][2] + sp[31] * PI3[0][5][2] + sp[34] * PI1[0][2][5] + sp[35] * PI4[0][5][2] + sp[29] * PI5[0][5][2] + sp[32] * PI6[0][5][2] + sp[28] * PI2[0][2][5] + sp[29] * PI5[0][2][5] + sp[26] * PI7[0][5][2] + sp[27] * PI8[0][5][2] + sp[31] * PI3[0][2][5] + sp[32] * PI6[0][2][5] + sp[27] * PI8[0][2][5] + sp[30] * PI9[0][5][2];
    A[78] = sp[33] * PI0[0][5][3] + sp[34] * PI1[0][5][3] + sp[28] * PI2[0][5][3] + sp[31] * PI3[0][5][3] + sp[34] * PI1[0][3][5] + sp[35] * PI4[0][5][3] + sp[29] * PI5[0][5][3] + sp[32] * PI6[0][5][3] + sp[28] * PI2[0][3][5] + sp[29] * PI5[0][3][5] + sp[26] * PI7[0][5][3] + sp[27] * PI8[0][5][3] + sp[31] * PI3[0][3][5] + sp[32] * PI6[0][3][5] + sp[27] * PI8[0][3][5] + sp[30] * PI9[0][5][3];
    A[79] = sp[33] * PI0[0][5][4] + sp[34] * PI1[0][5][4] + sp[28] * PI2[0][5][4] + sp[31] * PI3[0][5][4] + sp[34] * PI1[0][4][5] + sp[35] * PI4[0][5][4] + sp[29] * PI5[0][5][4] + sp[32] * PI6[0][5][4] + sp[28] * PI2[0][4][5] + sp[29] * PI5[0][4][5] + sp[26] * PI7[0][5][4] + sp[27] * PI8[0][5][4] + sp[31] * PI3[0][4][5] + sp[32] * PI6[0][4][5] + sp[27] * PI8[0][4][5] + sp[30] * PI9[0][5][4];
    A[80] = sp[33] * PI0[0][5][5] + sp[34] * PI1[0][5][5] + sp[28] * PI2[0][5][5] + sp[31] * PI3[0][5][5] + sp[34] * PI1[0][5][5] + sp[35] * PI4[0][5][5] + sp[29] * PI5[0][5][5] + sp[32] * PI6[0][5][5] + sp[28] * PI2[0][5][5] + sp[29] * PI5[0][5][5] + sp[26] * PI7[0][5][5] + sp[27] * PI8[0][5][5] + sp[31] * PI3[0][5][5] + sp[32] * PI6[0][5][5] + sp[27] * PI8[0][5][5] + sp[30] * PI9[0][5][5];
    A[81] = sp[33] * PI0[0][5][6] + sp[34] * PI1[0][5][6] + sp[28] * PI2[0][5][6] + sp[31] * PI3[0][5][6] + sp[34] * PI1[0][6][5] + sp[35] * PI4[0][5][6] + sp[29] * PI5[0][5][6] + sp[32] * PI6[0][5][6] + sp[28] * PI2[0][6][5] + sp[29] * PI5[0][6][5] + sp[26] * PI7[0][5][6] + sp[27] * PI8[0][5][6] + sp[31] * PI3[0][6][5] + sp[32] * PI6[0][6][5] + sp[27] * PI8[0][6][5] + sp[30] * PI9[0][5][6];
    A[82] = sp[33] * PI0[0][5][7] + sp[34] * PI1[0][5][7] + sp[28] * PI2[0][5][7] + sp[31] * PI3[0][5][7] + sp[34] * PI1[0][7][5] + sp[35] * PI4[0][5][7] + sp[29] * PI5[0][5][7] + sp[32] * PI6[0][5][7] + sp[28] * PI2[0][7][5] + sp[29] * PI5[0][7][5] + sp[26] * PI7[0][5][7] + sp[27] * PI8[0][5][7] + sp[31] * PI3[0][7][5] + sp[32] * PI6[0][7][5] + sp[27] * PI8[0][7][5] + sp[30] * PI9[0][5][7];
    A[83] = sp[33] * PI0[0][5][8] + sp[34] * PI1[0][5][8] + sp[28] * PI2[0][5][8] + sp[31] * PI3[0][5][8] + sp[34] * PI1[0][8][5] + sp[35] * PI4[0][5][8] + sp[29] * PI5[0][5][8] + sp[32] * PI6[0][5][8] + sp[28] * PI2[0][8][5] + sp[29] * PI5[0][8][5] + sp[26] * PI7[0][5][8] + sp[27] * PI8[0][5][8] + sp[31] * PI3[0][8][5] + sp[32] * PI6[0][8][5] + sp[27] * PI8[0][8][5] + sp[30] * PI9[0][5][8];
    A[84] = sp[33] * PI0[0][5][9] + sp[34] * PI1[0][5][9] + sp[28] * PI2[0][5][9] + sp[31] * PI3[0][5][9] + sp[34] * PI1[0][9][5] + sp[35] * PI4[0][5][9] + sp[29] * PI5[0][5][9] + sp[32] * PI6[0][5][9] + sp[28] * PI2[0][9][5] + sp[29] * PI5[0][9][5] + sp[26] * PI7[0][5][9] + sp[27] * PI8[0][5][9] + sp[31] * PI3[0][9][5] + sp[32] * PI6[0][9][5] + sp[27] * PI8[0][9][5] + sp[30] * PI9[0][5][9];
    A[85] = sp[33] * PI0[0][5][10] + sp[34] * PI1[0][5][10] + sp[28] * PI2[0][5][10] + sp[31] * PI3[0][5][10] + sp[34] * PI1[0][10][5] + sp[35] * PI4[0][5][10] + sp[29] * PI5[0][5][10] + sp[32] * PI6[0][5][10] + sp[28] * PI2[0][10][5] + sp[29] * PI5[0][10][5] + sp[26] * PI7[0][5][10] + sp[27] * PI8[0][5][10] + sp[31] * PI3[0][10][5] + sp[32] * PI6[0][10][5] + sp[27] * PI8[0][10][5] + sp[30] * PI9[0][5][10];
    A[86] = sp[33] * PI0[0][5][11] + sp[34] * PI1[0][5][11] + sp[28] * PI2[0][5][11] + sp[31] * PI3[0][5][11] + sp[34] * PI1[0][11][5] + sp[35] * PI4[0][5][11] + sp[29] * PI5[0][5][11] + sp[32] * PI6[0][5][11] + sp[28] * PI2[0][11][5] + sp[29] * PI5[0][11][5] + sp[26] * PI7[0][5][11] + sp[27] * PI8[0][5][11] + sp[31] * PI3[0][11][5] + sp[32] * PI6[0][11][5] + sp[27] * PI8[0][11][5] + sp[30] * PI9[0][5][11];
    A[87] = sp[33] * PI0[0][5][12] + sp[34] * PI1[0][5][12] + sp[28] * PI2[0][5][12] + sp[31] * PI3[0][5][12] + sp[34] * PI1[0][12][5] + sp[35] * PI4[0][5][12] + sp[29] * PI5[0][5][12] + sp[32] * PI6[0][5][12] + sp[28] * PI2[0][12][5] + sp[29] * PI5[0][12][5] + sp[26] * PI7[0][5][12] + sp[27] * PI8[0][5][12] + sp[31] * PI3[0][12][5] + sp[32] * PI6[0][12][5] + sp[27] * PI8[0][12][5] + sp[30] * PI9[0][5][12];
    A[88] = sp[33] * PI0[0][5][13] + sp[34] * PI1[0][5][13] + sp[28] * PI2[0][5][13] + sp[31] * PI3[0][5][13] + sp[34] * PI1[0][13][5] + sp[35] * PI4[0][5][13] + sp[29] * PI5[0][5][13] + sp[32] * PI6[0][5][13] + sp[28] * PI2[0][13][5] + sp[29] * PI5[0][13][5] + sp[26] * PI7[0][5][13] + sp[27] * PI8[0][5][13] + sp[31] * PI3[0][13][5] + sp[32] * PI6[0][13][5] + sp[27] * PI8[0][13][5] + sp[30] * PI9[0][5][13];
    A[89] = sp[33] * PI0[0][5][14] + sp[34] * PI1[0][5][14] + sp[28] * PI2[0][5][14] + sp[31] * PI3[0][5][14] + sp[34] * PI1[0][14][5] + sp[35] * PI4[0][5][14] + sp[29] * PI5[0][5][14] + sp[32] * PI6[0][5][14] + sp[28] * PI2[0][14][5] + sp[29] * PI5[0][14][5] + sp[26] * PI7[0][5][14] + sp[27] * PI8[0][5][14] + sp[31] * PI3[0][14][5] + sp[32] * PI6[0][14][5] + sp[27] * PI8[0][14][5] + sp[30] * PI9[0][5][14];
    A[90] = sp[33] * PI0[0][6][0] + sp[34] * PI1[0][6][0] + sp[28] * PI2[0][6][0] + sp[31] * PI3[0][6][0] + sp[34] * PI1[0][0][6] + sp[35] * PI4[0][6][0] + sp[29] * PI5[0][6][0] + sp[32] * PI6[0][6][0] + sp[28] * PI2[0][0][6] + sp[29] * PI5[0][0][6] + sp[26] * PI7[0][6][0] + sp[27] * PI8[0][6][0] + sp[31] * PI3[0][0][6] + sp[32] * PI6[0][0][6] + sp[27] * PI8[0][0][6] + sp[30] * PI9[0][6][0];
    A[91] = sp[33] * PI0[0][6][1] + sp[34] * PI1[0][6][1] + sp[28] * PI2[0][6][1] + sp[31] * PI3[0][6][1] + sp[34] * PI1[0][1][6] + sp[35] * PI4[0][6][1] + sp[29] * PI5[0][6][1] + sp[32] * PI6[0][6][1] + sp[28] * PI2[0][1][6] + sp[29] * PI5[0][1][6] + sp[26] * PI7[0][6][1] + sp[27] * PI8[0][6][1] + sp[31] * PI3[0][1][6] + sp[32] * PI6[0][1][6] + sp[27] * PI8[0][1][6] + sp[30] * PI9[0][6][1];
    A[92] = sp[33] * PI0[0][6][2] + sp[34] * PI1[0][6][2] + sp[28] * PI2[0][6][2] + sp[31] * PI3[0][6][2] + sp[34] * PI1[0][2][6] + sp[35] * PI4[0][6][2] + sp[29] * PI5[0][6][2] + sp[32] * PI6[0][6][2] + sp[28] * PI2[0][2][6] + sp[29] * PI5[0][2][6] + sp[26] * PI7[0][6][2] + sp[27] * PI8[0][6][2] + sp[31] * PI3[0][2][6] + sp[32] * PI6[0][2][6] + sp[27] * PI8[0][2][6] + sp[30] * PI9[0][6][2];
    A[93] = sp[33] * PI0[0][6][3] + sp[34] * PI1[0][6][3] + sp[28] * PI2[0][6][3] + sp[31] * PI3[0][6][3] + sp[34] * PI1[0][3][6] + sp[35] * PI4[0][6][3] + sp[29] * PI5[0][6][3] + sp[32] * PI6[0][6][3] + sp[28] * PI2[0][3][6] + sp[29] * PI5[0][3][6] + sp[26] * PI7[0][6][3] + sp[27] * PI8[0][6][3] + sp[31] * PI3[0][3][6] + sp[32] * PI6[0][3][6] + sp[27] * PI8[0][3][6] + sp[30] * PI9[0][6][3];
    A[94] = sp[33] * PI0[0][6][4] + sp[34] * PI1[0][6][4] + sp[28] * PI2[0][6][4] + sp[31] * PI3[0][6][4] + sp[34] * PI1[0][4][6] + sp[35] * PI4[0][6][4] + sp[29] * PI5[0][6][4] + sp[32] * PI6[0][6][4] + sp[28] * PI2[0][4][6] + sp[29] * PI5[0][4][6] + sp[26] * PI7[0][6][4] + sp[27] * PI8[0][6][4] + sp[31] * PI3[0][4][6] + sp[32] * PI6[0][4][6] + sp[27] * PI8[0][4][6] + sp[30] * PI9[0][6][4];
    A[95] = sp[33] * PI0[0][6][5] + sp[34] * PI1[0][6][5] + sp[28] * PI2[0][6][5] + sp[31] * PI3[0][6][5] + sp[34] * PI1[0][5][6] + sp[35] * PI4[0][6][5] + sp[29] * PI5[0][6][5] + sp[32] * PI6[0][6][5] + sp[28] * PI2[0][5][6] + sp[29] * PI5[0][5][6] + sp[26] * PI7[0][6][5] + sp[27] * PI8[0][6][5] + sp[31] * PI3[0][5][6] + sp[32] * PI6[0][5][6] + sp[27] * PI8[0][5][6] + sp[30] * PI9[0][6][5];
    A[96] = sp[33] * PI0[0][6][6] + sp[34] * PI1[0][6][6] + sp[28] * PI2[0][6][6] + sp[31] * PI3[0][6][6] + sp[34] * PI1[0][6][6] + sp[35] * PI4[0][6][6] + sp[29] * PI5[0][6][6] + sp[32] * PI6[0][6][6] + sp[28] * PI2[0][6][6] + sp[29] * PI5[0][6][6] + sp[26] * PI7[0][6][6] + sp[27] * PI8[0][6][6] + sp[31] * PI3[0][6][6] + sp[32] * PI6[0][6][6] + sp[27] * PI8[0][6][6] + sp[30] * PI9[0][6][6];
    A[97] = sp[33] * PI0[0][6][7] + sp[34] * PI1[0][6][7] + sp[28] * PI2[0][6][7] + sp[31] * PI3[0][6][7] + sp[34] * PI1[0][7][6] + sp[35] * PI4[0][6][7] + sp[29] * PI5[0][6][7] + sp[32] * PI6[0][6][7] + sp[28] * PI2[0][7][6] + sp[29] * PI5[0][7][6] + sp[26] * PI7[0][6][7] + sp[27] * PI8[0][6][7] + sp[31] * PI3[0][7][6] + sp[32] * PI6[0][7][6] + sp[27] * PI8[0][7][6] + sp[30] * PI9[0][6][7];
    A[98] = sp[33] * PI0[0][6][8] + sp[34] * PI1[0][6][8] + sp[28] * PI2[0][6][8] + sp[31] * PI3[0][6][8] + sp[34] * PI1[0][8][6] + sp[35] * PI4[0][6][8] + sp[29] * PI5[0][6][8] + sp[32] * PI6[0][6][8] + sp[28] * PI2[0][8][6] + sp[29] * PI5[0][8][6] + sp[26] * PI7[0][6][8] + sp[27] * PI8[0][6][8] + sp[31] * PI3[0][8][6] + sp[32] * PI6[0][8][6] + sp[27] * PI8[0][8][6] + sp[30] * PI9[0][6][8];
    A[99] = sp[33] * PI0[0][6][9] + sp[34] * PI1[0][6][9] + sp[28] * PI2[0][6][9] + sp[31] * PI3[0][6][9] + sp[34] * PI1[0][9][6] + sp[35] * PI4[0][6][9] + sp[29] * PI5[0][6][9] + sp[32] * PI6[0][6][9] + sp[28] * PI2[0][9][6] + sp[29] * PI5[0][9][6] + sp[26] * PI7[0][6][9] + sp[27] * PI8[0][6][9] + sp[31] * PI3[0][9][6] + sp[32] * PI6[0][9][6] + sp[27] * PI8[0][9][6] + sp[30] * PI9[0][6][9];
    A[100] = sp[33] * PI0[0][6][10] + sp[34] * PI1[0][6][10] + sp[28] * PI2[0][6][10] + sp[31] * PI3[0][6][10] + sp[34] * PI1[0][10][6] + sp[35] * PI4[0][6][10] + sp[29] * PI5[0][6][10] + sp[32] * PI6[0][6][10] + sp[28] * PI2[0][10][6] + sp[29] * PI5[0][10][6] + sp[26] * PI7[0][6][10] + sp[27] * PI8[0][6][10] + sp[31] * PI3[0][10][6] + sp[32] * PI6[0][10][6] + sp[27] * PI8[0][10][6] + sp[30] * PI9[0][6][10];
    A[101] = sp[33] * PI0[0][6][11] + sp[34] * PI1[0][6][11] + sp[28] * PI2[0][6][11] + sp[31] * PI3[0][6][11] + sp[34] * PI1[0][11][6] + sp[35] * PI4[0][6][11] + sp[29] * PI5[0][6][11] + sp[32] * PI6[0][6][11] + sp[28] * PI2[0][11][6] + sp[29] * PI5[0][11][6] + sp[26] * PI7[0][6][11] + sp[27] * PI8[0][6][11] + sp[31] * PI3[0][11][6] + sp[32] * PI6[0][11][6] + sp[27] * PI8[0][11][6] + sp[30] * PI9[0][6][11];
    A[102] = sp[33] * PI0[0][6][12] + sp[34] * PI1[0][6][12] + sp[28] * PI2[0][6][12] + sp[31] * PI3[0][6][12] + sp[34] * PI1[0][12][6] + sp[35] * PI4[0][6][12] + sp[29] * PI5[0][6][12] + sp[32] * PI6[0][6][12] + sp[28] * PI2[0][12][6] + sp[29] * PI5[0][12][6] + sp[26] * PI7[0][6][12] + sp[27] * PI8[0][6][12] + sp[31] * PI3[0][12][6] + sp[32] * PI6[0][12][6] + sp[27] * PI8[0][12][6] + sp[30] * PI9[0][6][12];
    A[103] = sp[33] * PI0[0][6][13] + sp[34] * PI1[0][6][13] + sp[28] * PI2[0][6][13] + sp[31] * PI3[0][6][13] + sp[34] * PI1[0][13][6] + sp[35] * PI4[0][6][13] + sp[29] * PI5[0][6][13] + sp[32] * PI6[0][6][13] + sp[28] * PI2[0][13][6] + sp[29] * PI5[0][13][6] + sp[26] * PI7[0][6][13] + sp[27] * PI8[0][6][13] + sp[31] * PI3[0][13][6] + sp[32] * PI6[0][13][6] + sp[27] * PI8[0][13][6] + sp[30] * PI9[0][6][13];
    A[104] = sp[33] * PI0[0][6][14] + sp[34] * PI1[0][6][14] + sp[28] * PI2[0][6][14] + sp[31] * PI3[0][6][14] + sp[34] * PI1[0][14][6] + sp[35] * PI4[0][6][14] + sp[29] * PI5[0][6][14] + sp[32] * PI6[0][6][14] + sp[28] * PI2[0][14][6] + sp[29] * PI5[0][14][6] + sp[26] * PI7[0][6][14] + sp[27] * PI8[0][6][14] + sp[31] * PI3[0][14][6] + sp[32] * PI6[0][14][6] + sp[27] * PI8[0][14][6] + sp[30] * PI9[0][6][14];
    A[105] = sp[33] * PI0[0][7][0] + sp[34] * PI1[0][7][0] + sp[28] * PI2[0][7][0] + sp[31] * PI3[0][7][0] + sp[34] * PI1[0][0][7] + sp[35] * PI4[0][7][0] + sp[29] * PI5[0][7][0] + sp[32] * PI6[0][7][0] + sp[28] * PI2[0][0][7] + sp[29] * PI5[0][0][7] + sp[26] * PI7[0][7][0] + sp[27] * PI8[0][7][0] + sp[31] * PI3[0][0][7] + sp[32] * PI6[0][0][7] + sp[27] * PI8[0][0][7] + sp[30] * PI9[0][7][0];
    A[106] = sp[33] * PI0[0][7][1] + sp[34] * PI1[0][7][1] + sp[28] * PI2[0][7][1] + sp[31] * PI3[0][7][1] + sp[34] * PI1[0][1][7] + sp[35] * PI4[0][7][1] + sp[29] * PI5[0][7][1] + sp[32] * PI6[0][7][1] + sp[28] * PI2[0][1][7] + sp[29] * PI5[0][1][7] + sp[26] * PI7[0][7][1] + sp[27] * PI8[0][7][1] + sp[31] * PI3[0][1][7] + sp[32] * PI6[0][1][7] + sp[27] * PI8[0][1][7] + sp[30] * PI9[0][7][1];
    A[107] = sp[33] * PI0[0][7][2] + sp[34] * PI1[0][7][2] + sp[28] * PI2[0][7][2] + sp[31] * PI3[0][7][2] + sp[34] * PI1[0][2][7] + sp[35] * PI4[0][7][2] + sp[29] * PI5[0][7][2] + sp[32] * PI6[0][7][2] + sp[28] * PI2[0][2][7] + sp[29] * PI5[0][2][7] + sp[26] * PI7[0][7][2] + sp[27] * PI8[0][7][2] + sp[31] * PI3[0][2][7] + sp[32] * PI6[0][2][7] + sp[27] * PI8[0][2][7] + sp[30] * PI9[0][7][2];
    A[108] = sp[33] * PI0[0][7][3] + sp[34] * PI1[0][7][3] + sp[28] * PI2[0][7][3] + sp[31] * PI3[0][7][3] + sp[34] * PI1[0][3][7] + sp[35] * PI4[0][7][3] + sp[29] * PI5[0][7][3] + sp[32] * PI6[0][7][3] + sp[28] * PI2[0][3][7] + sp[29] * PI5[0][3][7] + sp[26] * PI7[0][7][3] + sp[27] * PI8[0][7][3] + sp[31] * PI3[0][3][7] + sp[32] * PI6[0][3][7] + sp[27] * PI8[0][3][7] + sp[30] * PI9[0][7][3];
    A[109] = sp[33] * PI0[0][7][4] + sp[34] * PI1[0][7][4] + sp[28] * PI2[0][7][4] + sp[31] * PI3[0][7][4] + sp[34] * PI1[0][4][7] + sp[35] * PI4[0][7][4] + sp[29] * PI5[0][7][4] + sp[32] * PI6[0][7][4] + sp[28] * PI2[0][4][7] + sp[29] * PI5[0][4][7] + sp[26] * PI7[0][7][4] + sp[27] * PI8[0][7][4] + sp[31] * PI3[0][4][7] + sp[32] * PI6[0][4][7] + sp[27] * PI8[0][4][7] + sp[30] * PI9[0][7][4];
    A[110] = sp[33] * PI0[0][7][5] + sp[34] * PI1[0][7][5] + sp[28] * PI2[0][7][5] + sp[31] * PI3[0][7][5] + sp[34] * PI1[0][5][7] + sp[35] * PI4[0][7][5] + sp[29] * PI5[0][7][5] + sp[32] * PI6[0][7][5] + sp[28] * PI2[0][5][7] + sp[29] * PI5[0][5][7] + sp[26] * PI7[0][7][5] + sp[27] * PI8[0][7][5] + sp[31] * PI3[0][5][7] + sp[32] * PI6[0][5][7] + sp[27] * PI8[0][5][7] + sp[30] * PI9[0][7][5];
    A[111] = sp[33] * PI0[0][7][6] + sp[34] * PI1[0][7][6] + sp[28] * PI2[0][7][6] + sp[31] * PI3[0][7][6] + sp[34] * PI1[0][6][7] + sp[35] * PI4[0][7][6] + sp[29] * PI5[0][7][6] + sp[32] * PI6[0][7][6] + sp[28] * PI2[0][6][7] + sp[29] * PI5[0][6][7] + sp[26] * PI7[0][7][6] + sp[27] * PI8[0][7][6] + sp[31] * PI3[0][6][7] + sp[32] * PI6[0][6][7] + sp[27] * PI8[0][6][7] + sp[30] * PI9[0][7][6];
    A[112] = sp[33] * PI0[0][7][7] + sp[34] * PI1[0][7][7] + sp[28] * PI2[0][7][7] + sp[31] * PI3[0][7][7] + sp[34] * PI1[0][7][7] + sp[35] * PI4[0][7][7] + sp[29] * PI5[0][7][7] + sp[32] * PI6[0][7][7] + sp[28] * PI2[0][7][7] + sp[29] * PI5[0][7][7] + sp[26] * PI7[0][7][7] + sp[27] * PI8[0][7][7] + sp[31] * PI3[0][7][7] + sp[32] * PI6[0][7][7] + sp[27] * PI8[0][7][7] + sp[30] * PI9[0][7][7];
    A[113] = sp[33] * PI0[0][7][8] + sp[34] * PI1[0][7][8] + sp[28] * PI2[0][7][8] + sp[31] * PI3[0][7][8] + sp[34] * PI1[0][8][7] + sp[35] * PI4[0][7][8] + sp[29] * PI5[0][7][8] + sp[32] * PI6[0][7][8] + sp[28] * PI2[0][8][7] + sp[29] * PI5[0][8][7] + sp[26] * PI7[0][7][8] + sp[27] * PI8[0][7][8] + sp[31] * PI3[0][8][7] + sp[32] * PI6[0][8][7] + sp[27] * PI8[0][8][7] + sp[30] * PI9[0][7][8];
    A[114] = sp[33] * PI0[0][7][9] + sp[34] * PI1[0][7][9] + sp[28] * PI2[0][7][9] + sp[31] * PI3[0][7][9] + sp[34] * PI1[0][9][7] + sp[35] * PI4[0][7][9] + sp[29] * PI5[0][7][9] + sp[32] * PI6[0][7][9] + sp[28] * PI2[0][9][7] + sp[29] * PI5[0][9][7] + sp[26] * PI7[0][7][9] + sp[27] * PI8[0][7][9] + sp[31] * PI3[0][9][7] + sp[32] * PI6[0][9][7] + sp[27] * PI8[0][9][7] + sp[30] * PI9[0][7][9];
    A[115] = sp[33] * PI0[0][7][10] + sp[34] * PI1[0][7][10] + sp[28] * PI2[0][7][10] + sp[31] * PI3[0][7][10] + sp[34] * PI1[0][10][7] + sp[35] * PI4[0][7][10] + sp[29] * PI5[0][7][10] + sp[32] * PI6[0][7][10] + sp[28] * PI2[0][10][7] + sp[29] * PI5[0][10][7] + sp[26] * PI7[0][7][10] + sp[27] * PI8[0][7][10] + sp[31] * PI3[0][10][7] + sp[32] * PI6[0][10][7] + sp[27] * PI8[0][10][7] + sp[30] * PI9[0][7][10];
    A[116] = sp[33] * PI0[0][7][11] + sp[34] * PI1[0][7][11] + sp[28] * PI2[0][7][11] + sp[31] * PI3[0][7][11] + sp[34] * PI1[0][11][7] + sp[35] * PI4[0][7][11] + sp[29] * PI5[0][7][11] + sp[32] * PI6[0][7][11] + sp[28] * PI2[0][11][7] + sp[29] * PI5[0][11][7] + sp[26] * PI7[0][7][11] + sp[27] * PI8[0][7][11] + sp[31] * PI3[0][11][7] + sp[32] * PI6[0][11][7] + sp[27] * PI8[0][11][7] + sp[30] * PI9[0][7][11];
    A[117] = sp[33] * PI0[0][7][12] + sp[34] * PI1[0][7][12] + sp[28] * PI2[0][7][12] + sp[31] * PI3[0][7][12] + sp[34] * PI1[0][12][7] + sp[35] * PI4[0][7][12] + sp[29] * PI5[0][7][12] + sp[32] * PI6[0][7][12] + sp[28] * PI2[0][12][7] + sp[29] * PI5[0][12][7] + sp[26] * PI7[0][7][12] + sp[27] * PI8[0][7][12] + sp[31] * PI3[0][12][7] + sp[32] * PI6[0][12][7] + sp[27] * PI8[0][12][7] + sp[30] * PI9[0][7][12];
    A[118] = sp[33] * PI0[0][7][13] + sp[34] * PI1[0][7][13] + sp[28] * PI2[0][7][13] + sp[31] * PI3[0][7][13] + sp[34] * PI1[0][13][7] + sp[35] * PI4[0][7][13] + sp[29] * PI5[0][7][13] + sp[32] * PI6[0][7][13] + sp[28] * PI2[0][13][7] + sp[29] * PI5[0][13][7] + sp[26] * PI7[0][7][13] + sp[27] * PI8[0][7][13] + sp[31] * PI3[0][13][7] + sp[32] * PI6[0][13][7] + sp[27] * PI8[0][13][7] + sp[30] * PI9[0][7][13];
    A[119] = sp[33] * PI0[0][7][14] + sp[34] * PI1[0][7][14] + sp[28] * PI2[0][7][14] + sp[31] * PI3[0][7][14] + sp[34] * PI1[0][14][7] + sp[35] * PI4[0][7][14] + sp[29] * PI5[0][7][14] + sp[32] * PI6[0][7][14] + sp[28] * PI2[0][14][7] + sp[29] * PI5[0][14][7] + sp[26] * PI7[0][7][14] + sp[27] * PI8[0][7][14] + sp[31] * PI3[0][14][7] + sp[32] * PI6[0][14][7] + sp[27] * PI8[0][14][7] + sp[30] * PI9[0][7][14];
    A[120] = sp[33] * PI0[0][8][0] + sp[34] * PI1[0][8][0] + sp[28] * PI2[0][8][0] + sp[31] * PI3[0][8][0] + sp[34] * PI1[0][0][8] + sp[35] * PI4[0][8][0] + sp[29] * PI5[0][8][0] + sp[32] * PI6[0][8][0] + sp[28] * PI2[0][0][8] + sp[29] * PI5[0][0][8] + sp[26] * PI7[0][8][0] + sp[27] * PI8[0][8][0] + sp[31] * PI3[0][0][8] + sp[32] * PI6[0][0][8] + sp[27] * PI8[0][0][8] + sp[30] * PI9[0][8][0];
    A[121] = sp[33] * PI0[0][8][1] + sp[34] * PI1[0][8][1] + sp[28] * PI2[0][8][1] + sp[31] * PI3[0][8][1] + sp[34] * PI1[0][1][8] + sp[35] * PI4[0][8][1] + sp[29] * PI5[0][8][1] + sp[32] * PI6[0][8][1] + sp[28] * PI2[0][1][8] + sp[29] * PI5[0][1][8] + sp[26] * PI7[0][8][1] + sp[27] * PI8[0][8][1] + sp[31] * PI3[0][1][8] + sp[32] * PI6[0][1][8] + sp[27] * PI8[0][1][8] + sp[30] * PI9[0][8][1];
    A[122] = sp[33] * PI0[0][8][2] + sp[34] * PI1[0][8][2] + sp[28] * PI2[0][8][2] + sp[31] * PI3[0][8][2] + sp[34] * PI1[0][2][8] + sp[35] * PI4[0][8][2] + sp[29] * PI5[0][8][2] + sp[32] * PI6[0][8][2] + sp[28] * PI2[0][2][8] + sp[29] * PI5[0][2][8] + sp[26] * PI7[0][8][2] + sp[27] * PI8[0][8][2] + sp[31] * PI3[0][2][8] + sp[32] * PI6[0][2][8] + sp[27] * PI8[0][2][8] + sp[30] * PI9[0][8][2];
    A[123] = sp[33] * PI0[0][8][3] + sp[34] * PI1[0][8][3] + sp[28] * PI2[0][8][3] + sp[31] * PI3[0][8][3] + sp[34] * PI1[0][3][8] + sp[35] * PI4[0][8][3] + sp[29] * PI5[0][8][3] + sp[32] * PI6[0][8][3] + sp[28] * PI2[0][3][8] + sp[29] * PI5[0][3][8] + sp[26] * PI7[0][8][3] + sp[27] * PI8[0][8][3] + sp[31] * PI3[0][3][8] + sp[32] * PI6[0][3][8] + sp[27] * PI8[0][3][8] + sp[30] * PI9[0][8][3];
    A[124] = sp[33] * PI0[0][8][4] + sp[34] * PI1[0][8][4] + sp[28] * PI2[0][8][4] + sp[31] * PI3[0][8][4] + sp[34] * PI1[0][4][8] + sp[35] * PI4[0][8][4] + sp[29] * PI5[0][8][4] + sp[32] * PI6[0][8][4] + sp[28] * PI2[0][4][8] + sp[29] * PI5[0][4][8] + sp[26] * PI7[0][8][4] + sp[27] * PI8[0][8][4] + sp[31] * PI3[0][4][8] + sp[32] * PI6[0][4][8] + sp[27] * PI8[0][4][8] + sp[30] * PI9[0][8][4];
    A[125] = sp[33] * PI0[0][8][5] + sp[34] * PI1[0][8][5] + sp[28] * PI2[0][8][5] + sp[31] * PI3[0][8][5] + sp[34] * PI1[0][5][8] + sp[35] * PI4[0][8][5] + sp[29] * PI5[0][8][5] + sp[32] * PI6[0][8][5] + sp[28] * PI2[0][5][8] + sp[29] * PI5[0][5][8] + sp[26] * PI7[0][8][5] + sp[27] * PI8[0][8][5] + sp[31] * PI3[0][5][8] + sp[32] * PI6[0][5][8] + sp[27] * PI8[0][5][8] + sp[30] * PI9[0][8][5];
    A[126] = sp[33] * PI0[0][8][6] + sp[34] * PI1[0][8][6] + sp[28] * PI2[0][8][6] + sp[31] * PI3[0][8][6] + sp[34] * PI1[0][6][8] + sp[35] * PI4[0][8][6] + sp[29] * PI5[0][8][6] + sp[32] * PI6[0][8][6] + sp[28] * PI2[0][6][8] + sp[29] * PI5[0][6][8] + sp[26] * PI7[0][8][6] + sp[27] * PI8[0][8][6] + sp[31] * PI3[0][6][8] + sp[32] * PI6[0][6][8] + sp[27] * PI8[0][6][8] + sp[30] * PI9[0][8][6];
    A[127] = sp[33] * PI0[0][8][7] + sp[34] * PI1[0][8][7] + sp[28] * PI2[0][8][7] + sp[31] * PI3[0][8][7] + sp[34] * PI1[0][7][8] + sp[35] * PI4[0][8][7] + sp[29] * PI5[0][8][7] + sp[32] * PI6[0][8][7] + sp[28] * PI2[0][7][8] + sp[29] * PI5[0][7][8] + sp[26] * PI7[0][8][7] + sp[27] * PI8[0][8][7] + sp[31] * PI3[0][7][8] + sp[32] * PI6[0][7][8] + sp[27] * PI8[0][7][8] + sp[30] * PI9[0][8][7];
    A[128] = sp[33] * PI0[0][8][8] + sp[34] * PI1[0][8][8] + sp[28] * PI2[0][8][8] + sp[31] * PI3[0][8][8] + sp[34] * PI1[0][8][8] + sp[35] * PI4[0][8][8] + sp[29] * PI5[0][8][8] + sp[32] * PI6[0][8][8] + sp[28] * PI2[0][8][8] + sp[29] * PI5[0][8][8] + sp[26] * PI7[0][8][8] + sp[27] * PI8[0][8][8] + sp[31] * PI3[0][8][8] + sp[32] * PI6[0][8][8] + sp[27] * PI8[0][8][8] + sp[30] * PI9[0][8][8];
    A[129] = sp[33] * PI0[0][8][9] + sp[34] * PI1[0][8][9] + sp[28] * PI2[0][8][9] + sp[31] * PI3[0][8][9] + sp[34] * PI1[0][9][8] + sp[35] * PI4[0][8][9] + sp[29] * PI5[0][8][9] + sp[32] * PI6[0][8][9] + sp[28] * PI2[0][9][8] + sp[29] * PI5[0][9][8] + sp[26] * PI7[0][8][9] + sp[27] * PI8[0][8][9] + sp[31] * PI3[0][9][8] + sp[32] * PI6[0][9][8] + sp[27] * PI8[0][9][8] + sp[30] * PI9[0][8][9];
    A[130] = sp[33] * PI0[0][8][10] + sp[34] * PI1[0][8][10] + sp[28] * PI2[0][8][10] + sp[31] * PI3[0][8][10] + sp[34] * PI1[0][10][8] + sp[35] * PI4[0][8][10] + sp[29] * PI5[0][8][10] + sp[32] * PI6[0][8][10] + sp[28] * PI2[0][10][8] + sp[29] * PI5[0][10][8] + sp[26] * PI7[0][8][10] + sp[27] * PI8[0][8][10] + sp[31] * PI3[0][10][8] + sp[32] * PI6[0][10][8] + sp[27] * PI8[0][10][8] + sp[30] * PI9[0][8][10];
    A[131] = sp[33] * PI0[0][8][11] + sp[34] * PI1[0][8][11] + sp[28] * PI2[0][8][11] + sp[31] * PI3[0][8][11] + sp[34] * PI1[0][11][8] + sp[35] * PI4[0][8][11] + sp[29] * PI5[0][8][11] + sp[32] * PI6[0][8][11] + sp[28] * PI2[0][11][8] + sp[29] * PI5[0][11][8] + sp[26] * PI7[0][8][11] + sp[27] * PI8[0][8][11] + sp[31] * PI3[0][11][8] + sp[32] * PI6[0][11][8] + sp[27] * PI8[0][11][8] + sp[30] * PI9[0][8][11];
    A[132] = sp[33] * PI0[0][8][12] + sp[34] * PI1[0][8][12] + sp[28] * PI2[0][8][12] + sp[31] * PI3[0][8][12] + sp[34] * PI1[0][12][8] + sp[35] * PI4[0][8][12] + sp[29] * PI5[0][8][12] + sp[32] * PI6[0][8][12] + sp[28] * PI2[0][12][8] + sp[29] * PI5[0][12][8] + sp[26] * PI7[0][8][12] + sp[27] * PI8[0][8][12] + sp[31] * PI3[0][12][8] + sp[32] * PI6[0][12][8] + sp[27] * PI8[0][12][8] + sp[30] * PI9[0][8][12];
    A[133] = sp[33] * PI0[0][8][13] + sp[34] * PI1[0][8][13] + sp[28] * PI2[0][8][13] + sp[31] * PI3[0][8][13] + sp[34] * PI1[0][13][8] + sp[35] * PI4[0][8][13] + sp[29] * PI5[0][8][13] + sp[32] * PI6[0][8][13] + sp[28] * PI2[0][13][8] + sp[29] * PI5[0][13][8] + sp[26] * PI7[0][8][13] + sp[27] * PI8[0][8][13] + sp[31] * PI3[0][13][8] + sp[32] * PI6[0][13][8] + sp[27] * PI8[0][13][8] + sp[30] * PI9[0][8][13];
    A[134] = sp[33] * PI0[0][8][14] + sp[34] * PI1[0][8][14] + sp[28] * PI2[0][8][14] + sp[31] * PI3[0][8][14] + sp[34] * PI1[0][14][8] + sp[35] * PI4[0][8][14] + sp[29] * PI5[0][8][14] + sp[32] * PI6[0][8][14] + sp[28] * PI2[0][14][8] + sp[29] * PI5[0][14][8] + sp[26] * PI7[0][8][14] + sp[27] * PI8[0][8][14] + sp[31] * PI3[0][14][8] + sp[32] * PI6[0][14][8] + sp[27] * PI8[0][14][8] + sp[30] * PI9[0][8][14];
    A[135] = sp[33] * PI0[0][9][0] + sp[34] * PI1[0][9][0] + sp[28] * PI2[0][9][0] + sp[31] * PI3[0][9][0] + sp[34] * PI1[0][0][9] + sp[35] * PI4[0][9][0] + sp[29] * PI5[0][9][0] + sp[32] * PI6[0][9][0] + sp[28] * PI2[0][0][9] + sp[29] * PI5[0][0][9] + sp[26] * PI7[0][9][0] + sp[27] * PI8[0][9][0] + sp[31] * PI3[0][0][9] + sp[32] * PI6[0][0][9] + sp[27] * PI8[0][0][9] + sp[30] * PI9[0][9][0];
    A[136] = sp[33] * PI0[0][9][1] + sp[34] * PI1[0][9][1] + sp[28] * PI2[0][9][1] + sp[31] * PI3[0][9][1] + sp[34] * PI1[0][1][9] + sp[35] * PI4[0][9][1] + sp[29] * PI5[0][9][1] + sp[32] * PI6[0][9][1] + sp[28] * PI2[0][1][9] + sp[29] * PI5[0][1][9] + sp[26] * PI7[0][9][1] + sp[27] * PI8[0][9][1] + sp[31] * PI3[0][1][9] + sp[32] * PI6[0][1][9] + sp[27] * PI8[0][1][9] + sp[30] * PI9[0][9][1];
    A[137] = sp[33] * PI0[0][9][2] + sp[34] * PI1[0][9][2] + sp[28] * PI2[0][9][2] + sp[31] * PI3[0][9][2] + sp[34] * PI1[0][2][9] + sp[35] * PI4[0][9][2] + sp[29] * PI5[0][9][2] + sp[32] * PI6[0][9][2] + sp[28] * PI2[0][2][9] + sp[29] * PI5[0][2][9] + sp[26] * PI7[0][9][2] + sp[27] * PI8[0][9][2] + sp[31] * PI3[0][2][9] + sp[32] * PI6[0][2][9] + sp[27] * PI8[0][2][9] + sp[30] * PI9[0][9][2];
    A[138] = sp[33] * PI0[0][9][3] + sp[34] * PI1[0][9][3] + sp[28] * PI2[0][9][3] + sp[31] * PI3[0][9][3] + sp[34] * PI1[0][3][9] + sp[35] * PI4[0][9][3] + sp[29] * PI5[0][9][3] + sp[32] * PI6[0][9][3] + sp[28] * PI2[0][3][9] + sp[29] * PI5[0][3][9] + sp[26] * PI7[0][9][3] + sp[27] * PI8[0][9][3] + sp[31] * PI3[0][3][9] + sp[32] * PI6[0][3][9] + sp[27] * PI8[0][3][9] + sp[30] * PI9[0][9][3];
    A[139] = sp[33] * PI0[0][9][4] + sp[34] * PI1[0][9][4] + sp[28] * PI2[0][9][4] + sp[31] * PI3[0][9][4] + sp[34] * PI1[0][4][9] + sp[35] * PI4[0][9][4] + sp[29] * PI5[0][9][4] + sp[32] * PI6[0][9][4] + sp[28] * PI2[0][4][9] + sp[29] * PI5[0][4][9] + sp[26] * PI7[0][9][4] + sp[27] * PI8[0][9][4] + sp[31] * PI3[0][4][9] + sp[32] * PI6[0][4][9] + sp[27] * PI8[0][4][9] + sp[30] * PI9[0][9][4];
    A[140] = sp[33] * PI0[0][9][5] + sp[34] * PI1[0][9][5] + sp[28] * PI2[0][9][5] + sp[31] * PI3[0][9][5] + sp[34] * PI1[0][5][9] + sp[35] * PI4[0][9][5] + sp[29] * PI5[0][9][5] + sp[32] * PI6[0][9][5] + sp[28] * PI2[0][5][9] + sp[29] * PI5[0][5][9] + sp[26] * PI7[0][9][5] + sp[27] * PI8[0][9][5] + sp[31] * PI3[0][5][9] + sp[32] * PI6[0][5][9] + sp[27] * PI8[0][5][9] + sp[30] * PI9[0][9][5];
    A[141] = sp[33] * PI0[0][9][6] + sp[34] * PI1[0][9][6] + sp[28] * PI2[0][9][6] + sp[31] * PI3[0][9][6] + sp[34] * PI1[0][6][9] + sp[35] * PI4[0][9][6] + sp[29] * PI5[0][9][6] + sp[32] * PI6[0][9][6] + sp[28] * PI2[0][6][9] + sp[29] * PI5[0][6][9] + sp[26] * PI7[0][9][6] + sp[27] * PI8[0][9][6] + sp[31] * PI3[0][6][9] + sp[32] * PI6[0][6][9] + sp[27] * PI8[0][6][9] + sp[30] * PI9[0][9][6];
    A[142] = sp[33] * PI0[0][9][7] + sp[34] * PI1[0][9][7] + sp[28] * PI2[0][9][7] + sp[31] * PI3[0][9][7] + sp[34] * PI1[0][7][9] + sp[35] * PI4[0][9][7] + sp[29] * PI5[0][9][7] + sp[32] * PI6[0][9][7] + sp[28] * PI2[0][7][9] + sp[29] * PI5[0][7][9] + sp[26] * PI7[0][9][7] + sp[27] * PI8[0][9][7] + sp[31] * PI3[0][7][9] + sp[32] * PI6[0][7][9] + sp[27] * PI8[0][7][9] + sp[30] * PI9[0][9][7];
    A[143] = sp[33] * PI0[0][9][8] + sp[34] * PI1[0][9][8] + sp[28] * PI2[0][9][8] + sp[31] * PI3[0][9][8] + sp[34] * PI1[0][8][9] + sp[35] * PI4[0][9][8] + sp[29] * PI5[0][9][8] + sp[32] * PI6[0][9][8] + sp[28] * PI2[0][8][9] + sp[29] * PI5[0][8][9] + sp[26] * PI7[0][9][8] + sp[27] * PI8[0][9][8] + sp[31] * PI3[0][8][9] + sp[32] * PI6[0][8][9] + sp[27] * PI8[0][8][9] + sp[30] * PI9[0][9][8];
    A[144] = sp[33] * PI0[0][9][9] + sp[34] * PI1[0][9][9] + sp[28] * PI2[0][9][9] + sp[31] * PI3[0][9][9] + sp[34] * PI1[0][9][9] + sp[35] * PI4[0][9][9] + sp[29] * PI5[0][9][9] + sp[32] * PI6[0][9][9] + sp[28] * PI2[0][9][9] + sp[29] * PI5[0][9][9] + sp[26] * PI7[0][9][9] + sp[27] * PI8[0][9][9] + sp[31] * PI3[0][9][9] + sp[32] * PI6[0][9][9] + sp[27] * PI8[0][9][9] + sp[30] * PI9[0][9][9];
    A[145] = sp[33] * PI0[0][9][10] + sp[34] * PI1[0][9][10] + sp[28] * PI2[0][9][10] + sp[31] * PI3[0][9][10] + sp[34] * PI1[0][10][9] + sp[35] * PI4[0][9][10] + sp[29] * PI5[0][9][10] + sp[32] * PI6[0][9][10] + sp[28] * PI2[0][10][9] + sp[29] * PI5[0][10][9] + sp[26] * PI7[0][9][10] + sp[27] * PI8[0][9][10] + sp[31] * PI3[0][10][9] + sp[32] * PI6[0][10][9] + sp[27] * PI8[0][10][9] + sp[30] * PI9[0][9][10];
    A[146] = sp[33] * PI0[0][9][11] + sp[34] * PI1[0][9][11] + sp[28] * PI2[0][9][11] + sp[31] * PI3[0][9][11] + sp[34] * PI1[0][11][9] + sp[35] * PI4[0][9][11] + sp[29] * PI5[0][9][11] + sp[32] * PI6[0][9][11] + sp[28] * PI2[0][11][9] + sp[29] * PI5[0][11][9] + sp[26] * PI7[0][9][11] + sp[27] * PI8[0][9][11] + sp[31] * PI3[0][11][9] + sp[32] * PI6[0][11][9] + sp[27] * PI8[0][11][9] + sp[30] * PI9[0][9][11];
    A[147] = sp[33] * PI0[0][9][12] + sp[34] * PI1[0][9][12] + sp[28] * PI2[0][9][12] + sp[31] * PI3[0][9][12] + sp[34] * PI1[0][12][9] + sp[35] * PI4[0][9][12] + sp[29] * PI5[0][9][12] + sp[32] * PI6[0][9][12] + sp[28] * PI2[0][12][9] + sp[29] * PI5[0][12][9] + sp[26] * PI7[0][9][12] + sp[27] * PI8[0][9][12] + sp[31] * PI3[0][12][9] + sp[32] * PI6[0][12][9] + sp[27] * PI8[0][12][9] + sp[30] * PI9[0][9][12];
    A[148] = sp[33] * PI0[0][9][13] + sp[34] * PI1[0][9][13] + sp[28] * PI2[0][9][13] + sp[31] * PI3[0][9][13] + sp[34] * PI1[0][13][9] + sp[35] * PI4[0][9][13] + sp[29] * PI5[0][9][13] + sp[32] * PI6[0][9][13] + sp[28] * PI2[0][13][9] + sp[29] * PI5[0][13][9] + sp[26] * PI7[0][9][13] + sp[27] * PI8[0][9][13] + sp[31] * PI3[0][13][9] + sp[32] * PI6[0][13][9] + sp[27] * PI8[0][13][9] + sp[30] * PI9[0][9][13];
    A[149] = sp[33] * PI0[0][9][14] + sp[34] * PI1[0][9][14] + sp[28] * PI2[0][9][14] + sp[31] * PI3[0][9][14] + sp[34] * PI1[0][14][9] + sp[35] * PI4[0][9][14] + sp[29] * PI5[0][9][14] + sp[32] * PI6[0][9][14] + sp[28] * PI2[0][14][9] + sp[29] * PI5[0][14][9] + sp[26] * PI7[0][9][14] + sp[27] * PI8[0][9][14] + sp[31] * PI3[0][14][9] + sp[32] * PI6[0][14][9] + sp[27] * PI8[0][14][9] + sp[30] * PI9[0][9][14];
    A[150] = sp[33] * PI0[0][10][0] + sp[34] * PI1[0][10][0] + sp[28] * PI2[0][10][0] + sp[31] * PI3[0][10][0] + sp[34] * PI1[0][0][10] + sp[35] * PI4[0][10][0] + sp[29] * PI5[0][10][0] + sp[32] * PI6[0][10][0] + sp[28] * PI2[0][0][10] + sp[29] * PI5[0][0][10] + sp[26] * PI7[0][10][0] + sp[27] * PI8[0][10][0] + sp[31] * PI3[0][0][10] + sp[32] * PI6[0][0][10] + sp[27] * PI8[0][0][10] + sp[30] * PI9[0][10][0];
    A[151] = sp[33] * PI0[0][10][1] + sp[34] * PI1[0][10][1] + sp[28] * PI2[0][10][1] + sp[31] * PI3[0][10][1] + sp[34] * PI1[0][1][10] + sp[35] * PI4[0][10][1] + sp[29] * PI5[0][10][1] + sp[32] * PI6[0][10][1] + sp[28] * PI2[0][1][10] + sp[29] * PI5[0][1][10] + sp[26] * PI7[0][10][1] + sp[27] * PI8[0][10][1] + sp[31] * PI3[0][1][10] + sp[32] * PI6[0][1][10] + sp[27] * PI8[0][1][10] + sp[30] * PI9[0][10][1];
    A[152] = sp[33] * PI0[0][10][2] + sp[34] * PI1[0][10][2] + sp[28] * PI2[0][10][2] + sp[31] * PI3[0][10][2] + sp[34] * PI1[0][2][10] + sp[35] * PI4[0][10][2] + sp[29] * PI5[0][10][2] + sp[32] * PI6[0][10][2] + sp[28] * PI2[0][2][10] + sp[29] * PI5[0][2][10] + sp[26] * PI7[0][10][2] + sp[27] * PI8[0][10][2] + sp[31] * PI3[0][2][10] + sp[32] * PI6[0][2][10] + sp[27] * PI8[0][2][10] + sp[30] * PI9[0][10][2];
    A[153] = sp[33] * PI0[0][10][3] + sp[34] * PI1[0][10][3] + sp[28] * PI2[0][10][3] + sp[31] * PI3[0][10][3] + sp[34] * PI1[0][3][10] + sp[35] * PI4[0][10][3] + sp[29] * PI5[0][10][3] + sp[32] * PI6[0][10][3] + sp[28] * PI2[0][3][10] + sp[29] * PI5[0][3][10] + sp[26] * PI7[0][10][3] + sp[27] * PI8[0][10][3] + sp[31] * PI3[0][3][10] + sp[32] * PI6[0][3][10] + sp[27] * PI8[0][3][10] + sp[30] * PI9[0][10][3];
    A[154] = sp[33] * PI0[0][10][4] + sp[34] * PI1[0][10][4] + sp[28] * PI2[0][10][4] + sp[31] * PI3[0][10][4] + sp[34] * PI1[0][4][10] + sp[35] * PI4[0][10][4] + sp[29] * PI5[0][10][4] + sp[32] * PI6[0][10][4] + sp[28] * PI2[0][4][10] + sp[29] * PI5[0][4][10] + sp[26] * PI7[0][10][4] + sp[27] * PI8[0][10][4] + sp[31] * PI3[0][4][10] + sp[32] * PI6[0][4][10] + sp[27] * PI8[0][4][10] + sp[30] * PI9[0][10][4];
    A[155] = sp[33] * PI0[0][10][5] + sp[34] * PI1[0][10][5] + sp[28] * PI2[0][10][5] + sp[31] * PI3[0][10][5] + sp[34] * PI1[0][5][10] + sp[35] * PI4[0][10][5] + sp[29] * PI5[0][10][5] + sp[32] * PI6[0][10][5] + sp[28] * PI2[0][5][10] + sp[29] * PI5[0][5][10] + sp[26] * PI7[0][10][5] + sp[27] * PI8[0][10][5] + sp[31] * PI3[0][5][10] + sp[32] * PI6[0][5][10] + sp[27] * PI8[0][5][10] + sp[30] * PI9[0][10][5];
    A[156] = sp[33] * PI0[0][10][6] + sp[34] * PI1[0][10][6] + sp[28] * PI2[0][10][6] + sp[31] * PI3[0][10][6] + sp[34] * PI1[0][6][10] + sp[35] * PI4[0][10][6] + sp[29] * PI5[0][10][6] + sp[32] * PI6[0][10][6] + sp[28] * PI2[0][6][10] + sp[29] * PI5[0][6][10] + sp[26] * PI7[0][10][6] + sp[27] * PI8[0][10][6] + sp[31] * PI3[0][6][10] + sp[32] * PI6[0][6][10] + sp[27] * PI8[0][6][10] + sp[30] * PI9[0][10][6];
    A[157] = sp[33] * PI0[0][10][7] + sp[34] * PI1[0][10][7] + sp[28] * PI2[0][10][7] + sp[31] * PI3[0][10][7] + sp[34] * PI1[0][7][10] + sp[35] * PI4[0][10][7] + sp[29] * PI5[0][10][7] + sp[32] * PI6[0][10][7] + sp[28] * PI2[0][7][10] + sp[29] * PI5[0][7][10] + sp[26] * PI7[0][10][7] + sp[27] * PI8[0][10][7] + sp[31] * PI3[0][7][10] + sp[32] * PI6[0][7][10] + sp[27] * PI8[0][7][10] + sp[30] * PI9[0][10][7];
    A[158] = sp[33] * PI0[0][10][8] + sp[34] * PI1[0][10][8] + sp[28] * PI2[0][10][8] + sp[31] * PI3[0][10][8] + sp[34] * PI1[0][8][10] + sp[35] * PI4[0][10][8] + sp[29] * PI5[0][10][8] + sp[32] * PI6[0][10][8] + sp[28] * PI2[0][8][10] + sp[29] * PI5[0][8][10] + sp[26] * PI7[0][10][8] + sp[27] * PI8[0][10][8] + sp[31] * PI3[0][8][10] + sp[32] * PI6[0][8][10] + sp[27] * PI8[0][8][10] + sp[30] * PI9[0][10][8];
    A[159] = sp[33] * PI0[0][10][9] + sp[34] * PI1[0][10][9] + sp[28] * PI2[0][10][9] + sp[31] * PI3[0][10][9] + sp[34] * PI1[0][9][10] + sp[35] * PI4[0][10][9] + sp[29] * PI5[0][10][9] + sp[32] * PI6[0][10][9] + sp[28] * PI2[0][9][10] + sp[29] * PI5[0][9][10] + sp[26] * PI7[0][10][9] + sp[27] * PI8[0][10][9] + sp[31] * PI3[0][9][10] + sp[32] * PI6[0][9][10] + sp[27] * PI8[0][9][10] + sp[30] * PI9[0][10][9];
    A[160] = sp[33] * PI0[0][10][10] + sp[34] * PI1[0][10][10] + sp[28] * PI2[0][10][10] + sp[31] * PI3[0][10][10] + sp[34] * PI1[0][10][10] + sp[35] * PI4[0][10][10] + sp[29] * PI5[0][10][10] + sp[32] * PI6[0][10][10] + sp[28] * PI2[0][10][10] + sp[29] * PI5[0][10][10] + sp[26] * PI7[0][10][10] + sp[27] * PI8[0][10][10] + sp[31] * PI3[0][10][10] + sp[32] * PI6[0][10][10] + sp[27] * PI8[0][10][10] + sp[30] * PI9[0][10][10];
    A[161] = sp[33] * PI0[0][10][11] + sp[34] * PI1[0][10][11] + sp[28] * PI2[0][10][11] + sp[31] * PI3[0][10][11] + sp[34] * PI1[0][11][10] + sp[35] * PI4[0][10][11] + sp[29] * PI5[0][10][11] + sp[32] * PI6[0][10][11] + sp[28] * PI2[0][11][10] + sp[29] * PI5[0][11][10] + sp[26] * PI7[0][10][11] + sp[27] * PI8[0][10][11] + sp[31] * PI3[0][11][10] + sp[32] * PI6[0][11][10] + sp[27] * PI8[0][11][10] + sp[30] * PI9[0][10][11];
    A[162] = sp[33] * PI0[0][10][12] + sp[34] * PI1[0][10][12] + sp[28] * PI2[0][10][12] + sp[31] * PI3[0][10][12] + sp[34] * PI1[0][12][10] + sp[35] * PI4[0][10][12] + sp[29] * PI5[0][10][12] + sp[32] * PI6[0][10][12] + sp[28] * PI2[0][12][10] + sp[29] * PI5[0][12][10] + sp[26] * PI7[0][10][12] + sp[27] * PI8[0][10][12] + sp[31] * PI3[0][12][10] + sp[32] * PI6[0][12][10] + sp[27] * PI8[0][12][10] + sp[30] * PI9[0][10][12];
    A[163] = sp[33] * PI0[0][10][13] + sp[34] * PI1[0][10][13] + sp[28] * PI2[0][10][13] + sp[31] * PI3[0][10][13] + sp[34] * PI1[0][13][10] + sp[35] * PI4[0][10][13] + sp[29] * PI5[0][10][13] + sp[32] * PI6[0][10][13] + sp[28] * PI2[0][13][10] + sp[29] * PI5[0][13][10] + sp[26] * PI7[0][10][13] + sp[27] * PI8[0][10][13] + sp[31] * PI3[0][13][10] + sp[32] * PI6[0][13][10] + sp[27] * PI8[0][13][10] + sp[30] * PI9[0][10][13];
    A[164] = sp[33] * PI0[0][10][14] + sp[34] * PI1[0][10][14] + sp[28] * PI2[0][10][14] + sp[31] * PI3[0][10][14] + sp[34] * PI1[0][14][10] + sp[35] * PI4[0][10][14] + sp[29] * PI5[0][10][14] + sp[32] * PI6[0][10][14] + sp[28] * PI2[0][14][10] + sp[29] * PI5[0][14][10] + sp[26] * PI7[0][10][14] + sp[27] * PI8[0][10][14] + sp[31] * PI3[0][14][10] + sp[32] * PI6[0][14][10] + sp[27] * PI8[0][14][10] + sp[30] * PI9[0][10][14];
    A[165] = sp[33] * PI0[0][11][0] + sp[34] * PI1[0][11][0] + sp[28] * PI2[0][11][0] + sp[31] * PI3[0][11][0] + sp[34] * PI1[0][0][11] + sp[35] * PI4[0][11][0] + sp[29] * PI5[0][11][0] + sp[32] * PI6[0][11][0] + sp[28] * PI2[0][0][11] + sp[29] * PI5[0][0][11] + sp[26] * PI7[0][11][0] + sp[27] * PI8[0][11][0] + sp[31] * PI3[0][0][11] + sp[32] * PI6[0][0][11] + sp[27] * PI8[0][0][11] + sp[30] * PI9[0][11][0];
    A[166] = sp[33] * PI0[0][11][1] + sp[34] * PI1[0][11][1] + sp[28] * PI2[0][11][1] + sp[31] * PI3[0][11][1] + sp[34] * PI1[0][1][11] + sp[35] * PI4[0][11][1] + sp[29] * PI5[0][11][1] + sp[32] * PI6[0][11][1] + sp[28] * PI2[0][1][11] + sp[29] * PI5[0][1][11] + sp[26] * PI7[0][11][1] + sp[27] * PI8[0][11][1] + sp[31] * PI3[0][1][11] + sp[32] * PI6[0][1][11] + sp[27] * PI8[0][1][11] + sp[30] * PI9[0][11][1];
    A[167] = sp[33] * PI0[0][11][2] + sp[34] * PI1[0][11][2] + sp[28] * PI2[0][11][2] + sp[31] * PI3[0][11][2] + sp[34] * PI1[0][2][11] + sp[35] * PI4[0][11][2] + sp[29] * PI5[0][11][2] + sp[32] * PI6[0][11][2] + sp[28] * PI2[0][2][11] + sp[29] * PI5[0][2][11] + sp[26] * PI7[0][11][2] + sp[27] * PI8[0][11][2] + sp[31] * PI3[0][2][11] + sp[32] * PI6[0][2][11] + sp[27] * PI8[0][2][11] + sp[30] * PI9[0][11][2];
    A[168] = sp[33] * PI0[0][11][3] + sp[34] * PI1[0][11][3] + sp[28] * PI2[0][11][3] + sp[31] * PI3[0][11][3] + sp[34] * PI1[0][3][11] + sp[35] * PI4[0][11][3] + sp[29] * PI5[0][11][3] + sp[32] * PI6[0][11][3] + sp[28] * PI2[0][3][11] + sp[29] * PI5[0][3][11] + sp[26] * PI7[0][11][3] + sp[27] * PI8[0][11][3] + sp[31] * PI3[0][3][11] + sp[32] * PI6[0][3][11] + sp[27] * PI8[0][3][11] + sp[30] * PI9[0][11][3];
    A[169] = sp[33] * PI0[0][11][4] + sp[34] * PI1[0][11][4] + sp[28] * PI2[0][11][4] + sp[31] * PI3[0][11][4] + sp[34] * PI1[0][4][11] + sp[35] * PI4[0][11][4] + sp[29] * PI5[0][11][4] + sp[32] * PI6[0][11][4] + sp[28] * PI2[0][4][11] + sp[29] * PI5[0][4][11] + sp[26] * PI7[0][11][4] + sp[27] * PI8[0][11][4] + sp[31] * PI3[0][4][11] + sp[32] * PI6[0][4][11] + sp[27] * PI8[0][4][11] + sp[30] * PI9[0][11][4];
    A[170] = sp[33] * PI0[0][11][5] + sp[34] * PI1[0][11][5] + sp[28] * PI2[0][11][5] + sp[31] * PI3[0][11][5] + sp[34] * PI1[0][5][11] + sp[35] * PI4[0][11][5] + sp[29] * PI5[0][11][5] + sp[32] * PI6[0][11][5] + sp[28] * PI2[0][5][11] + sp[29] * PI5[0][5][11] + sp[26] * PI7[0][11][5] + sp[27] * PI8[0][11][5] + sp[31] * PI3[0][5][11] + sp[32] * PI6[0][5][11] + sp[27] * PI8[0][5][11] + sp[30] * PI9[0][11][5];
    A[171] = sp[33] * PI0[0][11][6] + sp[34] * PI1[0][11][6] + sp[28] * PI2[0][11][6] + sp[31] * PI3[0][11][6] + sp[34] * PI1[0][6][11] + sp[35] * PI4[0][11][6] + sp[29] * PI5[0][11][6] + sp[32] * PI6[0][11][6] + sp[28] * PI2[0][6][11] + sp[29] * PI5[0][6][11] + sp[26] * PI7[0][11][6] + sp[27] * PI8[0][11][6] + sp[31] * PI3[0][6][11] + sp[32] * PI6[0][6][11] + sp[27] * PI8[0][6][11] + sp[30] * PI9[0][11][6];
    A[172] = sp[33] * PI0[0][11][7] + sp[34] * PI1[0][11][7] + sp[28] * PI2[0][11][7] + sp[31] * PI3[0][11][7] + sp[34] * PI1[0][7][11] + sp[35] * PI4[0][11][7] + sp[29] * PI5[0][11][7] + sp[32] * PI6[0][11][7] + sp[28] * PI2[0][7][11] + sp[29] * PI5[0][7][11] + sp[26] * PI7[0][11][7] + sp[27] * PI8[0][11][7] + sp[31] * PI3[0][7][11] + sp[32] * PI6[0][7][11] + sp[27] * PI8[0][7][11] + sp[30] * PI9[0][11][7];
    A[173] = sp[33] * PI0[0][11][8] + sp[34] * PI1[0][11][8] + sp[28] * PI2[0][11][8] + sp[31] * PI3[0][11][8] + sp[34] * PI1[0][8][11] + sp[35] * PI4[0][11][8] + sp[29] * PI5[0][11][8] + sp[32] * PI6[0][11][8] + sp[28] * PI2[0][8][11] + sp[29] * PI5[0][8][11] + sp[26] * PI7[0][11][8] + sp[27] * PI8[0][11][8] + sp[31] * PI3[0][8][11] + sp[32] * PI6[0][8][11] + sp[27] * PI8[0][8][11] + sp[30] * PI9[0][11][8];
    A[174] = sp[33] * PI0[0][11][9] + sp[34] * PI1[0][11][9] + sp[28] * PI2[0][11][9] + sp[31] * PI3[0][11][9] + sp[34] * PI1[0][9][11] + sp[35] * PI4[0][11][9] + sp[29] * PI5[0][11][9] + sp[32] * PI6[0][11][9] + sp[28] * PI2[0][9][11] + sp[29] * PI5[0][9][11] + sp[26] * PI7[0][11][9] + sp[27] * PI8[0][11][9] + sp[31] * PI3[0][9][11] + sp[32] * PI6[0][9][11] + sp[27] * PI8[0][9][11] + sp[30] * PI9[0][11][9];
    A[175] = sp[33] * PI0[0][11][10] + sp[34] * PI1[0][11][10] + sp[28] * PI2[0][11][10] + sp[31] * PI3[0][11][10] + sp[34] * PI1[0][10][11] + sp[35] * PI4[0][11][10] + sp[29] * PI5[0][11][10] + sp[32] * PI6[0][11][10] + sp[28] * PI2[0][10][11] + sp[29] * PI5[0][10][11] + sp[26] * PI7[0][11][10] + sp[27] * PI8[0][11][10] + sp[31] * PI3[0][10][11] + sp[32] * PI6[0][10][11] + sp[27] * PI8[0][10][11] + sp[30] * PI9[0][11][10];
    A[176] = sp[33] * PI0[0][11][11] + sp[34] * PI1[0][11][11] + sp[28] * PI2[0][11][11] + sp[31] * PI3[0][11][11] + sp[34] * PI1[0][11][11] + sp[35] * PI4[0][11][11] + sp[29] * PI5[0][11][11] + sp[32] * PI6[0][11][11] + sp[28] * PI2[0][11][11] + sp[29] * PI5[0][11][11] + sp[26] * PI7[0][11][11] + sp[27] * PI8[0][11][11] + sp[31] * PI3[0][11][11] + sp[32] * PI6[0][11][11] + sp[27] * PI8[0][11][11] + sp[30] * PI9[0][11][11];
    A[177] = sp[33] * PI0[0][11][12] + sp[34] * PI1[0][11][12] + sp[28] * PI2[0][11][12] + sp[31] * PI3[0][11][12] + sp[34] * PI1[0][12][11] + sp[35] * PI4[0][11][12] + sp[29] * PI5[0][11][12] + sp[32] * PI6[0][11][12] + sp[28] * PI2[0][12][11] + sp[29] * PI5[0][12][11] + sp[26] * PI7[0][11][12] + sp[27] * PI8[0][11][12] + sp[31] * PI3[0][12][11] + sp[32] * PI6[0][12][11] + sp[27] * PI8[0][12][11] + sp[30] * PI9[0][11][12];
    A[178] = sp[33] * PI0[0][11][13] + sp[34] * PI1[0][11][13] + sp[28] * PI2[0][11][13] + sp[31] * PI3[0][11][13] + sp[34] * PI1[0][13][11] + sp[35] * PI4[0][11][13] + sp[29] * PI5[0][11][13] + sp[32] * PI6[0][11][13] + sp[28] * PI2[0][13][11] + sp[29] * PI5[0][13][11] + sp[26] * PI7[0][11][13] + sp[27] * PI8[0][11][13] + sp[31] * PI3[0][13][11] + sp[32] * PI6[0][13][11] + sp[27] * PI8[0][13][11] + sp[30] * PI9[0][11][13];
    A[179] = sp[33] * PI0[0][11][14] + sp[34] * PI1[0][11][14] + sp[28] * PI2[0][11][14] + sp[31] * PI3[0][11][14] + sp[34] * PI1[0][14][11] + sp[35] * PI4[0][11][14] + sp[29] * PI5[0][11][14] + sp[32] * PI6[0][11][14] + sp[28] * PI2[0][14][11] + sp[29] * PI5[0][14][11] + sp[26] * PI7[0][11][14] + sp[27] * PI8[0][11][14] + sp[31] * PI3[0][14][11] + sp[32] * PI6[0][14][11] + sp[27] * PI8[0][14][11] + sp[30] * PI9[0][11][14];
    A[180] = sp[33] * PI0[0][12][0] + sp[34] * PI1[0][12][0] + sp[28] * PI2[0][12][0] + sp[31] * PI3[0][12][0] + sp[34] * PI1[0][0][12] + sp[35] * PI4[0][12][0] + sp[29] * PI5[0][12][0] + sp[32] * PI6[0][12][0] + sp[28] * PI2[0][0][12] + sp[29] * PI5[0][0][12] + sp[26] * PI7[0][12][0] + sp[27] * PI8[0][12][0] + sp[31] * PI3[0][0][12] + sp[32] * PI6[0][0][12] + sp[27] * PI8[0][0][12] + sp[30] * PI9[0][12][0];
    A[181] = sp[33] * PI0[0][12][1] + sp[34] * PI1[0][12][1] + sp[28] * PI2[0][12][1] + sp[31] * PI3[0][12][1] + sp[34] * PI1[0][1][12] + sp[35] * PI4[0][12][1] + sp[29] * PI5[0][12][1] + sp[32] * PI6[0][12][1] + sp[28] * PI2[0][1][12] + sp[29] * PI5[0][1][12] + sp[26] * PI7[0][12][1] + sp[27] * PI8[0][12][1] + sp[31] * PI3[0][1][12] + sp[32] * PI6[0][1][12] + sp[27] * PI8[0][1][12] + sp[30] * PI9[0][12][1];
    A[182] = sp[33] * PI0[0][12][2] + sp[34] * PI1[0][12][2] + sp[28] * PI2[0][12][2] + sp[31] * PI3[0][12][2] + sp[34] * PI1[0][2][12] + sp[35] * PI4[0][12][2] + sp[29] * PI5[0][12][2] + sp[32] * PI6[0][12][2] + sp[28] * PI2[0][2][12] + sp[29] * PI5[0][2][12] + sp[26] * PI7[0][12][2] + sp[27] * PI8[0][12][2] + sp[31] * PI3[0][2][12] + sp[32] * PI6[0][2][12] + sp[27] * PI8[0][2][12] + sp[30] * PI9[0][12][2];
    A[183] = sp[33] * PI0[0][12][3] + sp[34] * PI1[0][12][3] + sp[28] * PI2[0][12][3] + sp[31] * PI3[0][12][3] + sp[34] * PI1[0][3][12] + sp[35] * PI4[0][12][3] + sp[29] * PI5[0][12][3] + sp[32] * PI6[0][12][3] + sp[28] * PI2[0][3][12] + sp[29] * PI5[0][3][12] + sp[26] * PI7[0][12][3] + sp[27] * PI8[0][12][3] + sp[31] * PI3[0][3][12] + sp[32] * PI6[0][3][12] + sp[27] * PI8[0][3][12] + sp[30] * PI9[0][12][3];
    A[184] = sp[33] * PI0[0][12][4] + sp[34] * PI1[0][12][4] + sp[28] * PI2[0][12][4] + sp[31] * PI3[0][12][4] + sp[34] * PI1[0][4][12] + sp[35] * PI4[0][12][4] + sp[29] * PI5[0][12][4] + sp[32] * PI6[0][12][4] + sp[28] * PI2[0][4][12] + sp[29] * PI5[0][4][12] + sp[26] * PI7[0][12][4] + sp[27] * PI8[0][12][4] + sp[31] * PI3[0][4][12] + sp[32] * PI6[0][4][12] + sp[27] * PI8[0][4][12] + sp[30] * PI9[0][12][4];
    A[185] = sp[33] * PI0[0][12][5] + sp[34] * PI1[0][12][5] + sp[28] * PI2[0][12][5] + sp[31] * PI3[0][12][5] + sp[34] * PI1[0][5][12] + sp[35] * PI4[0][12][5] + sp[29] * PI5[0][12][5] + sp[32] * PI6[0][12][5] + sp[28] * PI2[0][5][12] + sp[29] * PI5[0][5][12] + sp[26] * PI7[0][12][5] + sp[27] * PI8[0][12][5] + sp[31] * PI3[0][5][12] + sp[32] * PI6[0][5][12] + sp[27] * PI8[0][5][12] + sp[30] * PI9[0][12][5];
    A[186] = sp[33] * PI0[0][12][6] + sp[34] * PI1[0][12][6] + sp[28] * PI2[0][12][6] + sp[31] * PI3[0][12][6] + sp[34] * PI1[0][6][12] + sp[35] * PI4[0][12][6] + sp[29] * PI5[0][12][6] + sp[32] * PI6[0][12][6] + sp[28] * PI2[0][6][12] + sp[29] * PI5[0][6][12] + sp[26] * PI7[0][12][6] + sp[27] * PI8[0][12][6] + sp[31] * PI3[0][6][12] + sp[32] * PI6[0][6][12] + sp[27] * PI8[0][6][12] + sp[30] * PI9[0][12][6];
    A[187] = sp[33] * PI0[0][12][7] + sp[34] * PI1[0][12][7] + sp[28] * PI2[0][12][7] + sp[31] * PI3[0][12][7] + sp[34] * PI1[0][7][12] + sp[35] * PI4[0][12][7] + sp[29] * PI5[0][12][7] + sp[32] * PI6[0][12][7] + sp[28] * PI2[0][7][12] + sp[29] * PI5[0][7][12] + sp[26] * PI7[0][12][7] + sp[27] * PI8[0][12][7] + sp[31] * PI3[0][7][12] + sp[32] * PI6[0][7][12] + sp[27] * PI8[0][7][12] + sp[30] * PI9[0][12][7];
    A[188] = sp[33] * PI0[0][12][8] + sp[34] * PI1[0][12][8] + sp[28] * PI2[0][12][8] + sp[31] * PI3[0][12][8] + sp[34] * PI1[0][8][12] + sp[35] * PI4[0][12][8] + sp[29] * PI5[0][12][8] + sp[32] * PI6[0][12][8] + sp[28] * PI2[0][8][12] + sp[29] * PI5[0][8][12] + sp[26] * PI7[0][12][8] + sp[27] * PI8[0][12][8] + sp[31] * PI3[0][8][12] + sp[32] * PI6[0][8][12] + sp[27] * PI8[0][8][12] + sp[30] * PI9[0][12][8];
    A[189] = sp[33] * PI0[0][12][9] + sp[34] * PI1[0][12][9] + sp[28] * PI2[0][12][9] + sp[31] * PI3[0][12][9] + sp[34] * PI1[0][9][12] + sp[35] * PI4[0][12][9] + sp[29] * PI5[0][12][9] + sp[32] * PI6[0][12][9] + sp[28] * PI2[0][9][12] + sp[29] * PI5[0][9][12] + sp[26] * PI7[0][12][9] + sp[27] * PI8[0][12][9] + sp[31] * PI3[0][9][12] + sp[32] * PI6[0][9][12] + sp[27] * PI8[0][9][12] + sp[30] * PI9[0][12][9];
    A[190] = sp[33] * PI0[0][12][10] + sp[34] * PI1[0][12][10] + sp[28] * PI2[0][12][10] + sp[31] * PI3[0][12][10] + sp[34] * PI1[0][10][12] + sp[35] * PI4[0][12][10] + sp[29] * PI5[0][12][10] + sp[32] * PI6[0][12][10] + sp[28] * PI2[0][10][12] + sp[29] * PI5[0][10][12] + sp[26] * PI7[0][12][10] + sp[27] * PI8[0][12][10] + sp[31] * PI3[0][10][12] + sp[32] * PI6[0][10][12] + sp[27] * PI8[0][10][12] + sp[30] * PI9[0][12][10];
    A[191] = sp[33] * PI0[0][12][11] + sp[34] * PI1[0][12][11] + sp[28] * PI2[0][12][11] + sp[31] * PI3[0][12][11] + sp[34] * PI1[0][11][12] + sp[35] * PI4[0][12][11] + sp[29] * PI5[0][12][11] + sp[32] * PI6[0][12][11] + sp[28] * PI2[0][11][12] + sp[29] * PI5[0][11][12] + sp[26] * PI7[0][12][11] + sp[27] * PI8[0][12][11] + sp[31] * PI3[0][11][12] + sp[32] * PI6[0][11][12] + sp[27] * PI8[0][11][12] + sp[30] * PI9[0][12][11];
    A[192] = sp[33] * PI0[0][12][12] + sp[34] * PI1[0][12][12] + sp[28] * PI2[0][12][12] + sp[31] * PI3[0][12][12] + sp[34] * PI1[0][12][12] + sp[35] * PI4[0][12][12] + sp[29] * PI5[0][12][12] + sp[32] * PI6[0][12][12] + sp[28] * PI2[0][12][12] + sp[29] * PI5[0][12][12] + sp[26] * PI7[0][12][12] + sp[27] * PI8[0][12][12] + sp[31] * PI3[0][12][12] + sp[32] * PI6[0][12][12] + sp[27] * PI8[0][12][12] + sp[30] * PI9[0][12][12];
    A[193] = sp[33] * PI0[0][12][13] + sp[34] * PI1[0][12][13] + sp[28] * PI2[0][12][13] + sp[31] * PI3[0][12][13] + sp[34] * PI1[0][13][12] + sp[35] * PI4[0][12][13] + sp[29] * PI5[0][12][13] + sp[32] * PI6[0][12][13] + sp[28] * PI2[0][13][12] + sp[29] * PI5[0][13][12] + sp[26] * PI7[0][12][13] + sp[27] * PI8[0][12][13] + sp[31] * PI3[0][13][12] + sp[32] * PI6[0][13][12] + sp[27] * PI8[0][13][12] + sp[30] * PI9[0][12][13];
    A[194] = sp[33] * PI0[0][12][14] + sp[34] * PI1[0][12][14] + sp[28] * PI2[0][12][14] + sp[31] * PI3[0][12][14] + sp[34] * PI1[0][14][12] + sp[35] * PI4[0][12][14] + sp[29] * PI5[0][12][14] + sp[32] * PI6[0][12][14] + sp[28] * PI2[0][14][12] + sp[29] * PI5[0][14][12] + sp[26] * PI7[0][12][14] + sp[27] * PI8[0][12][14] + sp[31] * PI3[0][14][12] + sp[32] * PI6[0][14][12] + sp[27] * PI8[0][14][12] + sp[30] * PI9[0][12][14];
    A[195] = sp[33] * PI0[0][13][0] + sp[34] * PI1[0][13][0] + sp[28] * PI2[0][13][0] + sp[31] * PI3[0][13][0] + sp[34] * PI1[0][0][13] + sp[35] * PI4[0][13][0] + sp[29] * PI5[0][13][0] + sp[32] * PI6[0][13][0] + sp[28] * PI2[0][0][13] + sp[29] * PI5[0][0][13] + sp[26] * PI7[0][13][0] + sp[27] * PI8[0][13][0] + sp[31] * PI3[0][0][13] + sp[32] * PI6[0][0][13] + sp[27] * PI8[0][0][13] + sp[30] * PI9[0][13][0];
    A[196] = sp[33] * PI0[0][13][1] + sp[34] * PI1[0][13][1] + sp[28] * PI2[0][13][1] + sp[31] * PI3[0][13][1] + sp[34] * PI1[0][1][13] + sp[35] * PI4[0][13][1] + sp[29] * PI5[0][13][1] + sp[32] * PI6[0][13][1] + sp[28] * PI2[0][1][13] + sp[29] * PI5[0][1][13] + sp[26] * PI7[0][13][1] + sp[27] * PI8[0][13][1] + sp[31] * PI3[0][1][13] + sp[32] * PI6[0][1][13] + sp[27] * PI8[0][1][13] + sp[30] * PI9[0][13][1];
    A[197] = sp[33] * PI0[0][13][2] + sp[34] * PI1[0][13][2] + sp[28] * PI2[0][13][2] + sp[31] * PI3[0][13][2] + sp[34] * PI1[0][2][13] + sp[35] * PI4[0][13][2] + sp[29] * PI5[0][13][2] + sp[32] * PI6[0][13][2] + sp[28] * PI2[0][2][13] + sp[29] * PI5[0][2][13] + sp[26] * PI7[0][13][2] + sp[27] * PI8[0][13][2] + sp[31] * PI3[0][2][13] + sp[32] * PI6[0][2][13] + sp[27] * PI8[0][2][13] + sp[30] * PI9[0][13][2];
    A[198] = sp[33] * PI0[0][13][3] + sp[34] * PI1[0][13][3] + sp[28] * PI2[0][13][3] + sp[31] * PI3[0][13][3] + sp[34] * PI1[0][3][13] + sp[35] * PI4[0][13][3] + sp[29] * PI5[0][13][3] + sp[32] * PI6[0][13][3] + sp[28] * PI2[0][3][13] + sp[29] * PI5[0][3][13] + sp[26] * PI7[0][13][3] + sp[27] * PI8[0][13][3] + sp[31] * PI3[0][3][13] + sp[32] * PI6[0][3][13] + sp[27] * PI8[0][3][13] + sp[30] * PI9[0][13][3];
    A[199] = sp[33] * PI0[0][13][4] + sp[34] * PI1[0][13][4] + sp[28] * PI2[0][13][4] + sp[31] * PI3[0][13][4] + sp[34] * PI1[0][4][13] + sp[35] * PI4[0][13][4] + sp[29] * PI5[0][13][4] + sp[32] * PI6[0][13][4] + sp[28] * PI2[0][4][13] + sp[29] * PI5[0][4][13] + sp[26] * PI7[0][13][4] + sp[27] * PI8[0][13][4] + sp[31] * PI3[0][4][13] + sp[32] * PI6[0][4][13] + sp[27] * PI8[0][4][13] + sp[30] * PI9[0][13][4];
    A[200] = sp[33] * PI0[0][13][5] + sp[34] * PI1[0][13][5] + sp[28] * PI2[0][13][5] + sp[31] * PI3[0][13][5] + sp[34] * PI1[0][5][13] + sp[35] * PI4[0][13][5] + sp[29] * PI5[0][13][5] + sp[32] * PI6[0][13][5] + sp[28] * PI2[0][5][13] + sp[29] * PI5[0][5][13] + sp[26] * PI7[0][13][5] + sp[27] * PI8[0][13][5] + sp[31] * PI3[0][5][13] + sp[32] * PI6[0][5][13] + sp[27] * PI8[0][5][13] + sp[30] * PI9[0][13][5];
    A[201] = sp[33] * PI0[0][13][6] + sp[34] * PI1[0][13][6] + sp[28] * PI2[0][13][6] + sp[31] * PI3[0][13][6] + sp[34] * PI1[0][6][13] + sp[35] * PI4[0][13][6] + sp[29] * PI5[0][13][6] + sp[32] * PI6[0][13][6] + sp[28] * PI2[0][6][13] + sp[29] * PI5[0][6][13] + sp[26] * PI7[0][13][6] + sp[27] * PI8[0][13][6] + sp[31] * PI3[0][6][13] + sp[32] * PI6[0][6][13] + sp[27] * PI8[0][6][13] + sp[30] * PI9[0][13][6];
    A[202] = sp[33] * PI0[0][13][7] + sp[34] * PI1[0][13][7] + sp[28] * PI2[0][13][7] + sp[31] * PI3[0][13][7] + sp[34] * PI1[0][7][13] + sp[35] * PI4[0][13][7] + sp[29] * PI5[0][13][7] + sp[32] * PI6[0][13][7] + sp[28] * PI2[0][7][13] + sp[29] * PI5[0][7][13] + sp[26] * PI7[0][13][7] + sp[27] * PI8[0][13][7] + sp[31] * PI3[0][7][13] + sp[32] * PI6[0][7][13] + sp[27] * PI8[0][7][13] + sp[30] * PI9[0][13][7];
    A[203] = sp[33] * PI0[0][13][8] + sp[34] * PI1[0][13][8] + sp[28] * PI2[0][13][8] + sp[31] * PI3[0][13][8] + sp[34] * PI1[0][8][13] + sp[35] * PI4[0][13][8] + sp[29] * PI5[0][13][8] + sp[32] * PI6[0][13][8] + sp[28] * PI2[0][8][13] + sp[29] * PI5[0][8][13] + sp[26] * PI7[0][13][8] + sp[27] * PI8[0][13][8] + sp[31] * PI3[0][8][13] + sp[32] * PI6[0][8][13] + sp[27] * PI8[0][8][13] + sp[30] * PI9[0][13][8];
    A[204] = sp[33] * PI0[0][13][9] + sp[34] * PI1[0][13][9] + sp[28] * PI2[0][13][9] + sp[31] * PI3[0][13][9] + sp[34] * PI1[0][9][13] + sp[35] * PI4[0][13][9] + sp[29] * PI5[0][13][9] + sp[32] * PI6[0][13][9] + sp[28] * PI2[0][9][13] + sp[29] * PI5[0][9][13] + sp[26] * PI7[0][13][9] + sp[27] * PI8[0][13][9] + sp[31] * PI3[0][9][13] + sp[32] * PI6[0][9][13] + sp[27] * PI8[0][9][13] + sp[30] * PI9[0][13][9];
    A[205] = sp[33] * PI0[0][13][10] + sp[34] * PI1[0][13][10] + sp[28] * PI2[0][13][10] + sp[31] * PI3[0][13][10] + sp[34] * PI1[0][10][13] + sp[35] * PI4[0][13][10] + sp[29] * PI5[0][13][10] + sp[32] * PI6[0][13][10] + sp[28] * PI2[0][10][13] + sp[29] * PI5[0][10][13] + sp[26] * PI7[0][13][10] + sp[27] * PI8[0][13][10] + sp[31] * PI3[0][10][13] + sp[32] * PI6[0][10][13] + sp[27] * PI8[0][10][13] + sp[30] * PI9[0][13][10];
    A[206] = sp[33] * PI0[0][13][11] + sp[34] * PI1[0][13][11] + sp[28] * PI2[0][13][11] + sp[31] * PI3[0][13][11] + sp[34] * PI1[0][11][13] + sp[35] * PI4[0][13][11] + sp[29] * PI5[0][13][11] + sp[32] * PI6[0][13][11] + sp[28] * PI2[0][11][13] + sp[29] * PI5[0][11][13] + sp[26] * PI7[0][13][11] + sp[27] * PI8[0][13][11] + sp[31] * PI3[0][11][13] + sp[32] * PI6[0][11][13] + sp[27] * PI8[0][11][13] + sp[30] * PI9[0][13][11];
    A[207] = sp[33] * PI0[0][13][12] + sp[34] * PI1[0][13][12] + sp[28] * PI2[0][13][12] + sp[31] * PI3[0][13][12] + sp[34] * PI1[0][12][13] + sp[35] * PI4[0][13][12] + sp[29] * PI5[0][13][12] + sp[32] * PI6[0][13][12] + sp[28] * PI2[0][12][13] + sp[29] * PI5[0][12][13] + sp[26] * PI7[0][13][12] + sp[27] * PI8[0][13][12] + sp[31] * PI3[0][12][13] + sp[32] * PI6[0][12][13] + sp[27] * PI8[0][12][13] + sp[30] * PI9[0][13][12];
    A[208] = sp[33] * PI0[0][13][13] + sp[34] * PI1[0][13][13] + sp[28] * PI2[0][13][13] + sp[31] * PI3[0][13][13] + sp[34] * PI1[0][13][13] + sp[35] * PI4[0][13][13] + sp[29] * PI5[0][13][13] + sp[32] * PI6[0][13][13] + sp[28] * PI2[0][13][13] + sp[29] * PI5[0][13][13] + sp[26] * PI7[0][13][13] + sp[27] * PI8[0][13][13] + sp[31] * PI3[0][13][13] + sp[32] * PI6[0][13][13] + sp[27] * PI8[0][13][13] + sp[30] * PI9[0][13][13];
    A[209] = sp[33] * PI0[0][13][14] + sp[34] * PI1[0][13][14] + sp[28] * PI2[0][13][14] + sp[31] * PI3[0][13][14] + sp[34] * PI1[0][14][13] + sp[35] * PI4[0][13][14] + sp[29] * PI5[0][13][14] + sp[32] * PI6[0][13][14] + sp[28] * PI2[0][14][13] + sp[29] * PI5[0][14][13] + sp[26] * PI7[0][13][14] + sp[27] * PI8[0][13][14] + sp[31] * PI3[0][14][13] + sp[32] * PI6[0][14][13] + sp[27] * PI8[0][14][13] + sp[30] * PI9[0][13][14];
    A[210] = sp[33] * PI0[0][14][0] + sp[34] * PI1[0][14][0] + sp[28] * PI2[0][14][0] + sp[31] * PI3[0][14][0] + sp[34] * PI1[0][0][14] + sp[35] * PI4[0][14][0] + sp[29] * PI5[0][14][0] + sp[32] * PI6[0][14][0] + sp[28] * PI2[0][0][14] + sp[29] * PI5[0][0][14] + sp[26] * PI7[0][14][0] + sp[27] * PI8[0][14][0] + sp[31] * PI3[0][0][14] + sp[32] * PI6[0][0][14] + sp[27] * PI8[0][0][14] + sp[30] * PI9[0][14][0];
    A[211] = sp[33] * PI0[0][14][1] + sp[34] * PI1[0][14][1] + sp[28] * PI2[0][14][1] + sp[31] * PI3[0][14][1] + sp[34] * PI1[0][1][14] + sp[35] * PI4[0][14][1] + sp[29] * PI5[0][14][1] + sp[32] * PI6[0][14][1] + sp[28] * PI2[0][1][14] + sp[29] * PI5[0][1][14] + sp[26] * PI7[0][14][1] + sp[27] * PI8[0][14][1] + sp[31] * PI3[0][1][14] + sp[32] * PI6[0][1][14] + sp[27] * PI8[0][1][14] + sp[30] * PI9[0][14][1];
    A[212] = sp[33] * PI0[0][14][2] + sp[34] * PI1[0][14][2] + sp[28] * PI2[0][14][2] + sp[31] * PI3[0][14][2] + sp[34] * PI1[0][2][14] + sp[35] * PI4[0][14][2] + sp[29] * PI5[0][14][2] + sp[32] * PI6[0][14][2] + sp[28] * PI2[0][2][14] + sp[29] * PI5[0][2][14] + sp[26] * PI7[0][14][2] + sp[27] * PI8[0][14][2] + sp[31] * PI3[0][2][14] + sp[32] * PI6[0][2][14] + sp[27] * PI8[0][2][14] + sp[30] * PI9[0][14][2];
    A[213] = sp[33] * PI0[0][14][3] + sp[34] * PI1[0][14][3] + sp[28] * PI2[0][14][3] + sp[31] * PI3[0][14][3] + sp[34] * PI1[0][3][14] + sp[35] * PI4[0][14][3] + sp[29] * PI5[0][14][3] + sp[32] * PI6[0][14][3] + sp[28] * PI2[0][3][14] + sp[29] * PI5[0][3][14] + sp[26] * PI7[0][14][3] + sp[27] * PI8[0][14][3] + sp[31] * PI3[0][3][14] + sp[32] * PI6[0][3][14] + sp[27] * PI8[0][3][14] + sp[30] * PI9[0][14][3];
    A[214] = sp[33] * PI0[0][14][4] + sp[34] * PI1[0][14][4] + sp[28] * PI2[0][14][4] + sp[31] * PI3[0][14][4] + sp[34] * PI1[0][4][14] + sp[35] * PI4[0][14][4] + sp[29] * PI5[0][14][4] + sp[32] * PI6[0][14][4] + sp[28] * PI2[0][4][14] + sp[29] * PI5[0][4][14] + sp[26] * PI7[0][14][4] + sp[27] * PI8[0][14][4] + sp[31] * PI3[0][4][14] + sp[32] * PI6[0][4][14] + sp[27] * PI8[0][4][14] + sp[30] * PI9[0][14][4];
    A[215] = sp[33] * PI0[0][14][5] + sp[34] * PI1[0][14][5] + sp[28] * PI2[0][14][5] + sp[31] * PI3[0][14][5] + sp[34] * PI1[0][5][14] + sp[35] * PI4[0][14][5] + sp[29] * PI5[0][14][5] + sp[32] * PI6[0][14][5] + sp[28] * PI2[0][5][14] + sp[29] * PI5[0][5][14] + sp[26] * PI7[0][14][5] + sp[27] * PI8[0][14][5] + sp[31] * PI3[0][5][14] + sp[32] * PI6[0][5][14] + sp[27] * PI8[0][5][14] + sp[30] * PI9[0][14][5];
    A[216] = sp[33] * PI0[0][14][6] + sp[34] * PI1[0][14][6] + sp[28] * PI2[0][14][6] + sp[31] * PI3[0][14][6] + sp[34] * PI1[0][6][14] + sp[35] * PI4[0][14][6] + sp[29] * PI5[0][14][6] + sp[32] * PI6[0][14][6] + sp[28] * PI2[0][6][14] + sp[29] * PI5[0][6][14] + sp[26] * PI7[0][14][6] + sp[27] * PI8[0][14][6] + sp[31] * PI3[0][6][14] + sp[32] * PI6[0][6][14] + sp[27] * PI8[0][6][14] + sp[30] * PI9[0][14][6];
    A[217] = sp[33] * PI0[0][14][7] + sp[34] * PI1[0][14][7] + sp[28] * PI2[0][14][7] + sp[31] * PI3[0][14][7] + sp[34] * PI1[0][7][14] + sp[35] * PI4[0][14][7] + sp[29] * PI5[0][14][7] + sp[32] * PI6[0][14][7] + sp[28] * PI2[0][7][14] + sp[29] * PI5[0][7][14] + sp[26] * PI7[0][14][7] + sp[27] * PI8[0][14][7] + sp[31] * PI3[0][7][14] + sp[32] * PI6[0][7][14] + sp[27] * PI8[0][7][14] + sp[30] * PI9[0][14][7];
    A[218] = sp[33] * PI0[0][14][8] + sp[34] * PI1[0][14][8] + sp[28] * PI2[0][14][8] + sp[31] * PI3[0][14][8] + sp[34] * PI1[0][8][14] + sp[35] * PI4[0][14][8] + sp[29] * PI5[0][14][8] + sp[32] * PI6[0][14][8] + sp[28] * PI2[0][8][14] + sp[29] * PI5[0][8][14] + sp[26] * PI7[0][14][8] + sp[27] * PI8[0][14][8] + sp[31] * PI3[0][8][14] + sp[32] * PI6[0][8][14] + sp[27] * PI8[0][8][14] + sp[30] * PI9[0][14][8];
    A[219] = sp[33] * PI0[0][14][9] + sp[34] * PI1[0][14][9] + sp[28] * PI2[0][14][9] + sp[31] * PI3[0][14][9] + sp[34] * PI1[0][9][14] + sp[35] * PI4[0][14][9] + sp[29] * PI5[0][14][9] + sp[32] * PI6[0][14][9] + sp[28] * PI2[0][9][14] + sp[29] * PI5[0][9][14] + sp[26] * PI7[0][14][9] + sp[27] * PI8[0][14][9] + sp[31] * PI3[0][9][14] + sp[32] * PI6[0][9][14] + sp[27] * PI8[0][9][14] + sp[30] * PI9[0][14][9];
    A[220] = sp[33] * PI0[0][14][10] + sp[34] * PI1[0][14][10] + sp[28] * PI2[0][14][10] + sp[31] * PI3[0][14][10] + sp[34] * PI1[0][10][14] + sp[35] * PI4[0][14][10] + sp[29] * PI5[0][14][10] + sp[32] * PI6[0][14][10] + sp[28] * PI2[0][10][14] + sp[29] * PI5[0][10][14] + sp[26] * PI7[0][14][10] + sp[27] * PI8[0][14][10] + sp[31] * PI3[0][10][14] + sp[32] * PI6[0][10][14] + sp[27] * PI8[0][10][14] + sp[30] * PI9[0][14][10];
    A[221] = sp[33] * PI0[0][14][11] + sp[34] * PI1[0][14][11] + sp[28] * PI2[0][14][11] + sp[31] * PI3[0][14][11] + sp[34] * PI1[0][11][14] + sp[35] * PI4[0][14][11] + sp[29] * PI5[0][14][11] + sp[32] * PI6[0][14][11] + sp[28] * PI2[0][11][14] + sp[29] * PI5[0][11][14] + sp[26] * PI7[0][14][11] + sp[27] * PI8[0][14][11] + sp[31] * PI3[0][11][14] + sp[32] * PI6[0][11][14] + sp[27] * PI8[0][11][14] + sp[30] * PI9[0][14][11];
    A[222] = sp[33] * PI0[0][14][12] + sp[34] * PI1[0][14][12] + sp[28] * PI2[0][14][12] + sp[31] * PI3[0][14][12] + sp[34] * PI1[0][12][14] + sp[35] * PI4[0][14][12] + sp[29] * PI5[0][14][12] + sp[32] * PI6[0][14][12] + sp[28] * PI2[0][12][14] + sp[29] * PI5[0][12][14] + sp[26] * PI7[0][14][12] + sp[27] * PI8[0][14][12] + sp[31] * PI3[0][12][14] + sp[32] * PI6[0][12][14] + sp[27] * PI8[0][12][14] + sp[30] * PI9[0][14][12];
    A[223] = sp[33] * PI0[0][14][13] + sp[34] * PI1[0][14][13] + sp[28] * PI2[0][14][13] + sp[31] * PI3[0][14][13] + sp[34] * PI1[0][13][14] + sp[35] * PI4[0][14][13] + sp[29] * PI5[0][14][13] + sp[32] * PI6[0][14][13] + sp[28] * PI2[0][13][14] + sp[29] * PI5[0][13][14] + sp[26] * PI7[0][14][13] + sp[27] * PI8[0][14][13] + sp[31] * PI3[0][13][14] + sp[32] * PI6[0][13][14] + sp[27] * PI8[0][13][14] + sp[30] * PI9[0][14][13];
    A[224] = sp[33] * PI0[0][14][14] + sp[34] * PI1[0][14][14] + sp[28] * PI2[0][14][14] + sp[31] * PI3[0][14][14] + sp[34] * PI1[0][14][14] + sp[35] * PI4[0][14][14] + sp[29] * PI5[0][14][14] + sp[32] * PI6[0][14][14] + sp[28] * PI2[0][14][14] + sp[29] * PI5[0][14][14] + sp[26] * PI7[0][14][14] + sp[27] * PI8[0][14][14] + sp[31] * PI3[0][14][14] + sp[32] * PI6[0][14][14] + sp[27] * PI8[0][14][14] + sp[30] * PI9[0][14][14];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 0.02162698412698435, -0.02986111111111124, 0.01765873015873009, -0.0154265873015874, 0.01746031746031736, -0.02385912698412699, -0.01314484126984126, 0.02777777777777799, -0.0205853174603176, 0.04349267900155114, 0.06529556615835232, -0.01686507936508141, 0.03507474113028578, -0.1005208057964095, 0.06200396825396945 },
            { -0.02986111111111124, 0.06865079365079402, -0.04871031746031759, 0.01746031746031737, -0.04384920634920634, 0.06111111111111137, 0.01041666666666664, -0.017857142857143, 0.02529761904761933, -0.07856742013183728, -0.05326743555023516, -0.004960317460314796, -0.07014948226057145, 0.04639421805988031, -0.1240079365079387 },
            { 0.01765873015873009, -0.04871031746031759, 0.05734126984127018, -0.02385912698412704, 0.06111111111111149, -0.05114087301587322, -0.01860119047619066, 0.01190476190476204, -0.0111607142857144, 0.1248660784238152, -0.003436608745177203, 0.1001984126984121, -0.03507474113028564, -0.02319710902993958, -0.06200396825396921 },
            { -0.0154265873015874, 0.01746031746031737, -0.02385912698412704, 0.02162698412698432, -0.02986111111111125, 0.01765873015873008, 0.02058531746031756, -0.02777777777777796, 0.01314484126984126, -0.0785674201318369, -0.03522523963805749, -0.04513888888888812, 0.03507474113028563, 0.1005208057964093, 0.06200396825396917 },
            { 0.01746031746031736, -0.04384920634920634, 0.06111111111111149, -0.02986111111111125, 0.06865079365079416, -0.04871031746031759, -0.02529761904761933, 0.01785714285714301, -0.01041666666666667, 0.148716902392409, -0.006873217490354664, 0.1289682539682538, -0.07014948226057141, -0.04639421805988019, -0.1240079365079386 },
            { -0.02385912698412699, 0.06111111111111137, -0.05114087301587322, 0.01765873015873008, -0.04871031746031759, 0.05734126984127008, 0.01116071428571435, -0.011904761904762, 0.01860119047619066, -0.08979133729352941, -0.02663371777511715, -0.03819444444444252, -0.03507474113028564, 0.02319710902993945, -0.06200396825396917 },
            { -0.01314484126984126, 0.01041666666666664, -0.01860119047619066, 0.02058531746031756, -0.02529761904761933, 0.01116071428571435, 0.1012896825396833, -0.0944444444444448, 0.04474206349206346, -0.2062394778460755, 0.131450284502998, 0.1473214285714276, 0.04208968935634283, 0.1030982623552902, 0.07440476190476314 },
            { 0.02777777777777799, -0.017857142857143, 0.01190476190476204, -0.02777777777777796, 0.01785714285714301, -0.011904761904762, -0.0944444444444448, 0.1630952380952393, -0.09444444444444489, 0.1346870059402925, 0.1030982623552917, -0.1071428571428563, 0.0, -0.2061965247105818, 0.0 },
            { -0.0205853174603176, 0.02529761904761933, -0.0111607142857144, 0.01314484126984126, -0.01041666666666667, 0.01860119047619066, 0.04474206349206346, -0.09444444444444489, 0.1012896825396833, -0.1641497884897321, -0.2345485468582884, 0.2217261904761909, -0.04208968935634282, 0.1030982623552903, -0.07440476190476315 },
            { 0.04349267900155114, -0.07856742013183728, 0.1248660784238152, -0.0785674201318369, 0.148716902392409, -0.08979133729352941, -0.2062394778460755, 0.1346870059402925, -0.1641497884897321, 4.920634920634906, 0.0243004934799691, -0.519106168728203, -0.1984126984127016, -0.2187044413199086, -0.3507474113028559 },
            { 0.06529556615835232, -0.05326743555023516, -0.003436608745177203, -0.03522523963805749, -0.006873217490354664, -0.02663371777511715, 0.131450284502998, 0.1030982623552917, -0.2345485468582884, 0.0243004934799691, 5.416666666666708, -0.1890134809847096, 0.1701034543599528, -0.4017857142857217, 0.3007032652029488 },
            { -0.01686507936508141, -0.004960317460314796, 0.1001984126984121, -0.04513888888888812, 0.1289682539682538, -0.03819444444444252, 0.1473214285714276, -0.1071428571428563, 0.2217261904761909, -0.519106168728203, -0.1890134809847096, 5.55555555555557, -0.3507474113028569, 0.07732369676647471, -0.6200396825396935 },
            { 0.03507474113028578, -0.07014948226057145, -0.03507474113028564, 0.03507474113028563, -0.07014948226057141, -0.03507474113028564, 0.04208968935634283, 0.0, -0.04208968935634282, -0.1984126984127016, 0.1701034543599528, -0.3507474113028569, 0.3968253968254036, 0.0, 0.7014948226057137 },
            { -0.1005208057964095, 0.04639421805988031, -0.02319710902993958, 0.1005208057964093, -0.04639421805988019, 0.02319710902993945, 0.1030982623552902, -0.2061965247105818, 0.1030982623552903, -0.2187044413199086, -0.4017857142857217, 0.07732369676647471, 0.0, 0.8035714285714425, 0.0 },
            { 0.06200396825396945, -0.1240079365079387, -0.06200396825396921, 0.06200396825396917, -0.1240079365079386, -0.06200396825396917, 0.07440476190476314, 0.0, -0.07440476190476315, -0.3507474113028559, 0.3007032652029488, -0.6200396825396935, 0.7014948226057137, 0.0, 1.240079365079386 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { -0.01116071428571435, 0.005952380952380875, -0.004712301587301555, -0.02447916666666678, 0.02167658730158715, -0.03266369047619055, -0.008804563492063528, 0.01413690476190486, -0.007068452380952358, -0.02314932914598859, -0.05154913117764579, -0.007440476190475746, 0.1283735525368425, -0.06314768569261553, 0.09598214285714186 },
            { 0.009920634920635002, -0.01289682539682544, 0.005952380952380876, 0.02316468253968247, -0.05327380952380961, 0.07524801587301629, 0.004216269841269746, -0.00942460317460324, 0.01165674603174614, -0.009820927516479887, -0.0085915218629416, 0.01984126984126904, -0.1360899955855056, 0.04897167461876184, -0.2405753968253963 },
            { -0.00471230158730162, 0.009920634920634986, -0.01116071428571434, -0.03067956349206364, 0.07276785714285768, -0.05820932539682565, -0.009052579365079395, 0.005704365079365122, -0.006820436507936584, 0.01192541198429709, -0.01718304372588143, -0.07192460317460356, 0.06243303921190657, 0.001288728279441132, 0.1460813492063478 },
            { 0.009052579365079375, -0.004216269841269739, 0.008804563492063534, 0.03278769841269866, -0.03581349206349217, 0.02237103174603165, 0.01351686507936519, -0.01364087301587308, 0.004340277777777696, 0.02665680325901711, 0.07947157723220398, 0.04340277777777803, -0.09329881140655687, 0.03737312010379379, -0.03397817460317274 },
            { -0.005704365079365063, 0.009424603174603165, -0.01413690476190485, -0.0397817460317463, 0.08154761904761972, -0.05466269841269856, -0.0136408730158731, 0.008432539682539705, -0.006200396825396817, 0.002805979290422788, -0.047253370246175, -0.09176587301587376, 0.06594051332493447, 0.002577456558881516, 0.1165674603174582 },
            { 0.006820436507936543, -0.01165674603174608, 0.007068452380952352, 0.02237103174603173, -0.05863095238095267, 0.06850198412698448, 0.004340277777777708, -0.006200396825396842, 0.009548611111111202, -0.01543288609732565, -0.01073940232867686, 0.03596230158730127, -0.09750778034219186, 0.02448583730938063, -0.2080853174603166 },
            { 0.03067956349206365, -0.02316468253968254, 0.02447916666666682, 0.07879464285714317, -0.1005456349206357, 0.04382440476190493, 0.03278769841269868, -0.03978174603174629, 0.02237103174603177, 0.04700015311458268, 0.1576544261849666, 0.106894841269842, -0.152925871328041, 0.01546473935329262, 0.01537698412698315 },
            { -0.07276785714285772, 0.05327380952380978, -0.02167658730158726, -0.1005456349206356, 0.0711309523809526, -0.03358134920634907, -0.03581349206349217, 0.08154761904761967, -0.0586309523809528, -0.07997040977705097, -0.1520699369740541, 0.01934523809524032, 0.2946278254943949, -0.1030982623552906, -0.1458333333333371 },
            { 0.05820932539682571, -0.07524801587301648, 0.03266369047619068, 0.04382440476190486, -0.03358134920634917, 0.0430803571428574, 0.02237103174603172, -0.05466269841269866, 0.0685019841269847, -0.05822407027627445, -0.06142938132002937, 0.09945436507936549, -0.1950155606843832, 0.08763352300199788, -0.05902777777777945 },
            { -0.06243303921190627, 0.1360899955855054, -0.1283735525368425, -0.1529258713280409, 0.2946278254943953, -0.1950155606843834, -0.09329881140655705, 0.0659405133249347, -0.0975077803421921, 0.1984126984127018, -0.06075123369997169, -0.8067190459965525, 4.305555555555532, -0.03645074021998757, 0.5401510134063873 },
            { -0.1271545235715237, 0.1838585678669348, -0.05154913117764433, 0.02104922856420367, -0.1778445025628795, -0.007302793583500541, -0.01073940232867423, 0.1022391101689948, -0.1679642524204942, 0.2308546880599298, 0.4315476190476331, -0.06873217490352254, 0.4495591293798421, 3.593749999999993, 0.1761261981902897 },
            { 0.0719246031746027, -0.1626984126984119, 0.1026785714285715, 0.005704365079364766, -0.0163690476190468, 0.1054067460317485, 0.04935515873015902, -0.0560515873015872, 0.1252480158730156, -0.3016427737204508, -0.2749286996141045, 0.5902777777777783, -0.3016427737204449, 0.1675346763273471, 3.395337301587296 },
            { -0.01192541198429711, 0.00982092751647989, 0.02314932914598861, 0.04700015311458285, -0.07997040977705135, -0.05822407027627427, 0.02665680325901717, 0.002805979290422863, -0.01543288609732568, 0.01984126984126998, 0.1579532076199495, 0.2034334985556576, 0.1984126984127018, -0.1458029608799463, 0.3507474113028569 },
            { 0.07088005536926224, -0.01288728279441029, 0.0322182069860282, 0.1714008611656714, -0.0592815008542904, 0.05541531601596756, 0.07732369676646841, -0.1030982623552908, 0.02577456558882181, 0.2551551815399186, 0.558035714285723, 0.06443641397205549, -0.7290148043997469, 0.4017857142857212, -0.05154913117763665 },
            { -0.02108134920634952, 0.01736111111111123, 0.04092261904761981, 0.08308531746031883, -0.1413690476190499, -0.1029265873015891, 0.04712301587301673, 0.004960317460317543, -0.02728174603174644, 0.0350747411302854, 0.2792244605455824, 0.3596230158730228, 0.3507474113028572, -0.2577456558882165, 0.6200396825396923 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { 0.0573412698412703, -0.04871031746031775, 0.01765873015873019, 0.01860119047619061, -0.01190476190476189, 0.01116071428571419, 0.02385912698412707, -0.06111111111111161, 0.05114087301587341, 0.03507474113028557, 0.06529556615835085, -0.01091269841269967, -0.1248660784238148, -0.08505606644311364, 0.05307539682539828 },
            { -0.04871031746031775, 0.06865079365079425, -0.02986111111111132, -0.01041666666666659, 0.01785714285714283, -0.02529761904761911, -0.01746031746031746, 0.04384920634920658, -0.06111111111111168, 0.07014948226057133, 0.08419691425682245, -0.1021825396825403, 0.07856742013183692, 0.03092947870658618, 0.04365079365079537 },
            { 0.01765873015873019, -0.02986111111111132, 0.02162698412698437, 0.01314484126984126, -0.02777777777777795, 0.02058531746031755, 0.01542658730158744, -0.01746031746031749, 0.02385912698412713, -0.03507474113028568, -0.003436608745176603, 0.1180555555555573, -0.04349267900155106, -0.01804219591217503, -0.06498015873016071 },
            { 0.01860119047619061, -0.01041666666666659, 0.01314484126984126, 0.1012896825396832, -0.09444444444444483, 0.04474206349206337, 0.02058531746031756, -0.02529761904761924, 0.01116071428571426, 0.0420896893563428, 0.1159855451497028, 0.05208333333333283, -0.206239477846075, 0.1933092419161693, 0.0401785714285746 },
            { -0.01190476190476189, 0.01785714285714283, -0.02777777777777795, -0.09444444444444483, 0.1630952380952394, -0.09444444444444489, -0.02777777777777796, 0.0178571428571429, -0.01190476190476187, 0.0, -0.103098262355291, -0.1785714285714299, 0.1346870059402923, -0.04123930494211515, 0.1428571428571432 },
            { 0.01116071428571419, -0.02529761904761911, 0.02058531746031755, 0.04474206349206337, -0.09444444444444489, 0.1012896825396832, 0.01314484126984124, -0.01041666666666655, 0.01860119047619052, -0.04208968935634277, -0.01288728279441236, 0.1264880952380961, -0.1641497884897316, 0.07474624020758409, -0.3139880952380976 },
            { 0.02385912698412707, -0.01746031746031746, 0.01542658730158744, 0.02058531746031756, -0.02777777777777796, 0.01314484126984124, 0.02162698412698434, -0.02986111111111128, 0.01765873015873017, 0.0350747411302855, 0.1039574145415857, 0.05605158730158804, -0.07856742013183682, -0.05670404429540916, -0.007936507936507933 },
            { -0.06111111111111161, 0.04384920634920658, -0.01746031746031749, -0.02529761904761924, 0.0178571428571429, -0.01041666666666655, -0.02986111111111128, 0.06865079365079423, -0.04871031746031779, -0.07014948226057102, -0.1305911323167022, 0.02182539682539814, 0.1487169023924086, 0.1082531754730541, -0.07043650793651005 },
            { 0.05114087301587341, -0.06111111111111168, 0.02385912698412713, 0.01116071428571426, -0.01190476190476187, 0.01860119047619052, 0.01765873015873017, -0.04871031746031779, 0.0573412698412704, -0.0350747411302858, -0.04209845712841176, 0.05109126984126969, -0.08979133729352924, -0.04639421805987987, -0.003968253968254307 },
            { 0.03507474113028557, 0.07014948226057133, -0.03507474113028568, 0.0420896893563428, 0.0, -0.04208968935634277, 0.0350747411302855, -0.07014948226057102, -0.0350747411302858, 0.3968253968254025, 0.607512336999805, -0.3507474113028567, -0.1984126984127008, -0.2187044413199259, 0.3226876183986337 },
            { 0.06529556615835085, 0.08419691425682245, -0.003436608745176603, 0.1159855451497028, -0.103098262355291, -0.01288728279441236, 0.1039574145415857, -0.1305911323167022, -0.04209845712841176, 0.607512336999805, 1.130952380952398, -0.1890134809847019, -0.413108389159858, -0.4017857142857142, 0.3007032652029426 },
            { -0.01091269841269967, -0.1021825396825403, 0.1180555555555573, 0.05208333333333283, -0.1785714285714299, 0.1264880952380961, 0.05605158730158804, 0.02182539682539814, 0.05109126984126969, -0.3507474113028567, -0.1890134809847019, 0.9126984126984293, -0.01402989645209509, 0.07732369676647141, -0.620039682539702 },
            { -0.1248660784238148, 0.07856742013183692, -0.04349267900155106, -0.206239477846075, 0.1346870059402923, -0.1641497884897316, -0.07856742013183682, 0.1487169023924086, -0.08979133729352924, -0.1984126984127008, -0.413108389159858, -0.01402989645209509, 4.920634920634909, -0.4374088826398519, 0.2805979290422581 },
            { -0.08505606644311364, 0.03092947870658618, -0.01804219591217503, 0.1933092419161693, -0.04123930494211515, 0.07474624020758409, -0.05670404429540916, 0.1082531754730541, -0.04639421805987987, -0.2187044413199259, -0.4017857142857142, 0.07732369676647141, -0.4374088826398519, 5.357142857142863, -0.1546473935329269 },
            { 0.05307539682539828, 0.04365079365079537, -0.06498015873016071, 0.0401785714285746, 0.1428571428571432, -0.3139880952380976, -0.007936507936507933, -0.07043650793651005, -0.003968253968254307, 0.3226876183986337, 0.3007032652029426, -0.620039682539702, 0.2805979290422581, -0.1546473935329269, 5.615079365079414 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = sp[19] * PI0[0][0][0] + sp[18] * PI1[0][0][0] + sp[18] * PI1[0][0][0] + sp[17] * PI2[0][0][0];
    A[1] = sp[19] * PI0[0][0][1] + sp[18] * PI1[0][0][1] + sp[18] * PI1[0][1][0] + sp[17] * PI2[0][0][1];
    A[2] = sp[19] * PI0[0][0][2] + sp[18] * PI1[0][0][2] + sp[18] * PI1[0][2][0] + sp[17] * PI2[0][0][2];
    A[3] = sp[19] * PI0[0][0][3] + sp[18] * PI1[0][0][3] + sp[18] * PI1[0][3][0] + sp[17] * PI2[0][0][3];
    A[4] = sp[19] * PI0[0][0][4] + sp[18] * PI1[0][0][4] + sp[18] * PI1[0][4][0] + sp[17] * PI2[0][0][4];
    A[5] = sp[19] * PI0[0][0][5] + sp[18] * PI1[0][0][5] + sp[18] * PI1[0][5][0] + sp[17] * PI2[0][0][5];
    A[6] = sp[19] * PI0[0][0][6] + sp[18] * PI1[0][0][6] + sp[18] * PI1[0][6][0] + sp[17] * PI2[0][0][6];
    A[7] = sp[19] * PI0[0][0][7] + sp[18] * PI1[0][0][7] + sp[18] * PI1[0][7][0] + sp[17] * PI2[0][0][7];
    A[8] = sp[19] * PI0[0][0][8] + sp[18] * PI1[0][0][8] + sp[18] * PI1[0][8][0] + sp[17] * PI2[0][0][8];
    A[9] = sp[19] * PI0[0][0][9] + sp[18] * PI1[0][0][9] + sp[18] * PI1[0][9][0] + sp[17] * PI2[0][0][9];
    A[10] = sp[19] * PI0[0][0][10] + sp[18] * PI1[0][0][10] + sp[18] * PI1[0][10][0] + sp[17] * PI2[0][0][10];
    A[11] = sp[19] * PI0[0][0][11] + sp[18] * PI1[0][0][11] + sp[18] * PI1[0][11][0] + sp[17] * PI2[0][0][11];
    A[12] = sp[19] * PI0[0][0][12] + sp[18] * PI1[0][0][12] + sp[18] * PI1[0][12][0] + sp[17] * PI2[0][0][12];
    A[13] = sp[19] * PI0[0][0][13] + sp[18] * PI1[0][0][13] + sp[18] * PI1[0][13][0] + sp[17] * PI2[0][0][13];
    A[14] = sp[19] * PI0[0][0][14] + sp[18] * PI1[0][0][14] + sp[18] * PI1[0][14][0] + sp[17] * PI2[0][0][14];
    A[15] = sp[19] * PI0[0][1][0] + sp[18] * PI1[0][1][0] + sp[18] * PI1[0][0][1] + sp[17] * PI2[0][1][0];
    A[16] = sp[19] * PI0[0][1][1] + sp[18] * PI1[0][1][1] + sp[18] * PI1[0][1][1] + sp[17] * PI2[0][1][1];
    A[17] = sp[19] * PI0[0][1][2] + sp[18] * PI1[0][1][2] + sp[18] * PI1[0][2][1] + sp[17] * PI2[0][1][2];
    A[18] = sp[19] * PI0[0][1][3] + sp[18] * PI1[0][1][3] + sp[18] * PI1[0][3][1] + sp[17] * PI2[0][1][3];
    A[19] = sp[19] * PI0[0][1][4] + sp[18] * PI1[0][1][4] + sp[18] * PI1[0][4][1] + sp[17] * PI2[0][1][4];
    A[20] = sp[19] * PI0[0][1][5] + sp[18] * PI1[0][1][5] + sp[18] * PI1[0][5][1] + sp[17] * PI2[0][1][5];
    A[21] = sp[19] * PI0[0][1][6] + sp[18] * PI1[0][1][6] + sp[18] * PI1[0][6][1] + sp[17] * PI2[0][1][6];
    A[22] = sp[19] * PI0[0][1][7] + sp[18] * PI1[0][1][7] + sp[18] * PI1[0][7][1] + sp[17] * PI2[0][1][7];
    A[23] = sp[19] * PI0[0][1][8] + sp[18] * PI1[0][1][8] + sp[18] * PI1[0][8][1] + sp[17] * PI2[0][1][8];
    A[24] = sp[19] * PI0[0][1][9] + sp[18] * PI1[0][1][9] + sp[18] * PI1[0][9][1] + sp[17] * PI2[0][1][9];
    A[25] = sp[19] * PI0[0][1][10] + sp[18] * PI1[0][1][10] + sp[18] * PI1[0][10][1] + sp[17] * PI2[0][1][10];
    A[26] = sp[19] * PI0[0][1][11] + sp[18] * PI1[0][1][11] + sp[18] * PI1[0][11][1] + sp[17] * PI2[0][1][11];
    A[27] = sp[19] * PI0[0][1][12] + sp[18] * PI1[0][1][12] + sp[18] * PI1[0][12][1] + sp[17] * PI2[0][1][12];
    A[28] = sp[19] * PI0[0][1][13] + sp[18] * PI1[0][1][13] + sp[18] * PI1[0][13][1] + sp[17] * PI2[0][1][13];
    A[29] = sp[19] * PI0[0][1][14] + sp[18] * PI1[0][1][14] + sp[18] * PI1[0][14][1] + sp[17] * PI2[0][1][14];
    A[30] = sp[19] * PI0[0][2][0] + sp[18] * PI1[0][2][0] + sp[18] * PI1[0][0][2] + sp[17] * PI2[0][2][0];
    A[31] = sp[19] * PI0[0][2][1] + sp[18] * PI1[0][2][1] + sp[18] * PI1[0][1][2] + sp[17] * PI2[0][2][1];
    A[32] = sp[19] * PI0[0][2][2] + sp[18] * PI1[0][2][2] + sp[18] * PI1[0][2][2] + sp[17] * PI2[0][2][2];
    A[33] = sp[19] * PI0[0][2][3] + sp[18] * PI1[0][2][3] + sp[18] * PI1[0][3][2] + sp[17] * PI2[0][2][3];
    A[34] = sp[19] * PI0[0][2][4] + sp[18] * PI1[0][2][4] + sp[18] * PI1[0][4][2] + sp[17] * PI2[0][2][4];
    A[35] = sp[19] * PI0[0][2][5] + sp[18] * PI1[0][2][5] + sp[18] * PI1[0][5][2] + sp[17] * PI2[0][2][5];
    A[36] = sp[19] * PI0[0][2][6] + sp[18] * PI1[0][2][6] + sp[18] * PI1[0][6][2] + sp[17] * PI2[0][2][6];
    A[37] = sp[19] * PI0[0][2][7] + sp[18] * PI1[0][2][7] + sp[18] * PI1[0][7][2] + sp[17] * PI2[0][2][7];
    A[38] = sp[19] * PI0[0][2][8] + sp[18] * PI1[0][2][8] + sp[18] * PI1[0][8][2] + sp[17] * PI2[0][2][8];
    A[39] = sp[19] * PI0[0][2][9] + sp[18] * PI1[0][2][9] + sp[18] * PI1[0][9][2] + sp[17] * PI2[0][2][9];
    A[40] = sp[19] * PI0[0][2][10] + sp[18] * PI1[0][2][10] + sp[18] * PI1[0][10][2] + sp[17] * PI2[0][2][10];
    A[41] = sp[19] * PI0[0][2][11] + sp[18] * PI1[0][2][11] + sp[18] * PI1[0][11][2] + sp[17] * PI2[0][2][11];
    A[42] = sp[19] * PI0[0][2][12] + sp[18] * PI1[0][2][12] + sp[18] * PI1[0][12][2] + sp[17] * PI2[0][2][12];
    A[43] = sp[19] * PI0[0][2][13] + sp[18] * PI1[0][2][13] + sp[18] * PI1[0][13][2] + sp[17] * PI2[0][2][13];
    A[44] = sp[19] * PI0[0][2][14] + sp[18] * PI1[0][2][14] + sp[18] * PI1[0][14][2] + sp[17] * PI2[0][2][14];
    A[45] = sp[19] * PI0[0][3][0] + sp[18] * PI1[0][3][0] + sp[18] * PI1[0][0][3] + sp[17] * PI2[0][3][0];
    A[46] = sp[19] * PI0[0][3][1] + sp[18] * PI1[0][3][1] + sp[18] * PI1[0][1][3] + sp[17] * PI2[0][3][1];
    A[47] = sp[19] * PI0[0][3][2] + sp[18] * PI1[0][3][2] + sp[18] * PI1[0][2][3] + sp[17] * PI2[0][3][2];
    A[48] = sp[19] * PI0[0][3][3] + sp[18] * PI1[0][3][3] + sp[18] * PI1[0][3][3] + sp[17] * PI2[0][3][3];
    A[49] = sp[19] * PI0[0][3][4] + sp[18] * PI1[0][3][4] + sp[18] * PI1[0][4][3] + sp[17] * PI2[0][3][4];
    A[50] = sp[19] * PI0[0][3][5] + sp[18] * PI1[0][3][5] + sp[18] * PI1[0][5][3] + sp[17] * PI2[0][3][5];
    A[51] = sp[19] * PI0[0][3][6] + sp[18] * PI1[0][3][6] + sp[18] * PI1[0][6][3] + sp[17] * PI2[0][3][6];
    A[52] = sp[19] * PI0[0][3][7] + sp[18] * PI1[0][3][7] + sp[18] * PI1[0][7][3] + sp[17] * PI2[0][3][7];
    A[53] = sp[19] * PI0[0][3][8] + sp[18] * PI1[0][3][8] + sp[18] * PI1[0][8][3] + sp[17] * PI2[0][3][8];
    A[54] = sp[19] * PI0[0][3][9] + sp[18] * PI1[0][3][9] + sp[18] * PI1[0][9][3] + sp[17] * PI2[0][3][9];
    A[55] = sp[19] * PI0[0][3][10] + sp[18] * PI1[0][3][10] + sp[18] * PI1[0][10][3] + sp[17] * PI2[0][3][10];
    A[56] = sp[19] * PI0[0][3][11] + sp[18] * PI1[0][3][11] + sp[18] * PI1[0][11][3] + sp[17] * PI2[0][3][11];
    A[57] = sp[19] * PI0[0][3][12] + sp[18] * PI1[0][3][12] + sp[18] * PI1[0][12][3] + sp[17] * PI2[0][3][12];
    A[58] = sp[19] * PI0[0][3][13] + sp[18] * PI1[0][3][13] + sp[18] * PI1[0][13][3] + sp[17] * PI2[0][3][13];
    A[59] = sp[19] * PI0[0][3][14] + sp[18] * PI1[0][3][14] + sp[18] * PI1[0][14][3] + sp[17] * PI2[0][3][14];
    A[60] = sp[19] * PI0[0][4][0] + sp[18] * PI1[0][4][0] + sp[18] * PI1[0][0][4] + sp[17] * PI2[0][4][0];
    A[61] = sp[19] * PI0[0][4][1] + sp[18] * PI1[0][4][1] + sp[18] * PI1[0][1][4] + sp[17] * PI2[0][4][1];
    A[62] = sp[19] * PI0[0][4][2] + sp[18] * PI1[0][4][2] + sp[18] * PI1[0][2][4] + sp[17] * PI2[0][4][2];
    A[63] = sp[19] * PI0[0][4][3] + sp[18] * PI1[0][4][3] + sp[18] * PI1[0][3][4] + sp[17] * PI2[0][4][3];
    A[64] = sp[19] * PI0[0][4][4] + sp[18] * PI1[0][4][4] + sp[18] * PI1[0][4][4] + sp[17] * PI2[0][4][4];
    A[65] = sp[19] * PI0[0][4][5] + sp[18] * PI1[0][4][5] + sp[18] * PI1[0][5][4] + sp[17] * PI2[0][4][5];
    A[66] = sp[19] * PI0[0][4][6] + sp[18] * PI1[0][4][6] + sp[18] * PI1[0][6][4] + sp[17] * PI2[0][4][6];
    A[67] = sp[19] * PI0[0][4][7] + sp[18] * PI1[0][4][7] + sp[18] * PI1[0][7][4] + sp[17] * PI2[0][4][7];
    A[68] = sp[19] * PI0[0][4][8] + sp[18] * PI1[0][4][8] + sp[18] * PI1[0][8][4] + sp[17] * PI2[0][4][8];
    A[69] = sp[19] * PI0[0][4][9] + sp[18] * PI1[0][4][9] + sp[18] * PI1[0][9][4] + sp[17] * PI2[0][4][9];
    A[70] = sp[19] * PI0[0][4][10] + sp[18] * PI1[0][4][10] + sp[18] * PI1[0][10][4] + sp[17] * PI2[0][4][10];
    A[71] = sp[19] * PI0[0][4][11] + sp[18] * PI1[0][4][11] + sp[18] * PI1[0][11][4] + sp[17] * PI2[0][4][11];
    A[72] = sp[19] * PI0[0][4][12] + sp[18] * PI1[0][4][12] + sp[18] * PI1[0][12][4] + sp[17] * PI2[0][4][12];
    A[73] = sp[19] * PI0[0][4][13] + sp[18] * PI1[0][4][13] + sp[18] * PI1[0][13][4] + sp[17] * PI2[0][4][13];
    A[74] = sp[19] * PI0[0][4][14] + sp[18] * PI1[0][4][14] + sp[18] * PI1[0][14][4] + sp[17] * PI2[0][4][14];
    A[75] = sp[19] * PI0[0][5][0] + sp[18] * PI1[0][5][0] + sp[18] * PI1[0][0][5] + sp[17] * PI2[0][5][0];
    A[76] = sp[19] * PI0[0][5][1] + sp[18] * PI1[0][5][1] + sp[18] * PI1[0][1][5] + sp[17] * PI2[0][5][1];
    A[77] = sp[19] * PI0[0][5][2] + sp[18] * PI1[0][5][2] + sp[18] * PI1[0][2][5] + sp[17] * PI2[0][5][2];
    A[78] = sp[19] * PI0[0][5][3] + sp[18] * PI1[0][5][3] + sp[18] * PI1[0][3][5] + sp[17] * PI2[0][5][3];
    A[79] = sp[19] * PI0[0][5][4] + sp[18] * PI1[0][5][4] + sp[18] * PI1[0][4][5] + sp[17] * PI2[0][5][4];
    A[80] = sp[19] * PI0[0][5][5] + sp[18] * PI1[0][5][5] + sp[18] * PI1[0][5][5] + sp[17] * PI2[0][5][5];
    A[81] = sp[19] * PI0[0][5][6] + sp[18] * PI1[0][5][6] + sp[18] * PI1[0][6][5] + sp[17] * PI2[0][5][6];
    A[82] = sp[19] * PI0[0][5][7] + sp[18] * PI1[0][5][7] + sp[18] * PI1[0][7][5] + sp[17] * PI2[0][5][7];
    A[83] = sp[19] * PI0[0][5][8] + sp[18] * PI1[0][5][8] + sp[18] * PI1[0][8][5] + sp[17] * PI2[0][5][8];
    A[84] = sp[19] * PI0[0][5][9] + sp[18] * PI1[0][5][9] + sp[18] * PI1[0][9][5] + sp[17] * PI2[0][5][9];
    A[85] = sp[19] * PI0[0][5][10] + sp[18] * PI1[0][5][10] + sp[18] * PI1[0][10][5] + sp[17] * PI2[0][5][10];
    A[86] = sp[19] * PI0[0][5][11] + sp[18] * PI1[0][5][11] + sp[18] * PI1[0][11][5] + sp[17] * PI2[0][5][11];
    A[87] = sp[19] * PI0[0][5][12] + sp[18] * PI1[0][5][12] + sp[18] * PI1[0][12][5] + sp[17] * PI2[0][5][12];
    A[88] = sp[19] * PI0[0][5][13] + sp[18] * PI1[0][5][13] + sp[18] * PI1[0][13][5] + sp[17] * PI2[0][5][13];
    A[89] = sp[19] * PI0[0][5][14] + sp[18] * PI1[0][5][14] + sp[18] * PI1[0][14][5] + sp[17] * PI2[0][5][14];
    A[90] = sp[19] * PI0[0][6][0] + sp[18] * PI1[0][6][0] + sp[18] * PI1[0][0][6] + sp[17] * PI2[0][6][0];
    A[91] = sp[19] * PI0[0][6][1] + sp[18] * PI1[0][6][1] + sp[18] * PI1[0][1][6] + sp[17] * PI2[0][6][1];
    A[92] = sp[19] * PI0[0][6][2] + sp[18] * PI1[0][6][2] + sp[18] * PI1[0][2][6] + sp[17] * PI2[0][6][2];
    A[93] = sp[19] * PI0[0][6][3] + sp[18] * PI1[0][6][3] + sp[18] * PI1[0][3][6] + sp[17] * PI2[0][6][3];
    A[94] = sp[19] * PI0[0][6][4] + sp[18] * PI1[0][6][4] + sp[18] * PI1[0][4][6] + sp[17] * PI2[0][6][4];
    A[95] = sp[19] * PI0[0][6][5] + sp[18] * PI1[0][6][5] + sp[18] * PI1[0][5][6] + sp[17] * PI2[0][6][5];
    A[96] = sp[19] * PI0[0][6][6] + sp[18] * PI1[0][6][6] + sp[18] * PI1[0][6][6] + sp[17] * PI2[0][6][6];
    A[97] = sp[19] * PI0[0][6][7] + sp[18] * PI1[0][6][7] + sp[18] * PI1[0][7][6] + sp[17] * PI2[0][6][7];
    A[98] = sp[19] * PI0[0][6][8] + sp[18] * PI1[0][6][8] + sp[18] * PI1[0][8][6] + sp[17] * PI2[0][6][8];
    A[99] = sp[19] * PI0[0][6][9] + sp[18] * PI1[0][6][9] + sp[18] * PI1[0][9][6] + sp[17] * PI2[0][6][9];
    A[100] = sp[19] * PI0[0][6][10] + sp[18] * PI1[0][6][10] + sp[18] * PI1[0][10][6] + sp[17] * PI2[0][6][10];
    A[101] = sp[19] * PI0[0][6][11] + sp[18] * PI1[0][6][11] + sp[18] * PI1[0][11][6] + sp[17] * PI2[0][6][11];
    A[102] = sp[19] * PI0[0][6][12] + sp[18] * PI1[0][6][12] + sp[18] * PI1[0][12][6] + sp[17] * PI2[0][6][12];
    A[103] = sp[19] * PI0[0][6][13] + sp[18] * PI1[0][6][13] + sp[18] * PI1[0][13][6] + sp[17] * PI2[0][6][13];
    A[104] = sp[19] * PI0[0][6][14] + sp[18] * PI1[0][6][14] + sp[18] * PI1[0][14][6] + sp[17] * PI2[0][6][14];
    A[105] = sp[19] * PI0[0][7][0] + sp[18] * PI1[0][7][0] + sp[18] * PI1[0][0][7] + sp[17] * PI2[0][7][0];
    A[106] = sp[19] * PI0[0][7][1] + sp[18] * PI1[0][7][1] + sp[18] * PI1[0][1][7] + sp[17] * PI2[0][7][1];
    A[107] = sp[19] * PI0[0][7][2] + sp[18] * PI1[0][7][2] + sp[18] * PI1[0][2][7] + sp[17] * PI2[0][7][2];
    A[108] = sp[19] * PI0[0][7][3] + sp[18] * PI1[0][7][3] + sp[18] * PI1[0][3][7] + sp[17] * PI2[0][7][3];
    A[109] = sp[19] * PI0[0][7][4] + sp[18] * PI1[0][7][4] + sp[18] * PI1[0][4][7] + sp[17] * PI2[0][7][4];
    A[110] = sp[19] * PI0[0][7][5] + sp[18] * PI1[0][7][5] + sp[18] * PI1[0][5][7] + sp[17] * PI2[0][7][5];
    A[111] = sp[19] * PI0[0][7][6] + sp[18] * PI1[0][7][6] + sp[18] * PI1[0][6][7] + sp[17] * PI2[0][7][6];
    A[112] = sp[19] * PI0[0][7][7] + sp[18] * PI1[0][7][7] + sp[18] * PI1[0][7][7] + sp[17] * PI2[0][7][7];
    A[113] = sp[19] * PI0[0][7][8] + sp[18] * PI1[0][7][8] + sp[18] * PI1[0][8][7] + sp[17] * PI2[0][7][8];
    A[114] = sp[19] * PI0[0][7][9] + sp[18] * PI1[0][7][9] + sp[18] * PI1[0][9][7] + sp[17] * PI2[0][7][9];
    A[115] = sp[19] * PI0[0][7][10] + sp[18] * PI1[0][7][10] + sp[18] * PI1[0][10][7] + sp[17] * PI2[0][7][10];
    A[116] = sp[19] * PI0[0][7][11] + sp[18] * PI1[0][7][11] + sp[18] * PI1[0][11][7] + sp[17] * PI2[0][7][11];
    A[117] = sp[19] * PI0[0][7][12] + sp[18] * PI1[0][7][12] + sp[18] * PI1[0][12][7] + sp[17] * PI2[0][7][12];
    A[118] = sp[19] * PI0[0][7][13] + sp[18] * PI1[0][7][13] + sp[18] * PI1[0][13][7] + sp[17] * PI2[0][7][13];
    A[119] = sp[19] * PI0[0][7][14] + sp[18] * PI1[0][7][14] + sp[18] * PI1[0][14][7] + sp[17] * PI2[0][7][14];
    A[120] = sp[19] * PI0[0][8][0] + sp[18] * PI1[0][8][0] + sp[18] * PI1[0][0][8] + sp[17] * PI2[0][8][0];
    A[121] = sp[19] * PI0[0][8][1] + sp[18] * PI1[0][8][1] + sp[18] * PI1[0][1][8] + sp[17] * PI2[0][8][1];
    A[122] = sp[19] * PI0[0][8][2] + sp[18] * PI1[0][8][2] + sp[18] * PI1[0][2][8] + sp[17] * PI2[0][8][2];
    A[123] = sp[19] * PI0[0][8][3] + sp[18] * PI1[0][8][3] + sp[18] * PI1[0][3][8] + sp[17] * PI2[0][8][3];
    A[124] = sp[19] * PI0[0][8][4] + sp[18] * PI1[0][8][4] + sp[18] * PI1[0][4][8] + sp[17] * PI2[0][8][4];
    A[125] = sp[19] * PI0[0][8][5] + sp[18] * PI1[0][8][5] + sp[18] * PI1[0][5][8] + sp[17] * PI2[0][8][5];
    A[126] = sp[19] * PI0[0][8][6] + sp[18] * PI1[0][8][6] + sp[18] * PI1[0][6][8] + sp[17] * PI2[0][8][6];
    A[127] = sp[19] * PI0[0][8][7] + sp[18] * PI1[0][8][7] + sp[18] * PI1[0][7][8] + sp[17] * PI2[0][8][7];
    A[128] = sp[19] * PI0[0][8][8] + sp[18] * PI1[0][8][8] + sp[18] * PI1[0][8][8] + sp[17] * PI2[0][8][8];
    A[129] = sp[19] * PI0[0][8][9] + sp[18] * PI1[0][8][9] + sp[18] * PI1[0][9][8] + sp[17] * PI2[0][8][9];
    A[130] = sp[19] * PI0[0][8][10] + sp[18] * PI1[0][8][10] + sp[18] * PI1[0][10][8] + sp[17] * PI2[0][8][10];
    A[131] = sp[19] * PI0[0][8][11] + sp[18] * PI1[0][8][11] + sp[18] * PI1[0][11][8] + sp[17] * PI2[0][8][11];
    A[132] = sp[19] * PI0[0][8][12] + sp[18] * PI1[0][8][12] + sp[18] * PI1[0][12][8] + sp[17] * PI2[0][8][12];
    A[133] = sp[19] * PI0[0][8][13] + sp[18] * PI1[0][8][13] + sp[18] * PI1[0][13][8] + sp[17] * PI2[0][8][13];
    A[134] = sp[19] * PI0[0][8][14] + sp[18] * PI1[0][8][14] + sp[18] * PI1[0][14][8] + sp[17] * PI2[0][8][14];
    A[135] = sp[19] * PI0[0][9][0] + sp[18] * PI1[0][9][0] + sp[18] * PI1[0][0][9] + sp[17] * PI2[0][9][0];
    A[136] = sp[19] * PI0[0][9][1] + sp[18] * PI1[0][9][1] + sp[18] * PI1[0][1][9] + sp[17] * PI2[0][9][1];
    A[137] = sp[19] * PI0[0][9][2] + sp[18] * PI1[0][9][2] + sp[18] * PI1[0][2][9] + sp[17] * PI2[0][9][2];
    A[138] = sp[19] * PI0[0][9][3] + sp[18] * PI1[0][9][3] + sp[18] * PI1[0][3][9] + sp[17] * PI2[0][9][3];
    A[139] = sp[19] * PI0[0][9][4] + sp[18] * PI1[0][9][4] + sp[18] * PI1[0][4][9] + sp[17] * PI2[0][9][4];
    A[140] = sp[19] * PI0[0][9][5] + sp[18] * PI1[0][9][5] + sp[18] * PI1[0][5][9] + sp[17] * PI2[0][9][5];
    A[141] = sp[19] * PI0[0][9][6] + sp[18] * PI1[0][9][6] + sp[18] * PI1[0][6][9] + sp[17] * PI2[0][9][6];
    A[142] = sp[19] * PI0[0][9][7] + sp[18] * PI1[0][9][7] + sp[18] * PI1[0][7][9] + sp[17] * PI2[0][9][7];
    A[143] = sp[19] * PI0[0][9][8] + sp[18] * PI1[0][9][8] + sp[18] * PI1[0][8][9] + sp[17] * PI2[0][9][8];
    A[144] = sp[19] * PI0[0][9][9] + sp[18] * PI1[0][9][9] + sp[18] * PI1[0][9][9] + sp[17] * PI2[0][9][9];
    A[145] = sp[19] * PI0[0][9][10] + sp[18] * PI1[0][9][10] + sp[18] * PI1[0][10][9] + sp[17] * PI2[0][9][10];
    A[146] = sp[19] * PI0[0][9][11] + sp[18] * PI1[0][9][11] + sp[18] * PI1[0][11][9] + sp[17] * PI2[0][9][11];
    A[147] = sp[19] * PI0[0][9][12] + sp[18] * PI1[0][9][12] + sp[18] * PI1[0][12][9] + sp[17] * PI2[0][9][12];
    A[148] = sp[19] * PI0[0][9][13] + sp[18] * PI1[0][9][13] + sp[18] * PI1[0][13][9] + sp[17] * PI2[0][9][13];
    A[149] = sp[19] * PI0[0][9][14] + sp[18] * PI1[0][9][14] + sp[18] * PI1[0][14][9] + sp[17] * PI2[0][9][14];
    A[150] = sp[19] * PI0[0][10][0] + sp[18] * PI1[0][10][0] + sp[18] * PI1[0][0][10] + sp[17] * PI2[0][10][0];
    A[151] = sp[19] * PI0[0][10][1] + sp[18] * PI1[0][10][1] + sp[18] * PI1[0][1][10] + sp[17] * PI2[0][10][1];
    A[152] = sp[19] * PI0[0][10][2] + sp[18] * PI1[0][10][2] + sp[18] * PI1[0][2][10] + sp[17] * PI2[0][10][2];
    A[153] = sp[19] * PI0[0][10][3] + sp[18] * PI1[0][10][3] + sp[18] * PI1[0][3][10] + sp[17] * PI2[0][10][3];
    A[154] = sp[19] * PI0[0][10][4] + sp[18] * PI1[0][10][4] + sp[18] * PI1[0][4][10] + sp[17] * PI2[0][10][4];
    A[155] = sp[19] * PI0[0][10][5] + sp[18] * PI1[0][10][5] + sp[18] * PI1[0][5][10] + sp[17] * PI2[0][10][5];
    A[156] = sp[19] * PI0[0][10][6] + sp[18] * PI1[0][10][6] + sp[18] * PI1[0][6][10] + sp[17] * PI2[0][10][6];
    A[157] = sp[19] * PI0[0][10][7] + sp[18] * PI1[0][10][7] + sp[18] * PI1[0][7][10] + sp[17] * PI2[0][10][7];
    A[158] = sp[19] * PI0[0][10][8] + sp[18] * PI1[0][10][8] + sp[18] * PI1[0][8][10] + sp[17] * PI2[0][10][8];
    A[159] = sp[19] * PI0[0][10][9] + sp[18] * PI1[0][10][9] + sp[18] * PI1[0][9][10] + sp[17] * PI2[0][10][9];
    A[160] = sp[19] * PI0[0][10][10] + sp[18] * PI1[0][10][10] + sp[18] * PI1[0][10][10] + sp[17] * PI2[0][10][10];
    A[161] = sp[19] * PI0[0][10][11] + sp[18] * PI1[0][10][11] + sp[18] * PI1[0][11][10] + sp[17] * PI2[0][10][11];
    A[162] = sp[19] * PI0[0][10][12] + sp[18] * PI1[0][10][12] + sp[18] * PI1[0][12][10] + sp[17] * PI2[0][10][12];
    A[163] = sp[19] * PI0[0][10][13] + sp[18] * PI1[0][10][13] + sp[18] * PI1[0][13][10] + sp[17] * PI2[0][10][13];
    A[164] = sp[19] * PI0[0][10][14] + sp[18] * PI1[0][10][14] + sp[18] * PI1[0][14][10] + sp[17] * PI2[0][10][14];
    A[165] = sp[19] * PI0[0][11][0] + sp[18] * PI1[0][11][0] + sp[18] * PI1[0][0][11] + sp[17] * PI2[0][11][0];
    A[166] = sp[19] * PI0[0][11][1] + sp[18] * PI1[0][11][1] + sp[18] * PI1[0][1][11] + sp[17] * PI2[0][11][1];
    A[167] = sp[19] * PI0[0][11][2] + sp[18] * PI1[0][11][2] + sp[18] * PI1[0][2][11] + sp[17] * PI2[0][11][2];
    A[168] = sp[19] * PI0[0][11][3] + sp[18] * PI1[0][11][3] + sp[18] * PI1[0][3][11] + sp[17] * PI2[0][11][3];
    A[169] = sp[19] * PI0[0][11][4] + sp[18] * PI1[0][11][4] + sp[18] * PI1[0][4][11] + sp[17] * PI2[0][11][4];
    A[170] = sp[19] * PI0[0][11][5] + sp[18] * PI1[0][11][5] + sp[18] * PI1[0][5][11] + sp[17] * PI2[0][11][5];
    A[171] = sp[19] * PI0[0][11][6] + sp[18] * PI1[0][11][6] + sp[18] * PI1[0][6][11] + sp[17] * PI2[0][11][6];
    A[172] = sp[19] * PI0[0][11][7] + sp[18] * PI1[0][11][7] + sp[18] * PI1[0][7][11] + sp[17] * PI2[0][11][7];
    A[173] = sp[19] * PI0[0][11][8] + sp[18] * PI1[0][11][8] + sp[18] * PI1[0][8][11] + sp[17] * PI2[0][11][8];
    A[174] = sp[19] * PI0[0][11][9] + sp[18] * PI1[0][11][9] + sp[18] * PI1[0][9][11] + sp[17] * PI2[0][11][9];
    A[175] = sp[19] * PI0[0][11][10] + sp[18] * PI1[0][11][10] + sp[18] * PI1[0][10][11] + sp[17] * PI2[0][11][10];
    A[176] = sp[19] * PI0[0][11][11] + sp[18] * PI1[0][11][11] + sp[18] * PI1[0][11][11] + sp[17] * PI2[0][11][11];
    A[177] = sp[19] * PI0[0][11][12] + sp[18] * PI1[0][11][12] + sp[18] * PI1[0][12][11] + sp[17] * PI2[0][11][12];
    A[178] = sp[19] * PI0[0][11][13] + sp[18] * PI1[0][11][13] + sp[18] * PI1[0][13][11] + sp[17] * PI2[0][11][13];
    A[179] = sp[19] * PI0[0][11][14] + sp[18] * PI1[0][11][14] + sp[18] * PI1[0][14][11] + sp[17] * PI2[0][11][14];
    A[180] = sp[19] * PI0[0][12][0] + sp[18] * PI1[0][12][0] + sp[18] * PI1[0][0][12] + sp[17] * PI2[0][12][0];
    A[181] = sp[19] * PI0[0][12][1] + sp[18] * PI1[0][12][1] + sp[18] * PI1[0][1][12] + sp[17] * PI2[0][12][1];
    A[182] = sp[19] * PI0[0][12][2] + sp[18] * PI1[0][12][2] + sp[18] * PI1[0][2][12] + sp[17] * PI2[0][12][2];
    A[183] = sp[19] * PI0[0][12][3] + sp[18] * PI1[0][12][3] + sp[18] * PI1[0][3][12] + sp[17] * PI2[0][12][3];
    A[184] = sp[19] * PI0[0][12][4] + sp[18] * PI1[0][12][4] + sp[18] * PI1[0][4][12] + sp[17] * PI2[0][12][4];
    A[185] = sp[19] * PI0[0][12][5] + sp[18] * PI1[0][12][5] + sp[18] * PI1[0][5][12] + sp[17] * PI2[0][12][5];
    A[186] = sp[19] * PI0[0][12][6] + sp[18] * PI1[0][12][6] + sp[18] * PI1[0][6][12] + sp[17] * PI2[0][12][6];
    A[187] = sp[19] * PI0[0][12][7] + sp[18] * PI1[0][12][7] + sp[18] * PI1[0][7][12] + sp[17] * PI2[0][12][7];
    A[188] = sp[19] * PI0[0][12][8] + sp[18] * PI1[0][12][8] + sp[18] * PI1[0][8][12] + sp[17] * PI2[0][12][8];
    A[189] = sp[19] * PI0[0][12][9] + sp[18] * PI1[0][12][9] + sp[18] * PI1[0][9][12] + sp[17] * PI2[0][12][9];
    A[190] = sp[19] * PI0[0][12][10] + sp[18] * PI1[0][12][10] + sp[18] * PI1[0][10][12] + sp[17] * PI2[0][12][10];
    A[191] = sp[19] * PI0[0][12][11] + sp[18] * PI1[0][12][11] + sp[18] * PI1[0][11][12] + sp[17] * PI2[0][12][11];
    A[192] = sp[19] * PI0[0][12][12] + sp[18] * PI1[0][12][12] + sp[18] * PI1[0][12][12] + sp[17] * PI2[0][12][12];
    A[193] = sp[19] * PI0[0][12][13] + sp[18] * PI1[0][12][13] + sp[18] * PI1[0][13][12] + sp[17] * PI2[0][12][13];
    A[194] = sp[19] * PI0[0][12][14] + sp[18] * PI1[0][12][14] + sp[18] * PI1[0][14][12] + sp[17] * PI2[0][12][14];
    A[195] = sp[19] * PI0[0][13][0] + sp[18] * PI1[0][13][0] + sp[18] * PI1[0][0][13] + sp[17] * PI2[0][13][0];
    A[196] = sp[19] * PI0[0][13][1] + sp[18] * PI1[0][13][1] + sp[18] * PI1[0][1][13] + sp[17] * PI2[0][13][1];
    A[197] = sp[19] * PI0[0][13][2] + sp[18] * PI1[0][13][2] + sp[18] * PI1[0][2][13] + sp[17] * PI2[0][13][2];
    A[198] = sp[19] * PI0[0][13][3] + sp[18] * PI1[0][13][3] + sp[18] * PI1[0][3][13] + sp[17] * PI2[0][13][3];
    A[199] = sp[19] * PI0[0][13][4] + sp[18] * PI1[0][13][4] + sp[18] * PI1[0][4][13] + sp[17] * PI2[0][13][4];
    A[200] = sp[19] * PI0[0][13][5] + sp[18] * PI1[0][13][5] + sp[18] * PI1[0][5][13] + sp[17] * PI2[0][13][5];
    A[201] = sp[19] * PI0[0][13][6] + sp[18] * PI1[0][13][6] + sp[18] * PI1[0][6][13] + sp[17] * PI2[0][13][6];
    A[202] = sp[19] * PI0[0][13][7] + sp[18] * PI1[0][13][7] + sp[18] * PI1[0][7][13] + sp[17] * PI2[0][13][7];
    A[203] = sp[19] * PI0[0][13][8] + sp[18] * PI1[0][13][8] + sp[18] * PI1[0][8][13] + sp[17] * PI2[0][13][8];
    A[204] = sp[19] * PI0[0][13][9] + sp[18] * PI1[0][13][9] + sp[18] * PI1[0][9][13] + sp[17] * PI2[0][13][9];
    A[205] = sp[19] * PI0[0][13][10] + sp[18] * PI1[0][13][10] + sp[18] * PI1[0][10][13] + sp[17] * PI2[0][13][10];
    A[206] = sp[19] * PI0[0][13][11] + sp[18] * PI1[0][13][11] + sp[18] * PI1[0][11][13] + sp[17] * PI2[0][13][11];
    A[207] = sp[19] * PI0[0][13][12] + sp[18] * PI1[0][13][12] + sp[18] * PI1[0][12][13] + sp[17] * PI2[0][13][12];
    A[208] = sp[19] * PI0[0][13][13] + sp[18] * PI1[0][13][13] + sp[18] * PI1[0][13][13] + sp[17] * PI2[0][13][13];
    A[209] = sp[19] * PI0[0][13][14] + sp[18] * PI1[0][13][14] + sp[18] * PI1[0][14][13] + sp[17] * PI2[0][13][14];
    A[210] = sp[19] * PI0[0][14][0] + sp[18] * PI1[0][14][0] + sp[18] * PI1[0][0][14] + sp[17] * PI2[0][14][0];
    A[211] = sp[19] * PI0[0][14][1] + sp[18] * PI1[0][14][1] + sp[18] * PI1[0][1][14] + sp[17] * PI2[0][14][1];
    A[212] = sp[19] * PI0[0][14][2] + sp[18] * PI1[0][14][2] + sp[18] * PI1[0][2][14] + sp[17] * PI2[0][14][2];
    A[213] = sp[19] * PI0[0][14][3] + sp[18] * PI1[0][14][3] + sp[18] * PI1[0][3][14] + sp[17] * PI2[0][14][3];
    A[214] = sp[19] * PI0[0][14][4] + sp[18] * PI1[0][14][4] + sp[18] * PI1[0][4][14] + sp[17] * PI2[0][14][4];
    A[215] = sp[19] * PI0[0][14][5] + sp[18] * PI1[0][14][5] + sp[18] * PI1[0][5][14] + sp[17] * PI2[0][14][5];
    A[216] = sp[19] * PI0[0][14][6] + sp[18] * PI1[0][14][6] + sp[18] * PI1[0][6][14] + sp[17] * PI2[0][14][6];
    A[217] = sp[19] * PI0[0][14][7] + sp[18] * PI1[0][14][7] + sp[18] * PI1[0][7][14] + sp[17] * PI2[0][14][7];
    A[218] = sp[19] * PI0[0][14][8] + sp[18] * PI1[0][14][8] + sp[18] * PI1[0][8][14] + sp[17] * PI2[0][14][8];
    A[219] = sp[19] * PI0[0][14][9] + sp[18] * PI1[0][14][9] + sp[18] * PI1[0][9][14] + sp[17] * PI2[0][14][9];
    A[220] = sp[19] * PI0[0][14][10] + sp[18] * PI1[0][14][10] + sp[18] * PI1[0][10][14] + sp[17] * PI2[0][14][10];
    A[221] = sp[19] * PI0[0][14][11] + sp[18] * PI1[0][14][11] + sp[18] * PI1[0][11][14] + sp[17] * PI2[0][14][11];
    A[222] = sp[19] * PI0[0][14][12] + sp[18] * PI1[0][14][12] + sp[18] * PI1[0][12][14] + sp[17] * PI2[0][14][12];
    A[223] = sp[19] * PI0[0][14][13] + sp[18] * PI1[0][14][13] + sp[18] * PI1[0][13][14] + sp[17] * PI2[0][14][13];
    A[224] = sp[19] * PI0[0][14][14] + sp[18] * PI1[0][14][14] + sp[18] * PI1[0][14][14] + sp[17] * PI2[0][14][14];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f73909de61c7a584972308ec948cee2299c4122dad45668967747d44c6ce516601cdfd142f5b6360ed154254d5bea9a4e3611c10e94363e563535029705adcee";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "cf03543d81a8e3c872e762cb0952a22f306c14fc3d1e17af7ee979d98d16f96a16b33af01c29b918dd9d99e71e0450ba5b0dbc734baaf9f881f8778c54173636";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
